function Comments(pViewInstance, pReturnFn) {
	var iView = pViewInstance;
	var iData = null;
	var bLoading = false; 
	
	var iCommentInnerLoading = new innerLoading({
		id : "CommentInnerLoading"
		, container : _$("facebookFreeDiv1")
		, left : 720
		, top : 252
	});
	
	var nCurrentFocusIdx = 0;
	var nCurrentPageItems = 0;

	// 1 Based
	var nTotalItems = 0;
	var nTotalPages = 0;
	var nCurPage = 1;	
	var nItemsPerPage = 4;
	
	var arrCommentsData = null;

	var returnFn = pReturnFn;

	this.open = function() {
		iView.show();
		if (bLoading && !returnFn(StreamVideoDetail.Define.ON_GLOBAL_LOADING)) 
			iCommentInnerLoading.open();
	}

	this.close = function() {
		iView.hide();
		iCommentInnerLoading.close();
	}
	
	this.request = function(pPostID, pIDType) {
		iData = new CommentsData(pPostID, pIDType);
		iView.clear();
		bLoading = true;
		if (!returnFn(StreamVideoDetail.Define.ON_GLOBAL_LOADING)) 
			iCommentInnerLoading.open();
		iData.request(function(pComments) {
			commentsOnComplete(pComments);
			bLoading = false;
			if (!returnFn(StreamVideoDetail.Define.OFF_GLOBAL_LOADING)) 
				iCommentInnerLoading.close();
		});
		iView.show();
	}
	
	this.eventHandler = function(pEvent) {
		switch(pEvent) {
			case GMFPlayer.Event.EndDrawLoading :
				iView.loading();
				break;
			default:
				break;
		}
	}
	
	this.isLoading = function() {
		return bLoading;
	}
	
	function commentsOnComplete(pComments) {
		// Calculate pages
		arrCommentsData = pComments;
		nTotalItems = arrCommentsData.length;
		nTotalPages = Math.floor((nTotalItems - 1) / nItemsPerPage) + 1;

		updateView();
		
		// Notify total comments pages to parent object
		returnFn(Facebook.Define.Update, {
			nPage : nTotalPages,
			nItem : nTotalItems
		});
	}
	
	function updateView() {
		var arguComments = [];
		var nStartIdx = (nCurPage-1)*nItemsPerPage;
		var nLastIdx = (nCurPage*nItemsPerPage < nTotalItems) ? nCurPage*nItemsPerPage : nTotalItems;

		for (commentsIdx = nStartIdx; commentsIdx < nLastIdx; commentsIdx++) {
			arguComments.push(arrCommentsData[commentsIdx]);
		}
		iView.update(arguComments, nCurPage, nTotalPages);
	}
	
	this.next = function() {
		nCurPage = (nCurPage < nTotalPages) ? nCurPage + 1 : 1;
		updateView();
	}
	
	this.prev = function() {
		nCurPage = (nCurPage > 1) ? nCurPage -1 : nTotalPages;
		updateView();		
	}
	
	this.refresh = function() {
		if (!bLoading)
			updateView();
	}
	
	this.openLoading = iCommentInnerLoading.open;
}
