function CommentsFull(pViewInstance, pReturnFn) {
	var _this_ = this;
	var returnFn = pReturnFn;
	var comment = null;
	
	var iView = pViewInstance;

	var instanceState = Facebook.Define.None;
	var canDelete = false;
	
	this.open = function(pComment, pDelete) {
		comment = pComment;
		canDelete = pDelete;
        Instance.Main.setKeyHandler(keyHandler, "CommentsFull");
		iView.show();
		iView.update(pComment, pDelete);
	}
	
	this.close = function() {
		iView.clear();
		iView.hide();
	}
	
	function keyHandler(pKeyCode){
		if (instanceState == Facebook.Define.Processing) {
			FBTrace("CommentsFull : Processing (Block Key Event)");
			return;
		}
		switch (pKeyCode) {
			case TV.KEY_RIGHT:
			case TV.KEY_PANEL_VOL_DOWN:
				break;
			case TV.KEY_LEFT:
			case TV.KEY_PANEL_VOL_UP:
				break;
			case TV.KEY_UP:
			case TV.KEY_WHEELUP:
			case TV.KEY_PANEL_CH_UP:
				iView.scrollUp();
				break;
			case TV.KEY_DOWN:
			case TV.KEY_WHEELDOWN:
			case TV.KEY_PANEL_CH_DOWN:
				iView.scrollDown();
				break;
			case TV.KEY_ENTER:
				break;
			case TV.KEY_BLUE:
				_this_.close();
				returnFn(Facebook.Define.Close);
				Instance.Frame.open(comment.fromid, Facebook.Define.Menu.WALL);
				break;			
			case TV.KEY_RETURN:
				returnPrevious(Facebook.Define.Return);
				break;				
			default:
				break;
		}
	}

	function returnPrevious(pReturn){
		FBTrace("CommentsFull :: returnPrevious");
		instanceState = Facebook.Define.None;
		switch(pReturn) {
			case Facebook.Define.Yes : 
				// Delete comments
				_this_.close();
		        returnFn(Facebook.Define.Delete, comment.id);			
				break;
			case Facebook.Define.No :
				// Cancel deleting comments
				Instance.Main.setKeyHandler(keyHandler, "CommentsFull");
				iView.show();
				break;
			case Facebook.Define.Return :
				_this_.close();
		        returnFn();
				break;
			default :
				iView.show();
				break;
		}
    }
}
