function Menu(pObjUI, pObjMenuItems, pInitFocusID, pEventListner){
    var objFullMenu = pObjMenuItems;
	var initFocusID = pInitFocusID;
    var iView = pObjUI;
    
    var arrMenuReference = [];	// [{ id,type,position(,instance) }];

    var curFocusIdx = 1;
	var nCurPage = 0;
	var nTotalPage = 0;
	
    // Add "expanded" property to Category
    initMenu(objFullMenu);
	refreshMenu();
	
    this.show = function(){
		iView.show();
//        refreshMenu();
    }
	
    this.hide = function(){
		iView.hide();
    }
	
	this.shortCut = function(pShortCut) {
		instanceEnter(arrMenuReference[nCurPage][curFocusIdx].instance, {
			data : pShortCut
			, callback : function() {
				iView.select(arrMenuReference[nCurPage][curFocusIdx].id);
			}
		})
	}
	
    this.Replace = function(pParentID, pChildren){
		
		recurFindItem(objFullMenu.items, pParentID, pChildren);
		iView.update(getMenuPage(),nCurPage,nTotalPage);

        if (iView.isFocused()) 
            iView.focus(arrMenuReference[nCurPage][curFocusIdx].id);
		
		function recurFindItem(pObjMenu, pParentID, pChildren) {
			var currentItemLength = pObjMenu.length;
			for (var itemIdx = 0; itemIdx < currentItemLength; itemIdx++) {
				if (pObjMenu[itemIdx].id == pParentID) {
					pObjMenu[itemIdx].items = pChildren;
					return true;
				} else {
					if (pObjMenu[itemIdx].items instanceof Array) {
						recurFindItem(pObjMenu[itemIdx].items, pParentID, pChildren);
					}
				}
			}
		}
    }
	
    function refreshMenu(){
        iView.update(controlSubmenuForID(initFocusID),nCurPage,nTotalPage);
        iView.focus(arrMenuReference[nCurPage][curFocusIdx].id);
		instanceOpen(arrMenuReference[nCurPage][curFocusIdx].instance, arrMenuReference[nCurPage][curFocusIdx].params);
    }

    // Add "expanded" property to Category
    function initMenu(pObjMenuItems){
        var tempArrLength = pObjMenuItems.items.length;
        for (var index = 0; index < tempArrLength; index++) {
            if (pObjMenuItems.items[index].items) {
				if (pObjMenuItems.items[index].expanded && pObjMenuItems.items[index].expanded == true) {
					pObjMenuItems.items[index].expanded = true;
				} else {
					pObjMenuItems.items[index].expanded = false;
				}
                pObjMenuItems.items[index].type = Facebook.Define.MenuType.CATEGORY;
                initMenu(pObjMenuItems.items[index]);
            }
            else {
                pObjMenuItems.items[index].type = Facebook.Define.MenuType.ITEM;
            }
        }
    }

    var arrCurPosition = [];

    // Get menu array
    function getMenu(){
        var arrCurrentMenu = [];
        var nPage = 0;
		arrCurrentMenu[0] = [];
		arrMenuReference = [];
		arrMenuReference[0] = [];
        arrCurPosition = [];
		
		var arrMenuObject = generateMenu(arrCurrentMenu, objFullMenu);
		nTotalPage = arrMenuObject.length;
        return arrMenuObject[nCurPage];
		
		function generateMenu(pArrMenuList, pObjMenuItems){
	        var tempArrLength = pObjMenuItems.items.length;
			for (var index = 0; index < tempArrLength; index++) {
	            if (pObjMenuItems.items[index].items) {
					putCategory(index, [index], pObjMenuItems.items[index], pArrMenuList[nPage]);
					if (pObjMenuItems.items[index].expanded) {
						// In case having sub menu
						var nLength = pObjMenuItems.items[index].items.length;
						pArrMenuList[nPage][pArrMenuList[nPage].length-1].items = [];
						for (var idx = 0; idx < nLength; idx++) {
							//putItem(index, 0, pObjMenuItems.items[index].items[idx], pArrMenuList[nPage][pArrMenuList[nPage].length - 1].items);
							putItem(index, [index,idx], pObjMenuItems.items[index].items[idx], pArrMenuList[nPage]);
						}
					}
				}
				else {
					putItem(index, [index], pObjMenuItems.items[index], pArrMenuList[nPage]);
				}
	        }
			
			return pArrMenuList;
			
			function makeNewMenuPage() {
				nPage++;
				pArrMenuList[nPage] = [];
				arrMenuReference[nPage] = [];
			}
			
			function putItem(pIndex, pDepth, pSubmenu, pNode) {
				// Item
				arrMenuReference[nPage].push({
					id: pSubmenu.id
					, type: Facebook.Define.MenuType.ITEM
					, instance: pSubmenu.instance
					, params: pSubmenu.params
					, option : pSubmenu.option ? pSubmenu.option : null
					, position: Util.copyArray(pDepth)
				});
				pNode.push({
					id: pSubmenu.id
					, caption: pSubmenu.caption
					, icon: pSubmenu.icon
					, type : Facebook.Define.MenuType.ITEM
				});
				if (pNode.length > 10) makeNewMenuPage();
			}
			
			function putCategory(pIndex, pDepth, pCategory, pNode) {
				arrMenuReference[nPage].push({
					id: pCategory.id
					, type: Facebook.Define.MenuType.CATEGORY
					, instance: pCategory.instance
					, params: pCategory.params
					, option : pCategory.option ? pCategory.option : null
					, position: Util.copyArray(pDepth)
					, expanded: pCategory.expanded
				});
				pNode.push({
					id: pCategory.id
					, caption:pCategory.caption
					, icon: pCategory.icon
					, type : Facebook.Define.MenuType.CATEGORY
				});
				if (pNode.length > 10) makeNewMenuPage();
			}
	    }
    }

    function controlSubmenu(pItemIdx){
        var itemPosition = arrMenuReference[nCurPage][pItemIdx].position;
		var itemID = arrMenuReference[nCurPage][pItemIdx].id;
        
        var itemDepth = itemPosition.length;
       
        // Find all items at current depth in full menu object
        var itemCategory = objFullMenu.items;
	    for (var depthIdx = 0; depthIdx < itemDepth - 1; depthIdx++) {
            itemCategory = itemCategory[itemPosition[depthIdx]].items;
        }
		
        if (itemCategory[itemPosition[itemDepth - 1]].expanded) {
            itemCategory[itemPosition[itemDepth - 1]].expanded = false;
        }
        else {
            for (var index = 0; index < itemCategory.length; index++) {
                itemCategory[index].expanded = (itemPosition[itemDepth - 1] == index) ? true : false;
            }
        }
		
        var retArray = getMenu();
        curFocusIdx = findIndex(itemID);
		
        return retArray;
    }

	function getMenuPage() {
		 return getMenu();
	}

    function controlSubmenuForID(pItemID){
		// All parent category for target item
		var arrCategory = [];
		recurFindItem(objFullMenu.items, arrCategory);
        var retArray = getMenu();
        curFocusIdx = findIndex(pItemID);
        return retArray;

		function recurFindItem(pObjMenu, pArrCategory) {
			var currentItemLength = pObjMenu.length;
			for (var itemIdx = 0; itemIdx < currentItemLength; itemIdx++) {
				if (pObjMenu[itemIdx].items instanceof Array) {
					// Category
					pArrCategory.push(pObjMenu[itemIdx]);
					if(recurFindItem(pObjMenu[itemIdx].items, pArrCategory)) {
						return;
					}
					pArrCategory[pArrCategory.length-1].expanded = false;
					pArrCategory.pop();
				} else {
					// Item
					if (pObjMenu[itemIdx].id == pItemID) {
						// Find target Item
						var depthLength = pArrCategory.length;
						for (var depthIdx = 0; depthIdx < depthLength; depthIdx++) {
							pArrCategory[depthIdx].expanded = true;
							return true;
						}
					}
				}
			}
		}
    }

    function findIndex(pID){
        var arrLength = arrMenuReference[nCurPage].length;
        for (var index = 0; index < arrLength; index++) {
            if (arrMenuReference[nCurPage][index].id == pID) 
                return index;
        }
		// In case no such id, search in full menu object
        iView.blur(arrMenuReference[nCurPage][curFocusIdx].id);
        iView.update(controlSubmenuForID(pID),nCurPage,nTotalPage);
        iView.focus(arrMenuReference[nCurPage][curFocusIdx].id);
		return index;
    }
	
	this.focus = function() {
		iView.focus(arrMenuReference[nCurPage][curFocusIdx].id);
	}
	
    this.up = function(){
		iRemoteFB.hidePopup();		
        iView.blur(arrMenuReference[nCurPage][curFocusIdx].id);
		var oldInstance = arrMenuReference[nCurPage][curFocusIdx].instance;
		var oldOption = arrMenuReference[nCurPage][curFocusIdx].option;
		if (curFocusIdx > 0) {
			curFocusIdx = curFocusIdx - 1;
		} else {
			nCurPage = nCurPage  > 0 ? nCurPage - 1 : nTotalPage - 1;
			curFocusIdx = arrMenuReference[nCurPage].length - 1;
			iView.update(getMenuPage(),nCurPage,nTotalPage);
		}
		var newInstance = arrMenuReference[nCurPage][curFocusIdx].instance;
		var newOption = arrMenuReference[nCurPage][curFocusIdx].option;
		if (oldInstance != newInstance || oldOption != newOption) {
			instanceClose(oldInstance);
			instanceOpen(newInstance, arrMenuReference[nCurPage][curFocusIdx].params, arrMenuReference[nCurPage][curFocusIdx].option);
		}
		iView.focus(arrMenuReference[nCurPage][curFocusIdx].id);
		if (arrMenuReference[nCurPage][curFocusIdx].id == Facebook.Define.Menu.HOME || arrMenuReference[nCurPage][curFocusIdx].id == Facebook.Define.Menu.REQUEST) {
			iRemoteFB.onLoadHome();
		}
		else if (arrMenuReference[nCurPage][curFocusIdx].id == Facebook.Define.Menu.PROFILE || arrMenuReference[nCurPage][curFocusIdx].id == Facebook.Define.Menu.VIDEOS) {
			iRemoteFB.onLoadProfile();
		}
		else if (arrMenuReference[nCurPage][curFocusIdx].id == Facebook.Define.Menu.FRIENDS || arrMenuReference[nCurPage][curFocusIdx].id > 100) {
			iRemoteFB.onLoadFriends(GroupListNames);
		}					
    }
    
    this.down = function(){
		iRemoteFB.hidePopup();
        iView.blur(arrMenuReference[nCurPage][curFocusIdx].id);
		var oldInstance = arrMenuReference[nCurPage][curFocusIdx].instance;
		var oldOption = arrMenuReference[nCurPage][curFocusIdx].option;
		if (curFocusIdx < arrMenuReference[nCurPage].length - 1) {
			curFocusIdx = curFocusIdx + 1;
		} else {
			nCurPage = nCurPage + 1 < nTotalPage ? nCurPage + 1 : 0;
			
			curFocusIdx = 0;
			iView.update(getMenuPage(),nCurPage,nTotalPage);
		}
		var newInstance = arrMenuReference[nCurPage][curFocusIdx].instance;
		var newOption = arrMenuReference[nCurPage][curFocusIdx].option;
		if (oldInstance != newInstance || oldOption != newOption) {
			instanceClose(oldInstance);
			instanceOpen(newInstance, arrMenuReference[nCurPage][curFocusIdx].params, arrMenuReference[nCurPage][curFocusIdx].option);
		}
		iView.focus(arrMenuReference[nCurPage][curFocusIdx].id);
		if (arrMenuReference[nCurPage][curFocusIdx].id == Facebook.Define.Menu.HOME) {
			iRemoteFB.onLoadHome();
		}
		else if (arrMenuReference[nCurPage][curFocusIdx].id == Facebook.Define.Menu.PROFILE) {
			iRemoteFB.onLoadProfile();
		}
		else if (arrMenuReference[nCurPage][curFocusIdx].id == Facebook.Define.Menu.FRIENDS) {
			iRemoteFB.onLoadFriends(GroupListNames);
		}	
    }
	
	  this.showProfile= function(subMenuindex){    
		var itemCategory = objFullMenu.items;
		if(itemCategory[1] && !itemCategory[1].expanded){
			var  selectedindex = 0;    
		   for (var index = 0; index < itemCategory.length; index++) {               
				if(itemCategory[index].expanded ){
					var catItem = itemCategory[index].items;
					var catID = itemCategory[index].id;                   
					if(catID == Facebook.Define.Menu.HOME){
						selectedindex = catItem.length+1;
					}
					else if (catID ==Facebook.Define.Menu.FRIENDS){
						selectedindex =1;
					}
					  
				}
			}           
			this.highLight(selectedindex);
		}
		else{
			if(subMenuindex != -1){
				this.highLight(subMenuindex);
			}
		}
		if (arrMenuReference[nCurPage][curFocusIdx].type != Facebook.Define.MenuType.CATEGORY) {
			if(instanceEnter(arrMenuReference[nCurPage][curFocusIdx].instance)) {
				iRemoteFB.menuFlag = 0;
				iView.select(arrMenuReference[nCurPage][curFocusIdx].id);
				if(arrMenuReference[nCurPage][curFocusIdx].id == Facebook.Define.Menu.PHOTOS){
					iRemoteFB.profilePhoto(iRemoteFB.GlobalPhotoList, iRemoteFB.GlobalPageNum);
				}
				else if(arrMenuReference[nCurPage][curFocusIdx].id == Facebook.Define.Menu.INFO){
					iRemoteFB.infoPage(iRemoteFB.globalInfo);  
				}
				else if(arrMenuReference[nCurPage][curFocusIdx].id == Facebook.Define.Menu.VIDEOS){					
					iRemoteFB.showProfileDetailsVideos(iRemoteFB.ProfileVideoList);					
				}
				else if(arrMenuReference[nCurPage][curFocusIdx].id == Facebook.Define.Menu.WALL){					
            		iRemoteFB.showWall(NewsFeedArray, 13);
				}				
			}
		}
    }    
    /* Start Interactive Device */ 
	this.showFriends= function(subMenuindex){
		var itemCategory = objFullMenu.items;
		if(!itemCategory[2].expanded){ 
			if (curFocusIdx < arrMenuReference[nCurPage].length - 1) {
				var  selectedindex = 0;       
				for (var index = 0; index < itemCategory.length; index++) {               
					if(itemCategory[index].expanded ){
						var catItem = itemCategory[index].items;
						var catID = itemCategory[index].id;               
						if(catID == Facebook.Define.Menu.HOME){
							selectedindex = catItem.length+2;
						}	
						else if (catID ==Facebook.Define.Menu.PROFILE){
							selectedindex = catItem.length+2;
						}                     
					}
				}
			}     
			this.highLight(selectedindex);
		}
		else{
			if(subMenuindex != -1){
				this.highLight(subMenuindex);
			}        
        }
		if (arrMenuReference[nCurPage][curFocusIdx].type != Facebook.Define.MenuType.CATEGORY) {
			if (instanceEnter(arrMenuReference[nCurPage][curFocusIdx].instance)) {
				iRemoteFB.menuFlag = 0;
				iView.select(arrMenuReference[nCurPage][curFocusIdx].id);
				iRemoteFB.FriendList(FriendsArray);
			}
		}
    } 
    
    this.showHome= function(subMenuindex){
		var itemCategory = objFullMenu.items;		
		if(!itemCategory[0].expanded  && subMenuindex==-1){ 		
			var  selectedindex = 0;
			for (var index = 0; index < itemCategory.length; index++) {
				if(itemCategory[index].expanded ){
					var catItem = itemCategory[index].items;
					var catID = itemCategory[index].id;
					if(catID == Facebook.Define.Menu.PROFILE){
						selectedindex = 0;
					}
					else if (catID ==Facebook.Define.Menu.FRIENDS){
						selectedindex =0;
					}
					  
				}
			}
			this.highLight(selectedindex);
		}
		else{
			if(subMenuindex != -1){		   
				this.highLight(subMenuindex);
			}
		}
		if(arrMenuReference[nCurPage][curFocusIdx].type != Facebook.Define.MenuType.CATEGORY){
			if(instanceEnter(arrMenuReference[nCurPage][curFocusIdx].instance)){
				iRemoteFB.menuFlag = 0;
				iView.select(arrMenuReference[nCurPage][curFocusIdx].id);
				if(arrMenuReference[nCurPage][curFocusIdx].id == Facebook.Define.Menu.NEWS_FEED){					
            		iRemoteFB.showNews(NewsFeedArray, 12);
				}
				else if(arrMenuReference[nCurPage][curFocusIdx].id == Facebook.Define.Menu.HOME_PHOTOS){					
            		iRemoteFB.onLoadPhotos(NewsFeedArray);
				}
				else if(arrMenuReference[nCurPage][curFocusIdx].id == Facebook.Define.Menu.HOME_STATUS){					
            		iRemoteFB.onLoadStatusUpdate(NewsFeedArray);
				}
				else if(arrMenuReference[nCurPage][curFocusIdx].id == Facebook.Define.Menu.HOME_VIDEOS){					
            		iRemoteFB.onLoadVidoes(NewsFeedArray);
				}				
			}
		}
    }
	/* End Interactive Device */
    this.close = function(){
		instanceClose(arrMenuReference[nCurPage][curFocusIdx].instance);
    }
	
	this.go = function(pFocusID) {
		var oldInstance = arrMenuReference[nCurPage][curFocusIdx].instance;
		iView.update(controlSubmenuForID(pFocusID),nCurPage,nTotalPage);
		var newInstance = arrMenuReference[nCurPage][curFocusIdx].instance;
		if (oldInstance != newInstance || arrMenuReference[nCurPage][curFocusIdx].option) {
			instanceClose(oldInstance);
			instanceOpen(newInstance, arrMenuReference[nCurPage][curFocusIdx].params);
		}
		 iView.focus(arrMenuReference[nCurPage][curFocusIdx].id);
	}	
	
    this.enter = function(){
        // If current focused item is category type, expand sub menu
        if (arrMenuReference[nCurPage][curFocusIdx].type == Facebook.Define.MenuType.CATEGORY) {
			if (!arrMenuReference[nCurPage][curFocusIdx].expanded) {
				iView.blur(arrMenuReference[nCurPage][curFocusIdx].id);
				iView.update(controlSubmenu(curFocusIdx),nCurPage,nTotalPage);
				iView.focus(arrMenuReference[nCurPage][curFocusIdx].id);
			}
			this.down();
        }
        else {			 								
			if(instanceEnter(arrMenuReference[nCurPage][curFocusIdx].instance)) {
				iView.select(arrMenuReference[nCurPage][curFocusIdx].id);
				/* Start Interactive Device */
				if(arrMenuReference[nCurPage][curFocusIdx].id == Facebook.Define.Menu.PHOTOS){
					iRemoteFB.profilePhoto(iRemoteFB.GlobalPhotoList, iRemoteFB.GlobalPageNum);
				}
				else if(arrMenuReference[nCurPage][curFocusIdx].id == Facebook.Define.Menu.INFO){					
					iRemoteFB.infoPage(iRemoteFB.globalInfo);  
				}
				else if(arrMenuReference[nCurPage][curFocusIdx].id == Facebook.Define.Menu.VIDEOS){					
					iRemoteFB.showProfileDetailsVideos(iRemoteFB.ProfileVideoList);					
				}
				else if(arrMenuReference[nCurPage][curFocusIdx].id == Facebook.Define.Menu.REQUEST){					
            		iRemoteFB.friendRequest(iRemoteFB.requestObj);
				}
				else if(arrMenuReference[nCurPage][curFocusIdx].id == Facebook.Define.Menu.NEWS_FEED){					
            		iRemoteFB.showNews(NewsFeedArray, 12);
				}
				else if(arrMenuReference[nCurPage][curFocusIdx].id == Facebook.Define.Menu.WALL){					
            		iRemoteFB.showWall(NewsFeedArray, 13);
				}
				else if(arrMenuReference[nCurPage][curFocusIdx].id == Facebook.Define.Menu.HOME_PHOTOS){					
            		iRemoteFB.onLoadPhotos(NewsFeedArray);
				}
				else if(arrMenuReference[nCurPage][curFocusIdx].id == Facebook.Define.Menu.HOME_STATUS){					
            		iRemoteFB.onLoadStatusUpdate(NewsFeedArray);
				}
				else if(arrMenuReference[nCurPage][curFocusIdx].id == Facebook.Define.Menu.HOME_VIDEOS){					
            		iRemoteFB.onLoadVidoes(NewsFeedArray);
				}
				else {
					iRemoteFB.FriendList(FriendsArray);
				}
				
			}		
			else{
				if (arrMenuReference[nCurPage][curFocusIdx].id == Facebook.Define.Menu.INFO) {
					iRemoteFB.infoPage(iRemoteFB.globalInfo);
				}
			}
			/* End Interactive Device */
        }
    }
	/* Start Interactive Device */
	this.Profileenter = function(){
        var itemCategory = objFullMenu.items;
		for (var index = 0; index < itemCategory.length; index++) {             
            if(itemCategory[index].expanded ){
				alert("Index of opened menu "+index);
            }
        }      
       var itemCategory = objFullMenu.items;
		if(!itemCategory[1].expanded){         
			if (!arrMenuReference[nCurPage][curFocusIdx].expanded) {
				iView.blur(arrMenuReference[nCurPage][curFocusIdx].id);
				iView.update(controlSubmenu(curFocusIdx),nCurPage,nTotalPage);
				iView.focus(arrMenuReference[nCurPage][curFocusIdx].id);
			}
			this.down();
        }     
	}
	
	this.Friendenter = function(){       
       var itemCategory = objFullMenu.items;
       if(!itemCategory[2].expanded){        
			if (arrMenuReference[nCurPage][curFocusIdx].type == Facebook.Define.MenuType.CATEGORY) {
				if (!arrMenuReference[nCurPage][curFocusIdx].expanded) {     
					iView.blur(arrMenuReference[nCurPage][curFocusIdx].id);
					iView.update(controlSubmenu(curFocusIdx),nCurPage,nTotalPage);
					iView.focus(arrMenuReference[nCurPage][curFocusIdx].id);
				}
				this.down();
			}
			else {
				if(instanceEnter(arrMenuReference[nCurPage][curFocusIdx].instance)) {
					iView.select(arrMenuReference[nCurPage][curFocusIdx].id);
				}
			}      
		}        
    }

	 this.Homeenter = function(subMenuindex){
        var itemCategory = objFullMenu.items;
		for (var index = 0; index < itemCategory.length; index++) {
			if(itemCategory[index].expanded ){
				alert("Index of opened menu "+index);
			}
		}
      
        var itemCategory = objFullMenu.items;
		if(!itemCategory[0].expanded){ 
			if (!arrMenuReference[nCurPage][curFocusIdx].expanded) {
				iView.blur(arrMenuReference[nCurPage][curFocusIdx].id);
				iView.update(controlSubmenu(curFocusIdx),nCurPage,nTotalPage);
				iView.focus(arrMenuReference[nCurPage][curFocusIdx].id);
			}
			this.down();
        }   
    }

	this.highLight = function(selectedIndex){
		iView.blur(arrMenuReference[nCurPage][curFocusIdx].id);
		var oldInstance = arrMenuReference[nCurPage][curFocusIdx].instance;
		var oldOption = arrMenuReference[nCurPage][curFocusIdx].option;        
        curFocusIdx = selectedIndex;   
		var newInstance = arrMenuReference[nCurPage][curFocusIdx].instance;
		var newOption = arrMenuReference[nCurPage][curFocusIdx].option;
        MenuMovementFlag = 0;
		if (oldInstance != newInstance || oldOption != newOption) {
		    MenuMovementFlag = 1;
			instanceClose(oldInstance);
			instanceOpen(newInstance, arrMenuReference[nCurPage][curFocusIdx].params, arrMenuReference[nCurPage][curFocusIdx].option);
		}
		iView.focus(arrMenuReference[nCurPage][curFocusIdx].id);
	}
	/* End Interactive Device */
	this.back = function() {
        if (arrMenuReference[nCurPage][curFocusIdx].type == Facebook.Define.MenuType.CATEGORY) {
             /* Start Interactive Device */
			 iRemoteFB.showwallFlag = 0;
             /* End Interactive Device */
			// True means escape from current frame
			return true;
        }
        else {
			
			if(Instance.Frame.getType() == FacebookFrame.Define.ME){
             /* Start Interactive Device */
            	if(iRemoteFB.HomeFlag == 1){
					iRemoteFB.onLoadHome();
				}else if(iRemoteFB.ProfileFlag == 1){
					iRemoteFB.onLoadProfile();
				}else if(iRemoteFB.FriendFlag == 1){
					iRemoteFB.onLoadFriends(GroupListNames);
				}
                 /* End Interactive Device */
			}
			if(arrMenuReference[nCurPage][curFocusIdx].id == Facebook.Define.Menu.INFO && !iRemoteFB.bReadyFlag){
				iRemoteFB.onLoadFacebook();
				iRemoteFB.onLoadProfile();
			}
			for (var idx = curFocusIdx - 1; idx > -1; idx--) {
				if (arrMenuReference[nCurPage][idx].type == Facebook.Define.MenuType.CATEGORY) break;
			}
	        iView.blur(arrMenuReference[nCurPage][curFocusIdx].id);
			var oldInstance = arrMenuReference[nCurPage][curFocusIdx].instance;
			var oldOption = arrMenuReference[nCurPage][curFocusIdx].option;
	        curFocusIdx = idx;
			var newInstance = arrMenuReference[nCurPage][curFocusIdx].instance;
			var newOption = arrMenuReference[nCurPage][curFocusIdx].option;
			if (oldInstance != newInstance || oldOption != newOption) {
				instanceClose(oldInstance);
				instanceOpen(newInstance, arrMenuReference[nCurPage][curFocusIdx].params);
			}
	        iView.focus(arrMenuReference[nCurPage][curFocusIdx].id);
        }		
	}
	
	this.right = function() {
        if (arrMenuReference[nCurPage][curFocusIdx].type == Facebook.Define.MenuType.CATEGORY && curFocusIdx < (arrMenuReference[nCurPage].length - 1) && arrMenuReference[nCurPage][curFocusIdx+1].type == Facebook.Define.MenuType.ITEM) {
            this.down();
        }
        else {
			this.enter();
        }
	}
	
	function focusReturnFn() {
		iView.focus(arrMenuReference[nCurPage][curFocusIdx].id);
		pEventListner();
	}
	
	function instanceOpen(pInstance, pParams, pOption) {
		if (pInstance && pInstance.open instanceof Function) {
			if (!pInstance.isOpened()) {
				pInstance.open(pParams ? pParams : null, pOption ? pOption : null);
			}
		}
	}
	
	function instanceClose(pInstance) {
		if (pInstance && pInstance.close instanceof Function) {
			pInstance.close();
		}		
	}
	
	function instanceEnter(pInstance, pShortCut) {
		if (pShortCut) {
			pInstance.enter(focusReturnFn, pShortCut);
			return false;
		}
		if (pInstance && pInstance.enter instanceof Function && pInstance.isReady()) {
			pInstance.enter(focusReturnFn);
			return true;
		} else {
			return false;
		}		
	}
}
