function Popup(pViewInstance) {
	var _this_ = this;
	
	var iView = pViewInstance;
	var returnFn = null;
	
	var objPages = [];
	
	var nRow = 1, nCol = 1;
	var iFocus = null;
	
	var popupTimer = null;
	var POPUP_IDLE_TIME = 5 * 1000;
	var nIdleTime = 0;
	
	// External Interface
	this.close = function(pReturn) {
		// Clear timeout when this popup is closed
		iRemoteFB.hidePopup();
		if (popupTimer) clearTimeout(popupTimer);
		
		iView.blur(iFocus.getFocus());
		iView.clear();
		iView.hide();
		Instance.Main.restoreKeyHandler();
		if (pReturn != Facebook.Define.Cancel) {
			returnFn(objPages[iFocus.getFocus().page][iFocus.getFocus().row][iFocus.getFocus().col].value);
		} else {
			returnFn(false);
		}
	}
	
	this.enter = function(pData, pReturnFn) {
		Instance.Loading.close();
		
		iRemoteFB.hideLoading();
		nIdleTime = pData.idleSec ? (pData.idleSec * 1000) : POPUP_IDLE_TIME;
		
		returnFn = pReturnFn;
		nCol = pData.buttons.length;
		iFocus = new FocusMapper("Popup",nRow, nCol);
		Instance.Main.setKeyHandler(keyHandler,"Popup");
		generatePage(pData);
		iFocus.generate(objPages);
		iView.show();
		iView.request(objPages,iFocus);
		
		// focus button location
		var focusLocation = (pData.focus === undefined) ? 0 : pData.focus;
		while (focusLocation-- > 0) {
			iFocus.right();
		}
		
		iView.focus(iFocus.getFocus());
		
		popupTimer = setTimeout(function(){
			_this_.close(Facebook.Define.Cancel);
		},nIdleTime);
	}
	
	function generatePage(pData) {
		objPages[0] = [];
		var rowData = [];
		for (var buttonIdx = 0; buttonIdx < nCol; buttonIdx++) {
			rowData.push(pData.buttons[buttonIdx]);
		}
		objPages[0].push(rowData);
		objPages[0].push(pData.title);
		objPages[0].push(pData.message);
	}
	
	function keyHandler(pKeyCode) {
		
		if (popupTimer) clearTimeout(popupTimer);
		popupTimer = setTimeout(function(){
			_this_.close(Facebook.Define.Cancel);
		},nIdleTime);
		
		switch(pKeyCode) {
			case TV.KEY_RIGHT :
			case TV.KEY_PANEL_VOL_DOWN :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.right()) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_LEFT :
			case TV.KEY_PANEL_VOL_UP :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.left()) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				} 
				break;
			case TV.KEY_UP :
			case TV.KEY_WHEELUP :
			case TV.KEY_PANEL_CH_UP :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.up()) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_DOWN :
			case TV.KEY_WHEELDOWN :
			case TV.KEY_PANEL_CH_DOWN :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.down()) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_FF :
				if (iFocus.nextPage(true)) {
					requestPage(iFocus.getFocus().page);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_RW :
				if (iFocus.prevPage(true)) {
					requestPage(iFocus.getFocus().page);
					iView.focus(iFocus.getFocus());
				}
				break;				
			case TV.KEY_ENTER :
				_this_.close(Facebook.Define.Select);
				break;
			case TV.KEY_RETURN : 
				// Return to main menu	
				_this_.close(Facebook.Define.Cancel);
				break;
			default :
				break;
		}
	}
}