function Progress(pViewInstance, pDataInstance) {
	var iView = pViewInstance;
	var iData = pDataInstance;
	
	var objSetting = null;
	
    this.init = function(pSetting){
		objSetting = pSetting;
        iView.request(pSetting);
    }
	
    this.open = function(){
        iView.show();
		iView.refresh(iData.request(objSetting, 0));
    }
	
    this.close = function(){
//        iView.clear();
        iView.hide();
    }
	
	this.show = function() {
		iView.show();
	}
	
	this.hide = function() {
		iView.hide();
	}
	
    this.update = function(nPercentage){
		if (nPercentage > 100) nPercentage = 100;
        iView.refresh(iData.request(objSetting, nPercentage));
    }
	
	this.reset = function(){
		iView.refresh(iData.request(objSetting, 0));
	}
}

function ProgressVideoData() {
	this.request = function(pSetting, pPercentage){
		pSetting.bar.width = Math.ceil(pSetting.rail.width * pPercentage / 100);
		return pSetting.bar;
	}
}

function ProgressVideoView(pObjDiv,pUID) {
	var objDiv = pObjDiv;
	var UID = pUID;
	objDiv.style.position = "absolute";
	objDiv.style.left = "0px";
	objDiv.style.top = "0px";
	objDiv.style.width = "960px";
	objDiv.style.height = "540px";
	objDiv.style.visibility = "hidden";''

	var progressHTML = "<div id = '_ProgressView_Rail_"+UID+"_'></div>";
	progressHTML += "<div id = '_ProgressView_Bar_"+UID+"_'></div>";
	
	objDiv.innerHTML = progressHTML;

	var objRail = null;
	var objBar = null;
	
	this.show = function() {
		objDiv.style.visibility = "visible";
	}

	this.hide= function() {
		objDiv.style.visibility = "hidden";		
	}
	
	this.clear = function() {
		objDiv.innerHTML = "";
	}
	
	this.request = function(pSetting) {
		if (!objRail) objRail = _$("_ProgressView_Rail_"+UID+"_");
		objRail.style.position = "absolute";
		objRail.style.left = pSetting.rail.left;
		objRail.style.top = pSetting.rail.top;
		objRail.style.width = pSetting.rail.width;
		objRail.style.height = pSetting.rail.height;
		objRail.style.backgroundImage = "url("+pSetting.rail.src+")";

		if (!objBar) objBar = _$("_ProgressView_Bar_"+UID+"_");
		objBar.style.position = "absolute";
		objBar.style.left = pSetting.bar.left;
		objBar.style.top = pSetting.bar.top;
		objBar.style.width = pSetting.bar.width;
		objBar.style.height = pSetting.bar.height;
		objBar.style.backgroundImage = "url("+pSetting.bar.src+")";
	}
	
	this.refresh = function(pObjBar) {
		if (!objBar) objBar = _$("_ProgressView_Bar_"+UID+"_");
		objBar.style.left = pObjBar.left;
		objBar.style.top = pObjBar.top;
		objBar.style.width = pObjBar.width;
		objBar.style.height = pObjBar.height;
		objBar.style.backgroundImage = "url(" + pObjBar.src + ")";
	}
}