function SinglelineInput(pParam, pReturnFn) {
	FBTrace("SinglelineInput Instance Created");
	var _this_ = this;
	var returnFn = pReturnFn;

	var strConsoleDivTitle = pParam.ID+"_Title_";
	var strConsoleDivBack = pParam.ID+"_Background_";
	var strConsoleDivHelp = pParam.ID+"_Help_";
	var strInputDiv = pParam.ID+"_Input_";

	var strLastContents = "";

	var objDiv = document.getElementById(pParam.ID);
	objDiv.style.visibility = "hidden";
	if (!objDiv) {
//		FBTrace("MultilineInput -> Invalid <div> name");
	}

	// Initializing text input div
	initDiv();

	var objConsoleDivTitle = document.getElementById(strConsoleDivTitle);
	var objInputDiv = document.getElementById(strInputDiv);
	
	var instanceIME = null;

	setTimeout(function(){
		instanceIME = new IMEShell(strInputDiv, SinglelineInputInit);
	},200);
	
	this.open = function() {
		_this_.showIME();
	}

	this.showIME = function() {
		objDiv.style.visibility = "visible";
		var imeobj = instanceIME.getInputObj();

		imeobj.focus();
		Instance.Main.registHelpNavi(generateHelpNavi(),"SinglelineInput");
		Instance.Main.setKeyHandler(function(){},"SinglelineInput");
	}

	function generateHelpNavi() {
		var arrHelp = [];
		arrHelp[arrHelp.length] = {	image : HelpArea.Image.Return,	text : SID_RETURN			};
		return arrHelp;
	}

	this.close = function() {
		objDiv.style.visibility = "hidden";
		Instance.Main.focus();
	}

	function SinglelineInputInit(imeobj) {
		var inputobj = imeobj.getInputObj();		
//		FBTrace("start initializing : "+inputobj.id);
		imeobj.setKeypadPos(parseInt(pParam.IME.left,10),parseInt(pParam.IME.top,10),20);
		imeobj.setKeyFunc(TV.KEY_RETURN,function(){
			imeobj.setString("");
			_this_.close();
			returnFn(false);
		});
		imeobj.setKeyFunc(TV.KEY_EXIT,function(){
			imeobj.setString("");
			_this_.close();
			returnFn(false);
		});
		imeobj.setKeyFunc(TV.KEY_ENTER,function(){
			var retValue = inputobj.value;
			if (retValue != "") {
				imeobj.setString("");
				_this_.close();
				returnFn(retValue);
			}
		});
	}
	
	function initDiv() {
		var strHTML = "";
		strHTML += Util.addDiv(Util.getStyle({left:"0px",top:"0px",width:"960px",height:"540px",'background':"url(Resource/images/popup_blackbg.png)"}),"");
		strHTML += "<div style = 'position:absolute;left:0px;top:0px;width:960px;height:540px'>";
			strHTML += "<div id = '"+strConsoleDivBack+"' style = 'position:absolute;overflow:hidden;"+getStyle(pParam.Background.style)+"'></div>";		
			strHTML += "<div style = 'position:absolute;left:0px;top:0px;width:960px;height:540px'>";
				strHTML += "<div id = '"+strConsoleDivTitle+"' style = 'position:absolute;overflow:hidden;"+getStyle(pParam.Title.style)+"'>"+pParam.Title.text+"</div>";
				if (pParam.Subtitle) {
					strHTML += "<div style = 'position:absolute;overflow:hidden;" + getStyle(pParam.Subtitle.style) + "'>" + pParam.Subtitle.text + "</div>";
				}
				strHTML += "<input size = "+pParam.Input.style.size+" type = 'text' id = '"+strInputDiv+"' style = 'position:absolute;border:0px;"+getStyle(pParam.Input.style)+"'>";
				strHTML += "<div id = '"+strConsoleDivHelp+"' style = 'position:absolute;border:0px;"+getStyle(pParam.HelpArea)+"'>" + makeHelpArea(pParam.HelpArea, pParam.HelpItems) + "</div>";				
			strHTML += "</div>";		
		strHTML += "</div>";
		WIDGET.putInnerHTML(objDiv,strHTML);
	}
	
	function makeHelpArea(pHelpArea, pHelpItems) {
		var arrLength = pHelpItems.length;
		var strHTML = "<table><tr>";
		for (var helpIdx = 0; helpIdx < arrLength; helpIdx++) {
			strHTML += "<td style = 'width:5px;'></td>";
			strHTML += "<td style = 'vertical-align:middle;height:"+pHelpArea.height+";"+"'><img src = '"+pHelpItems[helpIdx].button.image+"'></td>";
			strHTML += "<td style = '"+getStyle(pHelpItems[helpIdx].label.style)+"'>"+pHelpItems[helpIdx].label.text+"</td>";
		}
		strHTML+= "</tr></table>";
//		FBTrace(strHTML);
		return strHTML;
	}
	
    function getStyle(pObjectStyle){
        var strDivHTML = "";
        for (var name in pObjectStyle) {
            strDivHTML += name + ":" + pObjectStyle[name] + ";"
        }
        return strDivHTML;
    }
}