var Util = {};

/*
 * pSetting = {
 * 		currentPage, 		// 1-based
 * 		totalPage,			// 1-based
 * 		left, top, width, height,
 * 		backgroundSrc,
 * 		barSrc
 * }
 */
 Util.getScrollBar = function(pSetting) {
	var returnHTML = "";
	
	var nTotalPage = pSetting.totalPage;
	var nCurrentPage = pSetting.currentPage;
		
	var scrollBarHeight = Math.floor(pSetting.height / nTotalPage);
	var scrollBarTop = pSetting.top + Math.floor((pSetting.height - scrollBarHeight) * nCurrentPage/(nTotalPage-1));
	var scrollBarStyle = {
		left : pSetting.left + "px", top : scrollBarTop + "px", width : pSetting.width + "px", height : scrollBarHeight + "px"
	};
	var scrollBackStyle = { left : pSetting.left + "px", top : pSetting.top + "px", width : pSetting.width + "px", height : pSetting.height + "px" }
			
	returnHTML += Util.addImage(Util.getStyle(scrollBackStyle),pSetting.backgroundSrc);
	returnHTML += Util.addImage(Util.getStyle(scrollBarStyle),pSetting.barSrc);
	
	return returnHTML;
}

Util.seperateString = function(pString, pUnit) {
	if (!pString) return "";
	
	var nSeperateUnit = pUnit ? pUnit : 20;
	var nStringLength = pString.length;
	
	if (nStringLength < nSeperateUnit) return pString;
	
	var strReturn = "";
	var nCount = 0;
	for (var charIdx = 0; charIdx < nStringLength; charIdx++) {
		strReturn += pString[charIdx];
		if (pString[charIdx] != " ") nCount++;
		else nCount = 0;
		if (nCount == nSeperateUnit) {
			strReturn += "<wbr></wbr>";
			nCount = 0;
		}
	}
	return strReturn;
}

Util.getHelpNavi = function(pLeft, pTop, pWidth, pHeight, pObj) {
	var strHTML = "";
	var help = pObj;
	var helpLength = help.length;
	var Style = {
		left : pLeft+"px", top:pTop+"px",width:pWidth+"px",height:pHeight+"px",
		'text-align' : "right"
	}
	strHTML += "<div style ='"+Util.getStyle(Style)+"'>";
	strHTML += "<table><tr>";
	for (var helpIdx = 0; helpIdx < helpLength; helpIdx++) {
		strHTML += "<td style = 'height:35px;vertical-align:middle;'>";
		strHTML += "<img src = '"+help[helpIdx].image+"'>";
		strHTML += "</td>";
		strHTML += "<td style = 'color:#434343;font:16px;vertical-align:middle;'>";
		strHTML += help[helpIdx].text
		strHTML += "</td>";
		strHTML += "<td style = 'width:3px;'></td>";
	}
	strHTML += "</tr></table>";
	strHTML += "</div>";
	//FBTrace(strHTML);
	return strHTML;
}

Util.isEmptyObject = function(pObject){
	for (var property in pObject) {
		return false;
	}
	return true;
}

Util.getObjectValues = function(pObj) {
	var strValues = "";
	for (var name in pObj) {
		if (pObj[name] && !Util.isEmptyObject(pObj[name]))
			strValues += ", " + pObj[name];
	}
	strValues = strValues.substr(2,strValues.length-2);
	return strValues;
}

Util.moldTime = function(pStrTime) {
	if (!(pStrTime instanceof String)) return "";
	
	var strTime = pStrTime.split(":");
	var retTime = "00:";
	var nTimeLength = strTime.length;
	for (var timeIdx = 0; timeIdx < nTimeLength; timeIdx++) {
		if (parseInt(strTime[timeIdx],10) < 10) {
			retTime += "0" + parseInt(strTime[timeIdx],10);
		} else {
			retTime += parseInt(strTime[timeIdx],10);
		}
		if (timeIdx < (nTimeLength-1)) {
			retTime += ":";
		}
	}
	return retTime;
}

/**
 * @brief		Print current time
 * @remarks	Print title and current time
 * @param		strTitle		Title associated with current time
 */
Util.printCurrentTime = function(strTitle) {
    var tmpDate = new Date();
    FBTrace(strTitle + " : " + tmpDate.getHours() +":" + tmpDate.getMinutes() + ":" + tmpDate.getSeconds() + "." + tmpDate.getMilliseconds());
}

Util.getTime = function(pTimeMillisec){
    var tDate = new Date(pTimeMillisec * 1000);
    var dateNow = new Date();
    
	var nDay = tDate.getDay();
	
	var arrWeek = [SID_SUNDAY, SID_MONDAY,SID_TUESDAY,SID_WEDNESDAY,SID_THURSDAY,SID_FRIDAY,SID_SATURDAY];
	var arrMonth = [SID_JANUARY,SID_FEBRUARY,SID_MARCH,SID_APRIL,SID_MAY_FULL,SID_JUNE,SID_JULY,SID_AUGUST,SID_SEPTEMBER,SID_OCTOBER,SID_NOVEMBER,SID_DECEMBER];
	
    var secNowTime = new Date().getTime() / 1000;
    var tWriteTime = new Date(pTimeMillisec * 1000);
	var secWriteTime = tWriteTime.getTime() / 1000;
    
    var secOneMinute = 60;
    var secOneHour = 60 * secOneMinute;
    var secOneDay = 24 * secOneHour;
    var secOneWeek = 7 * secOneDay;
    var secOneMonth = 30.5 * secOneDay;
    var secOneYear = 365 * secOneDay;
    
    var secElapsed = Math.floor(secNowTime - secWriteTime);
    var secMinutesAgo = Math.floor(secElapsed / 60);
	secMinutesAgo = secMinutesAgo < 0 ? 0 : secMinutesAgo;
    var secHoursAgo = Math.floor(secElapsed / 3600);
    
    var strTime = "";

	var tLimit = new Date();
	tLimit.setHours(0);
	tLimit.setMinutes(0);
	tLimit.setSeconds(0);
	var secLimit = (tLimit.getTime() / 1000) - nDay * secOneDay;

	if (secElapsed < secOneHour) {
		if (secMinutesAgo == 0) {
			strTime = SID_MIX_SECONDS_AGO.Replace(secElapsed > 1 ? secElapsed : 2);
		}
		else 
			if (secMinutesAgo == 1) {
				strTime = SID_ABOUT_A_MINUTE_AGO;
			}
			else {
				strTime = SID_MIX_MINUTES_AGO.Replace(secMinutesAgo);
			}
	}
	else 
		if (secElapsed < secOneDay) {
			if (secHoursAgo == 1) {
				strTime = SID_ABOUT_AN_HOUR_AGO;
			}
			else {
				strTime = SID_MIX_HOURS_AGO.Replace(secHoursAgo);
			}
		}
		else {
			if (secElapsed > secOneYear) {
				strTime = SID_OVER_A_YEAR_AGO;
			}
			else {
				var strMonth = arrMonth[tWriteTime.getMonth()];
				var strDate = tWriteTime.getDate();
				var strHours = tWriteTime.getHours();
				var strMinutes = tWriteTime.getMinutes();
				if (secWriteTime > secLimit) {
					strTime = SID_MIX_DATE_TIME.Replace(arrWeek[nDay],Instance.Date.getTimeString({hour:strHours, minute : strMinutes}));
				}
				else {
					strTime = SID_MIX_MONTH_DAY_TIME.Replace(strMonth, strDate ,Instance.Date.getTimeString({hour:strHours, minute : strMinutes}));
				}
			}
		}
	return strTime;
}

Util.getTime2 = function(pTimeMillisec){
    var tDate = new Date(pTimeMillisec * 1000);
    var dateNow = new Date();
    
	var nDay = tDate.getDay();
	
	var strNsec = SID_MIX_SECONDS_AGO; // nsec
	var str1min = SID_ABOUT_A_MINUTE_AGO; // 1min
	var strNmin = SID_MIX_MINUTES_AGO; // nmin
	var str1hr = SID_ABOUT_AN_HOUR_AGO; // 1hr
	var strNhr = SID_MIX_HOURS_AGO; // nhr
	
	var strMon = SID_ON_MONDAY; // Mon
	var strTue = SID_ON_TUESDAY; //Tue
	var strWed = SID_ON_WEDNESDAY; // Wed
	var strThu = SID_ON_THURSDAY; // Thu
	var strFri = SID_ON_FRIDAY; // Fri
	var strSat = SID_ON_SATURDAY; // Sat
	var strSun = SID_ON_SUNDAY; // Sun
	
	var strLMon = SID_LAST_MONDAY; // lMon
	var strLTue = SID_LAST_TUESDAY; // lTue
	var strLWed = SID_LAST_WEDNESDAY; // lWed
	var strLThu = SID_LAST_THURSDAY; // lThu
	var strLFri = SID_LAST_FRIDAY; // lFri
	var strLSat = SID_LAST_SATURDAY; // lSat
	var strLSun = SID_LAST_SUNDAY; // lSun
	
	var arrWeek = [strSun, strMon,strTue,strWed,strThu,strFri,strSat];
	var arrLWeek = [strLSun, strLMon,strLTue,strLWed,strLThu,strLFri,strLSat];
	
	var str1wk = SID_ABOUT_A_WEEK_AGO; // 1wk
	var strNwk = SID_MIX_ABOUT_WEEKS_AGO; // nwk
	var str1mo = SID_ABOUT_A_MONTH_AGO; // 1mo
	var strNmo = SID_MIX_ABOUT_MONTHS_AGO; //nmo
	var str1yr = SID_OVER_A_YEAR_AGO; // 1yr
	
    var secNowTime = new Date().getTime() / 1000;
    var secWriteTime = new Date(pTimeMillisec * 1000).getTime() / 1000;
    
    var secOneMinute = 60;
    var secOneHour = 60 * secOneMinute;
    var secOneDay = 24 * secOneHour;
    var secOneWeek = 7 * secOneDay;
    var secOneMonth = 30.5 * secOneDay;
    var secOneYear = 365 * secOneDay;
    
    var secElapsed = Math.floor(secNowTime - secWriteTime);
    var secMinutesAgo = Math.floor(secElapsed / 60);
	secMinutesAgo = secMinutesAgo < 0 ? 0 : secMinutesAgo;
    var secHoursAgo = Math.floor(secElapsed / 3600);
    
    var strTime = "";

	if (secElapsed < secOneHour) {
        if (secMinutesAgo == 0) {
            strTime = SID_MIX_SECONDS_AGO.Replace(secElapsed > 1 ? secElapsed : 2);
        }
        else if (secMinutesAgo == 1) {
            strTime = str1min;
        }
        else {
            strTime = strNmin.Replace(secMinutesAgo);
        }
    }
    else if (secElapsed < secOneDay) {
        if (secHoursAgo == 1) {
            strTime = str1hr;
        }
        else {
            strTime = strNhr.Replace(secHoursAgo);
        }
    } else if (secElapsed < secOneWeek) {
	    strTime = arrWeek[nDay];
	    // 5+ days ago => display "last Thursday" instead of "on Thursday".
	    if (secElapsed >= secOneDay * 5) {
			strTime = arrLWeek[nDay];
	    }
	}
	else if (secElapsed < secOneWeek * 2) {
        strTime = str1wk; // about a week ago
    }
    else if (secElapsed < secOneWeek * 3.5) {
        strTime = strNwk.Replace(Math.floor(secElapsed / secOneWeek));
    }
    else if (secElapsed < secOneMonth * 1.5) {
        strTime = str1mo; // a month ago
    }
    else if (secElapsed < secOneYear) {
        strTime = strNmo.Replace(Math.floor((secElapsed + secOneMonth / 2) / secOneMonth));
    }
    else {
        strTime = str1yr; // over a year ago.
    }
	
	return strTime;
}

Util.addDiv = function(pStrStyle, pHTML, pID) {
	var strHTML = "";
	strHTML += "<div id = '"+(pID? pID : "") +"' style = '" + pStrStyle + "'>" + pHTML + "</div>";
//	strHTML += "<div class = 'debug' id = '"+(pID? pID : "") +"' style = '" + pStrStyle + "'>" + pHTML + "</div>";
	return strHTML;
}

Util.addImage = function(pStrStyle, pSrc, pID) {
	var strHTML = "";
	strHTML += "<img id = '"+(pID? pID : "") +"' src = '" + pSrc + "' style = '"+pStrStyle + "'>";
	return strHTML;
}

Util.addImageDiv = function(pSrc, pArea, pSize) {
	var strHTML = "";
	strHTML += "<div style = 'position:absolute;left:"+pArea.left+"px;top:"+pArea.top+"px;width:"+pArea.width+"px;height:"+pArea.height+"px;overflow:hidden;'>";
	var objResized = resizeImage(pArea.width, pArea.height, pSize.width, pSize.height);
	strHTML += "<img src = '"+pSrc+"' style = 'position:absolute;left:"+objResized.left+"px;top:"+objResized.top+"px;width:"+objResized.width+"px;height:"+objResized.height+"px;'>";
	strHTML += "</div>";
	
	return strHTML;
	
	function resizeImage(pTargetWidth, pTargetHeight, pOriginalWidth, pOriginalHeight) {
		var objResult = { width : 0, height : 0, left : 0, top : 0 };
		
		if (!((pOriginalWidth < pTargetWidth) && (pOriginalHeight < pTargetHeight))) {
			// Calculate original image ratio
			if ((pTargetHeight / pTargetWidth) < (pOriginalHeight / pOriginalWidth)) {
				// Fit to width
				objResult.width = pTargetWidth;
				objResult.height = Math.round(pOriginalHeight * (pTargetWidth / pOriginalWidth));
				objResult.top = -Math.round((objResult.height - pTargetHeight)/4);
				objResult.left = -Math.round((objResult.width - pTargetWidth)/2);
			} else {
				// Fit to height
				objResult.height = pTargetHeight;
				objResult.width = Math.round(pOriginalWidth * (pTargetHeight / pOriginalHeight));
				objResult.left = -Math.round((objResult.width - pTargetWidth)/2);
				objResult.top = -Math.round((objResult.height - pTargetHeight)/2);
			}			
		}
		return objResult;
	}
}

Util.getStyle = function(pObjectStyle, pRelative) {
	var strDivHTML = "";
	strDivHTML = pRelative ? "" : "position:absolute;";
	for (var name in pObjectStyle) {
		strDivHTML += name + ":" + pObjectStyle[name] + ";"
	}
	return strDivHTML;
}

Util.reverseArray = function(pArray) {
	var arrReturn = [];
	var arrLength = 0;
	if (pArray instanceof Array) {
		arrLength = pArray.length;
		for (var arrIdx = arrLength-1;arrIdx >= 0; arrIdx--) {
			arrReturn.push(pArray[arrIdx]);
		}
	}
	return arrReturn;
}

Util.copyArray = function(pArr) {
	var retArr = new Array();
	var arrLength = pArr.length;
	for (var index = 0; index < arrLength; index++) {
		retArr.push(pArr[index]);
	}
	return retArr;
}

Util.copyObject = function(pObject) {
	var retObject = {};
	for (var name in pObject) {
		retObject[name] = pObject[name];
	}
	return retObject;
}

Util.isMaple = function() {
	var strAgent = navigator.userAgent;
	if (strAgent.indexOf("Maple") >= 0) {
		return true;
	} else {
		return false;
	}
}

Util.traverse = function(pObject) {
	var nDepth = 0;
	FBTrace_("[Object Traverse]");
	FBTrace_(recurPrint(nDepth,pObject,""));
	function recurPrint(nDepth, pObject, pStr) {
		if (pObject instanceof Array) {
			var itemLength = pObject.length;
			for (var itemIdx = 0; itemIdx < itemLength; itemIdx++) {
				pStr+="\n";
				for (var i = 0; i < nDepth; i++) pStr+= "  ";
				pStr += "Array[" + itemIdx + "]";
				pStr = recurPrint(nDepth+1, pObject[itemIdx],pStr);
			}
			return pStr;
		} else {
			if (typeof(pObject) != "object" || pObject == null) {
				pStr+="\n";
				for (var i = 0; i < nDepth; i++) pStr+= "  ";
				return pStr + "Value[" + pObject + "]";
			} else {
				for (var name in pObject) {
					pStr+="\n";
					for (var i = 0; i < nDepth; i++) pStr+= "  ";
					pStr += "Name[" + name + "]";
					pStr = recurPrint(nDepth+1, pObject[name], pStr);
				}
				return pStr;
			}
		}
	}
}

Util.DecodeJSON = function(pStr){
	//Util.printCurrentTime("JSON Parse Start");
	Instance.Plugin.setOffWatchDog();
	var objReturn = null;

    try {
        objReturn = JSON.parse(pStr);
    } catch (e) {
        objReturn = {};
    }
	
	Instance.Plugin.setOnWatchDog();	
	//Util.printCurrentTime("JSON Parse End");
	return objReturn;
}

Util.EncodeJSON = function(pObject) {
	return JSON.stringify(pObject)
}

// Print user type
Util.printUser = function(pUserType) {
	switch(pUserType) {
		case FacebookFrame.Define.ME :
			FBTrace_("Facebook Frame Type : Me");
			break;
		case FacebookFrame.Define.FRIEND :
			FBTrace_("Facebook Frame Type : Friend");
			break;
		case FacebookFrame.Define.OTHER :
			FBTrace_("Facebook Frame Type : Other");
			break;
	}
}

function TRACE(str) {
	alert(str);
}

function FBTrace(str) {
	alert("[Facebook Debug] " + str);
}

function FBTrace_(str) {
	alert("[Facebook FATAL Debug] " + str);
}

function _$(pElement) {
 	return _document.getElementById(pElement);
}

// Replace text with given keyword
Util.replaceString = function(pString, pArgs) {
	var nArgLength = pArgs.length < 6 ? pArgs.length : 5;
	for(var idx = 0; idx < nArgLength; idx++) {
		pString = pString.replace(Util.replaceString.arrSource[idx], pArgs[idx]);
	}
	return pString;
}

Util.replaceString.arrSource = ["<<A>>","<<B>>","<<C>>","<<D>>","<<E>>"];

String.prototype.Replace = function() {	return Util.replaceString(this, arguments); }

Util.ScreenSaver = {
	isOn : false
	, on : function() {
		if(!this.isOn) {
			FBTrace("Screen Saver On");
			Instance.Plugin.setOnScreenSaver();
			this.isOn = true;
		}
	}
	, off : function() {
		if(this.isOn) {
			FBTrace("Screen Saver Off");
			Instance.Plugin.setOffScreenSaver();
			this.isOn = false;
		}
	}
}

Util.parseParams = function(pObject) {
	var strParams = window.location.search;
	if (strParams.charAt(0) == "?")
		strParams = strParams.slice(1, strParams.length);
		
    var arrParams = strParams.split("&");
    for (var idx=0; idx < arrParams.length; idx++) {
        var paramPair = arrParams[idx].split("=");
		if (paramPair.length == 2) {
			pObject[paramPair[0]] = decodeURIComponent(paramPair[1]);
		}
    }
	return !strParams.match(/redirect=true/);
}

Util.getSeperateTime = function(pTime) {
		var nTotalSec = parseInt(pTime / 1000,10);
		var nMin = parseInt(nTotalSec / 60,10);
		var nSec = nTotalSec % 60;
		var strHour = "00";
		var strMin =nMin<10?"0"+nMin:nMin;
		var strSec = nSec<10?"0"+nSec:nSec;
		return {
			hour : strHour
			, min : strMin
			, sec : strSec
		}
}

Util.DateTemplate = function(strAreaCode) {
	var strAreaCode = strAreaCode || "USA";
	
	var strDateFormat = "";
	var strTimeFormat = "";
	
	setAreaCode(strAreaCode);
	
	alert("=== DateTemplate created! ===");
	alert("Date format : " + strDateFormat);
	alert("Time format : " + strTimeFormat);

	function getTimeString(srcDate) {
		alert("DateConverter : getTimeString("+srcDate+")");
		var retValue = "";
		retValue = replace(strTimeFormat, srcDate);
		alert("return : " + retValue);
		return retValue;
	}
	
	function getDateString(srcDate) {
		alert("DateConverter : getDateString("+srcDate+")");
		var retValue = "";
		retValue = replace(strDateFormat, srcDate);
		alert("return : " + retValue);
		return retValue;
	}
	
	function setApplyTimezoneOffset (b) {
		alert("DateConverter : setApplyTimezoneOffset("+b+")");
		bApplyTimezoneOffset = b;
	}

	function setAreaCode (str) {
		alert("DateConverter : setAreaCode("+str+")");
		strAreaCode = str;
		switch (strAreaCode) {
			case "KOR":
				strTimeFormat = "<<hour>>:<<minute>> <<AM>>";
				strDateFormat = "<<YEAR>> <<month>> <<date>>";
				break;
			case "PANEURO":
				strTimeFormat = "<<HOUR>>:<<minute>>";
				strDateFormat = "<<date>> <<month>> <<YEAR>>";
				break;
			case "BRA":
				strTimeFormat = "<<HOUR>>:<<minute>> <<AM>>";
				strDateFormat = "<<date>> <<month>> <<YEAR>>";
				break;
			case "USA":
				strTimeFormat = "<<hour>>:<<minute>> <<AM>>";
				strDateFormat = "<<month>> <<date>> <<YEAR>>";
				break;
			case "CHI":
			case "HKG":
			case "ARB":
			case "PANNORDIG":
			case "SOUTHEASTASIA":
			case "ASIA_ATV":
			case "ASIA_DTV":
			case "TW":
			case "NORTHAFRICA":
			case "EA_DTV":
			case "CIS":
			case "PHI":
			case "S_AFR_DTV":
			default :
				strTimeFormat = "<<hour>>:<<minute>> <<AM>>";
				strDateFormat = "<<month>> <<date>> <<YEAR>>";
				break;
		}
	}
	
	function replace (strFormat, pData) {
		var retValue = strFormat;
			
		var year = pData.year ? pData.year + "" : null;
		var month = pData.month ? pData.month + "" : null;
		var date = pData.date ? pData.date + "" : null;

		var hours = pData.hour;
        if (hours < 0 || hours > 24) {
			alert("DateTemplate :: replace - Hour param error(Out of range)");
			hours = 0;
		}
		
		var minutes = pData.minute;
		if (minutes < 0 || minutes > 60) {
			alert("DateTemplate :: replace - Minute param error(Out of range)");
			minutes = 0;
		}
		
		//alert(year +"."+ month +"."+date +"."+ hours +"."+ minutes);
		
		if (!year)
			retValue = retValue.replace("<<YEAR>>", "");
		retValue = retValue.replace("<<month>>", makeTwoDigits(month));
		retValue = retValue.replace("<<date>>", makeTwoDigits(date));
		retValue = retValue.replace("<<HOUR>>", makeTwoDigits(hours));
		retValue = retValue.replace("<<hour>>", hours > 12 ? makeTwoDigits(hours-12) : makeTwoDigits(hours));
		retValue = retValue.replace("<<minute>>", makeTwoDigits(minutes));
		retValue = retValue.replace("<<AM>>", hours > 12 ? "PM" : "AM");
		retValue = retValue.replace("<<am>>", hours > 12 ? "pm" : "am");

		function makeTwoDigits(n) {
		    // make two digits.
		    return n < 10 ? '0' + n : n;
		}
		
		return retValue;
	}
	
	return {
		getDateString : function(srcDate) {
			return getDateString(srcDate);
		},
		getTimeString : function(srcDate) {
			return getTimeString(srcDate);
		},
		setAreaCode : function(strAreaCode) {
			setAreaCode(strAreaCode);
		}
	}
}

Util.getValueFromURI = function(pURI, pKeyword){
	var reg = new RegExp("[\?\&]"+pKeyword+"=([^\&]+)");
	var result = pURI.match(reg);
	if(result && result instanceof Array && result.length == 2) {
		return result[1];
	} else {
		return false;
	}
}
