function FriendsGroup(pViewInstance, pReturnFn) {
	var _this_ = this;
	
	var iView = pViewInstance;
	var friendsGroup = null;
	var returnFn = pReturnFn;
	
	var objPages = [];
	
	var nRow = 0, nCol = 0;
	var iFocus = null;
	
	// External Interface
	this.open = function() {
		iView.show();
	}
	
	this.close = function() {
		iView.hide();
	}
	
	this.enter = function(pFriendsGroup) {
		friendsGroup = pFriendsGroup;
		nRow = 1, nCol = ( friendsGroup.length < 6 ) ? friendsGroup.length : 6;
		iFocus = new FocusMapper("FriendsGroup",nRow, nCol);
		Instance.Main.registHelpNavi(generateHelpNavi(),"FriendsGroup");
		Instance.Main.setKeyHandler(keyHandler,"FriendsGroup");
		generatePage();
		iFocus.refresh(objPages);
		iFocus.setPage(0);

		iView.show();
		iView.request(objPages[0],iFocus);
		iView.focus(iFocus.getFocus());
	}

	function generateHelpNavi() {
		var arrHelp = [];
		arrHelp[arrHelp.length] = {	image : HelpArea.Image.Return,	text : SID_RETURN			};
		return arrHelp;
	}

	function generatePage() {
		objPages[0] = [];
		var rowData = [];
		rowData.push({
			flid : "ALL",
			name : SID_ALL
		});
		for (var flid in friendsGroup) {
			rowData.push(friendsGroup[flid]);
		}
		objPages[0].push(rowData);
	}
	
	function returnFnFilter() {
		iView.show();
		Instance.Main.setKeyHandler(keyHandler,"FriendsGroup");
	}
	
	function keyHandler(pKeyCode) {
		switch(pKeyCode) {
			case TV.KEY_RIGHT :
			case TV.KEY_PANEL_VOL_DOWN :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				// Apply circulation (by DMS00508100)
				if (iFocus.right(true)) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_LEFT :
			case TV.KEY_PANEL_VOL_UP :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				// Apply circulation (by DMS00508100)
				if (iFocus.left(true)) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_UP :
			case TV.KEY_WHEELUP :
			case TV.KEY_PANEL_CH_UP :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.up()) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_DOWN :
			case TV.KEY_WHEELDOWN :
			case TV.KEY_PANEL_CH_DOWN :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.down()) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_FF :
				if (iFocus.nextPage(true)) {
					requestPage(iFocus.getFocus().page);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_RW :
				if (iFocus.prevPage(true)) {
					requestPage(iFocus.getFocus().page);
					iView.focus(iFocus.getFocus());
				}
				break;				
			case TV.KEY_ENTER :
				iView.hide();
				iView.blur(iFocus.getFocus());
				returnFn(objPages[iFocus.getFocus().page][iFocus.getFocus().row][iFocus.getFocus().col].flid);
				break;
			case TV.KEY_RETURN : 
				// Return to main menu	
				iView.hide();
				iView.blur(iFocus.getFocus());
				returnFn(false);
				break;
			default :
				break;
		}
	}
}