function FriendsList(pViewInstance, pDataInstance, pReturnFn) {
	var _this_ = this;

	var iView = pViewInstance;
	var iData = pDataInstance;
	var returnFn = pReturnFn;
	
	var objPages = null;
	var curFilterMode = "ALL";
	
	var objFriendSearch = {
		ID : "facebookIMESingle",
		Background : {
			style : {
				width : '461px',	height : '221px', left : '111px', top : '105px',
				'background-image' : 'url(Resource/images/search_bg.png)'
			}
		},
		Title : {
			text : FBID_SEARCH,
			style : {
				width : '461px', height : '30px',	left : '112px', top : '128px',
				'color' : '#F1EEEE', 'font-size' : '16px', 'text-align' : 'center', 'font-weight' : 'bold'
			}
		},
		Subtitle : {
			text : SID_SEARCH_FRIENDS,
			style : {
				width : '461px', height : '30px',	left : '147px', top : '187px',
				'color' : '#3d3d3d', 'font-size' : '18px', 'font-weight' : 'bold'
			}
		},
		Input : {
			text : "",
			style : {
				width : '391px',	height : '34px',	left : '146px', top : '213px',
				'size' : '35', 'font-size' : '16px',	'color' : '#434343', 'maxlength' : 200
			}
		},
		IME : {
			left : '573px', top : '106px'
		},
		HelpArea : {
			left : '145px', top : '285px', width : '395px', height : '32px',
	//		'border' : '1px solid #00FF00',
			'text-align' : 'right'
		},
		HelpItems : [
			{
				button : {
					image : 'Resource/images/viewmode_addicon.png',
					style : {
						width : '24px', height : '16px'
					}
				},
				label : {
					text : FBID_SEARCH, 
					style : { 
						'font-size' : '16px', 'font-weight' : 'bold', 'color' : '#434343'
					}
				}
			},
			{
				button : {
					image : 'Resource/images/help_icon_y.png',
					style : {
						width : '28px', height : '28px'
					}
				},
				label : {
					text : SID_SPACE_WORD, 
					style : { 
						'font-size' : '16px', 'font-weight' : 'bold', 'color' : '#434343'
					}
				}
			},
			{
				'button' : {
					image : 'Resource/images/viewmode_backicon.png',
					style : {
						width : '24px', height : '16px'
					}
				},
				label : {
					text : SID_RETURN, 
					style : { 
						'font-size' : '16px', 'font-weight' : 'bold', 'color' : '#434343'
					}
				}
			}
		]
	}
	
	var iSinglelineInput = new SinglelineInput(objFriendSearch, returnFromSearch);

	var nRow = 4, nCol = 3;
	var iFocus = new FocusMapper("FriendsList",nRow,nCol);

	var bOpened = false;
	var bReady = false;
	var bOptionMode = false;
	
	var objFriendList = null;
	var objFriendGroup = null;
	
	var strListName = "";
	var strCurUser = "";
    
	this.isOpened = function(){
        return bOpened;
    }
    
	this.isReady = function(){
        return bReady;
    }
	
	// External Interface
	this.open = function(pUserID, pOption) {
		FBTrace("FriendsList Open Start " + pUserID + "," + pOption);
		bOpened = true;
		bOptionMode = pOption ? true : false;
		
		iView.show();
		
		if (pOption) {
			bReady = true;
			strListName = objFriendGroup[pOption].name;
			changeGroup(pOption);
		} else {
			strCurUser = pUserID;
			strListName = SID_FRIENDS_LIST;
			iData.request(pUserID, OnLoadData);
		}
		FBTrace("FriendsList Open End");
	}
	
	this.close = function() {
//		FBTrace("FriendsList Close Start");
		bOpened = false;
		bReady = false;

		iView.clear();
		iView.hide();
//		FBTrace("FriendsList Close End");
	}

	this.enter = function() {
		if (!bReady) {	 returnFn(); return; }
		
		Instance.Main.setKeyHandler(keyHandler,"FriendsList");
		iView.focus(iFocus.getFocus());
	}

	function generateHelpNavi() {
		var arrHelp = [];
		if (iFocus.getTotalPage() > 1) 
			arrHelp[arrHelp.length] = {	image: HelpArea.Image.FFRW, text: SID_PAGE_UP_DOWN };
		arrHelp[arrHelp.length] = {	image : HelpArea.Image.Return,	text : SID_RETURN			};
		return arrHelp;
	}

	function OnLoadData(pFriendList, pFriendGroup) {
		//FBTrace("FriendsList :: OnLoadData Start");
		if (!bOpened || bOptionMode) return;
		
		objFriendList = pFriendList;
		objFriendGroup = pFriendGroup;
		
		if (pFriendList) {
			bReady = true;
			objPages = generatePage(objFriendList);
			iFocus.generate(objPages);
			requestPage(iFocus.getFocus().page);
		} else {
			bReady = false;
			iView.request(false, null, strListName);
		}
		
		// Refresh Menu
		updateMenu(objFriendGroup);
		
		//FBTrace("FriendsList :: OnLoadData End");
	}
	
	function requestPage(pPage) {
		
		// Show Help Navi for current mode
		Instance.Main.registHelpNavi(generateHelpNavi(),"FriendsList");
		if (Instance.Main.getKeyHandler() == "FriendsList") {
			Instance.Main.applyHelpNavi("FriendsList");
		}
		
		iFocus.setPage(pPage);
		if (objPages[pPage].length > 0) {
			iView.request(objPages[pPage],iFocus, strListName);
			if(iRemoteFB.menuFlag == 1){
				setTimeout(function(){
				iMenu.enter();
				iRemoteFB.menuFlag = 0;},50);
			}
			return true;
		} else {
			bReady = false;
			iView.request(false, null, strListName);
			return false;
		}
	}
	
    
	function keyHandler(pKeyCode) {
		switch(pKeyCode) {
			case TV.KEY_RIGHT :
			case TV.KEY_PANEL_VOL_DOWN :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.right()) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_LEFT :
			case TV.KEY_PANEL_VOL_UP :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.left()) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				} else {
					iView.blur(iFocus.getFocus());
					iRemoteFB.onLoadFacebook();
					iRemoteFB.onLoadFriends(GroupListNames);
					returnFn();
				}
				break;
			case TV.KEY_UP :
			case TV.KEY_WHEELUP :
			case TV.KEY_PANEL_CH_UP :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.up()) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				} else {
					requestPage(iFocus.getFocus().page);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_DOWN :
			case TV.KEY_WHEELDOWN :
			case TV.KEY_PANEL_CH_DOWN :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.down()) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				} else {
					requestPage(iFocus.getFocus().page);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_FF :
				if (iFocus.nextPage(true)) {
					requestPage(iFocus.getFocus().page);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_RW :
				if (iFocus.prevPage(true)) {
					requestPage(iFocus.getFocus().page);
					iView.focus(iFocus.getFocus());
				}			
				break;
			case TV.KEY_ENTER :
				iView.hide();
				Instance.Frame.open(findUid(iFocus.getFocus()));
				break;
			case TV.KEY_RETURN : 
				// Return to main menu	
				iView.blur(iFocus.getFocus());
				iRemoteFB.onLoadFacebook();
				iRemoteFB.onLoadFriends(GroupListNames);
				returnFn();
				break;
			default :
				break;
		}
	}
	
	function goList() {
		curFilterMode = "ALL";
		objPages = generatePage(objFriendList);
		iFocus.generate(objPages);
		requestPage(iFocus.getFocus().page);
		iView.focus(iFocus.getFocus());
	}
	
	function returnCaller(pFlid) {
		Instance.Main.setKeyHandler(keyHandler,"FriendsList");
		changeGroup(pFlid);
		iView.focus(iFocus.getFocus());
	}
	
	function changeGroup(pFlid) {
		FBTrace_("changeGroup pFlid : " + pFlid);
		if (pFlid) {
			if (pFlid == "ALL") {
				objPages = generatePage(objFriendList);					
			} else {
				var objGroupResult = generateGroupPage(objFriendGroup[pFlid]);
				objPages = objGroupResult;
				if (objGroupResult) {
					objPages = objGroupResult;
				} else {
					bReady = false;
					iView.request(false, null, strListName);
					return;
				}
			}
			iFocus.setPage(0);
			iFocus.resetFocus();
			
			iFocus.generate(objPages);
			if (!requestPage(iFocus.getFocus().page)) {
				return;
			}
		} 
	}
	
	function generateGroupPage(pFriendGroupList) {
		if (pFriendGroupList.arrMember instanceof Array && pFriendGroupList.arrMember.length > 0) {
			// Set current friend filter mode
			curFilterMode = pFriendGroupList.flid;
			
			var indexGroupList = {};
			indexGroupList[pFriendGroupList.name] = [];
			friendsList = pFriendGroupList.arrMember;
			var friendsLength = friendsList.length;
			for (var friendIdx = 0; friendIdx < friendsLength; friendIdx++) {
				indexGroupList[pFriendGroupList.name].push(friendsList[friendIdx]);
			}
			FriendsArray = indexGroupList;
			
			return assignPage(indexGroupList);
		} else {
			// If there is no friend in such group
			return false;
		}
	}

	function generateSearchPage(pFriendGroupList) {
		// Set current friend filter mode
		curFilterMode = "SEARCH";
		
		var indexGroupList = {};
		indexGroupList[pFriendGroupList.name] = [];
		friendsList = pFriendGroupList.arrMember;
		var friendsLength = friendsList.length;
		for (var friendIdx = 0; friendIdx < friendsLength; friendIdx++) {
			indexGroupList[pFriendGroupList.name].push(friendsList[friendIdx]);
		}
		
		return assignPage(indexGroupList);		
	}

	function generatePage(pFriendsList) {
		// Set current friend filter mode
		curFilterMode = "ALL";
		var indexFriendsList = {};
		indexFriendsList[curFilterMode] =pFriendsList
		FriendsArray = indexFriendsList;		
		return assignPage(indexFriendsList);
	}
	
	function assignPage(pList) {
		var nCurPage = 0;
		var nLineLength = 0;
		var nIndexLength = 0;

		var arrItemBuffer = [];		
		var objPages = [];
		objPages[0] = [];

		for (var indexChar in pList) {
			if (pList[indexChar].length > 0) {
				if(indexChar != "ALL")
					putItemToPage(indexChar);
				var item = pList[indexChar];
				var itemLength = item.length;
				for (var itemIdx = 0; itemIdx < itemLength; itemIdx++) {
					putItemToPage(item[itemIdx]);
				}
			}
		}
		flushItemToPage();
		
		return objPages;

		function makeNewPage() {
			// Prepare new page
			nCurPage++;
			nIndexLength = 0;
			nLineLength = 0;
			arrItemBuffer = [];
			if (!objPages[nCurPage] || !(objPages[nCurPage] instanceof Array)) {
				objPages[nCurPage] = [];
			}
		}

        function flushItemToPage(){
            if (arrItemBuffer.length > 0) {
                var tItems = Util.copyArray(arrItemBuffer);
                objPages[nCurPage].push(tItems);
				arrItemBuffer = [];
				nLineLength++;
            }
        }

		function putItemToPage(pItem) {
			if(typeof(pItem) != "object") {
//				FBTrace(pItem);
				flushItemToPage();
				// Index
				if (nLineLength > 2) {
					makeNewPage();
				}
				objPages[nCurPage].push(pItem);
				nIndexLength++;
				if (nIndexLength > 2) {
					nLineLength++;
				}
			} else {
//				FBTrace(pItem.name);
				// Item
				if (arrItemBuffer.length < 3) {
					arrItemBuffer.push(pItem);
					if (arrItemBuffer.length == 3) {
						flushItemToPage();
					}
				}
			}
			if(nLineLength > 3) {
				makeNewPage();
			}
		}		
	}
	
	function findUid(pPosition) {
		var curPage = objPages[iFocus.getFocus().page];
		var listLength = curPage.length;
		var itemLength = 0;
		for (var listIdx = 0, rowIdx = 0; listIdx < listLength; listIdx++) {
			if (curPage[listIdx] instanceof Array) {
				itemLength = curPage[listIdx].length;
				for (var itemIdx = 0; itemIdx < itemLength; itemIdx++) {
					if (pPosition.row == rowIdx && pPosition.col == itemIdx) {
						return curPage[listIdx][itemIdx].uid;
					}
				}
				rowIdx++;
			}
		}
	}
	
		function returnFromSearch(pReturn) {
		Instance.Main.setKeyHandler(keyHandler,"FriendsList");
		if (pReturn) {
			SearchFriends(pReturn);
		} 
	}

	// Search Friends
	function SearchFriends(pKeyword) {
		FBTrace(pKeyword);
		var friendList = iData.getList();
		var searchResult = {
			name : pKeyword,
			arrMember : []
		};
		
		var friendLength = friendList.length;
		for (var friendIdx = 0; friendIdx < friendLength; friendIdx++) {
			if (friendList[friendIdx].name.indexOf(pKeyword) != -1) {
				searchResult.arrMember.push(friendList[friendIdx]);
			}
		}

		if (searchResult.arrMember.length > 0) {
			curFilterMode = "SEARCH";
			objPages = generateSearchPage(searchResult);
			
			iFocus.setPage(0);
			iFocus.resetFocus();
			iFocus.generate(objPages);
			if (!requestPage(iFocus.getFocus().page)) {
				return;
			}
			Instance.Main.setKeyHandler(keyHandler,"FriendsList");
			iView.focus(iFocus.getFocus());
		} else {
             /* Start Interactive Device */
			iRemoteFB.errormsgPopup(SID_NO_RESULTS_FOUND_MSG);
             /* End Interactive Device */
			Instance.Popup.enter({
                title: FBID_SEARCH,
                message: SID_NO_RESULTS_FOUND_MSG,
                buttons: [{	 caption: SID_OK,	value: true }]
            }, function(){});
		}
	}
	
	// Update main menu refer to friend group
	function updateMenu(pFriendGroup) {
		//FBTrace("FriendsList :: updateMenu Start");
		var arrChildren = [];
		arrChildren.push(
			{
				id : Facebook.Define.Menu.FRIENDS_LIST
				, caption : SID_FRIENDS_LIST
				, instance : _this_
				, params : strCurUser
				, icon : "catagory_icon8.png"
			}
		);
		for (var flid in pFriendGroup) {
			arrChildren.push(
			{
				id : flid
				, caption : pFriendGroup[flid].name
				, instance : _this_
				, params : strCurUser
				, option : flid
				, icon : null
			}
			);
		}
		Instance.Frame.updateMenu(Facebook.Define.Menu.FRIENDS, arrChildren);
		//FBTrace("FriendsList :: updateMenu End");
             /* Start Interactive Device */		
        	 for(var i=1; i<arrChildren.length; i++){
           		GroupListNames[i] = arrChildren[i].caption;
       		 }
      		 iRemoteFB.onLoadFriends(GroupListNames);
             /* End Interactive Device */
	}
}