function FriendsListData() {
	var userID = "";
    var completeFn = null;

	var objProfile = {};
	var objFriendsGroup = {};
	var arrFriendsList = [];
	
    this.request = function(pUserID, pCompleteFn){
		userID = pUserID;
		Instance.Loading.open();
         /* Start Interactive Device */
        iRemoteFB.showLoading("Loading Data");
         /* End Interactive Device */
        completeFn = pCompleteFn;
        
        var strMultiQuery = '{\"friendsList\": \"SELECT flid,name FROM friendlist WHERE owner='+userID+'\" ,\"members\" : \"SELECT flid, uid FROM friendlist_member WHERE flid IN (SELECT flid FROM #friendsList)\",\"friends\" : \"SELECT uid2 FROM friend WHERE uid1 = '+pUserID+'\",\"profile\" : \"SELECT uid, name, pic_square FROM user WHERE uid IN (SELECT uid2 FROM #friends)\"}';
		
        Instance.API.fql.multiquery(function(pXMLHttpRequest){
            DataOnComplete(pXMLHttpRequest);
        }, Instance.API.createAPIParams({
            queries: strMultiQuery,
            format: "JSON"
        }));
        
    }
	
	this.getGroup = function(pFlid) {
		if (pFlid) {
			return objFriendsGroup[pFlid];
		} else {
			return objFriendsGroup;
		}
	}
    
	this.getList = function() {
		if (arrFriendsList.length > 0) {
			return arrFriendsList;			
		} else {
			return false;
		}
	}
	
	/*
	 * objFriend = {
	 * 		uid : String,
	 * 		name : String,
	 * 		pic_square : URL
	 * }
	 * 
	 * arrFriendsList = [objFriend]
	 * 
	 * objFriendsGroup = {
	 *		flid : {
	 * 			flid : String,
	 * 			name : String,
	 * 			arrMember : Array[objFriend]	 
	 *		}
	 * }
	 */
    function DataOnComplete(pXMLHttpRequest){
		
        if (!Instance.Main.checkNetworkError(pXMLHttpRequest)) return;
		
        //FBTrace(pXMLHttpRequest.responseText);
        var objResponse = Util.DecodeJSON(pXMLHttpRequest.responseText);

		objProfile = {};
		arrFriendsList = [];
		objFriendsGroup = {};
		
		var profile = objResponse[3].fql_result_set;
		var profileLength = profile.length;
		for (var profileIdx = 0; profileIdx < profileLength; profileIdx++) {
			objProfile[profile[profileIdx].uid] = profile[profileIdx];
			if (objProfile[profile[profileIdx].uid].pic_square == "") {
				objProfile[profile[profileIdx].uid].pic_square = "http://static.ak.fbcdn.net/pics/q_silhouette.gif";
			}
			if (objProfile[profile[profileIdx].uid].name == "") {
				objProfile[profile[profileIdx].uid].name = "Unknown";
			}			
		}

		// Need sorting
		var allList = objResponse[0].fql_result_set;
		var allListLength = allList.length;
		for (var allListIdx = 0; allListIdx < allListLength; allListIdx++) {
			if (objProfile[allList[allListIdx].uid2]) {
				arrFriendsList.push(objProfile[allList[allListIdx].uid2]);
			}
		}
		
		var list = objResponse[1].fql_result_set;

		var listLength= list.length;
		for (var listIdx = 0; listIdx < listLength; listIdx++) {
			objFriendsGroup[list[listIdx].flid] = {
				flid : list[listIdx].flid,
				name : list[listIdx].name,
				arrMember : []
			};
		}

		var member =  objResponse[2].fql_result_set;
		var memberLength = member.length;
		for (var memberIdx = 0; memberIdx < memberLength; memberIdx++) {
			objFriendsGroup[member[memberIdx].flid].arrMember.push(objProfile[member[memberIdx].uid]);
		}
		
		Instance.Loading.close();
        iRemoteFB.hideLoading();
        completeFn(arrFriendsList, objFriendsGroup);
    }
}

var TestObj = [{
    "name": "friends",
    "fql_result_set": [{
        "uid2": "1338864027"
    }, {
        "uid2": "1751224175"
    }, {
        "uid2": "100000093206056"
    }, {
        "uid2": "100000149258605"
    }, {
        "uid2": "100000195664421"
    }, {
        "uid2": "100000197718769"
    }, {
        "uid2": "100000442577032"
    },{
        "uid2": "13388640271"
    }, {
        "uid2": "17512241751"
    }, {
        "uid2": "1000000932060561"
    }, {
        "uid2": "1000001492586051"
    }, {
        "uid2": "1000001956644211"
    }, {
        "uid2": "1000001977187691"
    }, {
        "uid2": "1000004425770321"
    }]
}, {
    "name": "friendsList",
    "fql_result_set": [{
        "flid": "113773545302564",
        "name": "\uce5c\uad6c"
    }, {
        "flid": "113170188696233",
        "name": "Test List"
    }, {
        "flid": "113170108696241",
        "name": "Test List"
    }, {
        "flid": "101331913213394",
        "name": "BF"
    }, {
        "flid": "101330609880191",
        "name": "Samsung"
    }, {
        "flid": "101330579880194",
        "name": "Friends"
    }]
}, {
    "name": "members",
    "fql_result_set": [{
        "flid": "113773545302564",
        "uid": "100000197718769"
    }, {
        "flid": "113773545302564",
        "uid": "1338864027"
    }, {
        "flid": "101330579880194",
        "uid": "100000093206056"
    }]
}, {
    "name": "profile",
    "fql_result_set": [{
        "name": "EoHyung Lee",
        "uid": 1338864027,
        "pic_square": "http:\/\/profile.ak.fbcdn.net\/hprofile-ak-sf2p\/hs267.snc3\/23092_1338864027_8391_q.jpg"
    }, {
        "name": "Seungho Park",
        "uid": 1751224175,
        "pic_square": "http:\/\/profile.ak.fbcdn.net\/v226\/530\/106\/q1751224175_5939.jpg"
    }, {
        "name": "Widget Samsung",
        "uid": 100000093206056,
        "pic_square": null
    }, {
        "name": "Doremi Kang",
        "uid": 100000149258605,
        "pic_square": "http:\/\/profile.ak.fbcdn.net\/v226\/286\/118\/q100000149258605_8765.jpg"
    }, {
        "name": "Yeonho Kim",
        "uid": 100000195664421,
        "pic_square": "http:\/\/profile.ak.fbcdn.net\/v222\/1552\/35\/q100000195664421_222.jpg"
    }, {
        "name": "\uc11c\ucc3d\uad50",
        "uid": 100000197718769,
        "pic_square": null
    }, {
        "name": "Seo Changkyo",
        "uid": 100000442577032,
        "pic_square": "http:\/\/profile.ak.fbcdn.net\/v223\/23\/9\/q100000442577032_9754.jpg"
    },{
        "name": "EoHyung Lee",
        "uid": 13388640271,
        "pic_square": "http:\/\/profile.ak.fbcdn.net\/hprofile-ak-sf2p\/hs267.snc3\/23092_1338864027_8391_q.jpg"
    }, {
        "name": "Seungho Park",
        "uid": 17512241751,
        "pic_square": "http:\/\/profile.ak.fbcdn.net\/v226\/530\/106\/q1751224175_5939.jpg"
    }, {
        "name": "Widget Samsung",
        "uid": 1000000932060561,
        "pic_square": null
    }, {
        "name": "Doremi Kang",
        "uid": 1000001492586051,
        "pic_square": "http:\/\/profile.ak.fbcdn.net\/v226\/286\/118\/q100000149258605_8765.jpg"
    }, {
        "name": "Yeonho Kim",
        "uid": 1000001956644211,
        "pic_square": "http:\/\/profile.ak.fbcdn.net\/v222\/1552\/35\/q100000195664421_222.jpg"
    }, {
        "name": "\uc11c\ucc3d\uad50",
        "uid": 1000001977187691,
        "pic_square": null
    }, {
        "name": "Seo Changkyo",
        "uid": 1000004425770321,
        "pic_square": "http:\/\/profile.ak.fbcdn.net\/v223\/23\/9\/q100000442577032_9754.jpg"
    }]
}]

