function Info(pViewInstance, pDataInstance, pReturnFn) {
	_this_ = this;
	
	var iView = pViewInstance;
	var iData = pDataInstance;
	var returnFn = pReturnFn;
	
	var objPages = [];
	var nTotalPages = 0;
	var nCurPage = 0;

	var TYPE_CATEGORY = 0;
	var TYPE_ITEM = 1;

	var bOpened = false;
	var bReady = false;
    
	this.isOpened = function(){
        return bOpened;
    }
    
	this.isReady = function(){
        return bReady;
    }
	
	// External Interface
	this.open = function(pUserID) {
//		FBTrace("Info Open Start");
		bOpened = true;
		
		iView.show();
		iData.request(pUserID, OnLoadData);
//		FBTrace("Info Open End");
	}
	
	this.close = function() {
//		FBTrace("Info Close Start");
		bOpened = false;
		bReady = false;
		
		iView.clear();
		iView.hide();
//		FBTrace("Info Close End");
	}
	
	this.enter = function() {
		if (!bReady) {			
		returnFn(); return; }
		
		Instance.Main.registHelpNavi(generateHelpNavi(),"Info");
		Instance.Main.setKeyHandler(keyHandler,"Info");

		iView.focus();
	}
	
	function generateHelpNavi() {
		var arrHelp = [];
		arrHelp[arrHelp.length] = {	image : HelpArea.Image.Return,	text : SID_RETURN	};
		return arrHelp;
	}
	
	function OnLoadData(pInfo) {
		if (!bOpened) return;

		generatePage(pInfo);
		iView.request(objPages, eventHandler);
         	/* Start Interactive Device */
        	showDetails(objPages);
        	 /* End Interactive Device */
	}
    /* Start Interactive Device */
	 function showDetails(PageInfolist){   
	 	iRemoteFB.globalInfo = PageInfolist;	
		if(iRemoteFB.menuFlag == 1){	
			setTimeout(function(){				
				iMenu.enter();
				iRemoteFB.menuFlag = 0;		
			},150);
		}
			
    }
	this.setbReady = function(readyFlag){
		bReady = readyFlag;
	}
	
     /* End Interactive Device */
	function eventHandler(pEvent) {
		switch(pEvent) {
			case Info.Define.NO_SCROLL :
				bReady = false; 
				break;
			case Info.Define.SCROLL :
				bReady = true;
				break;
			default:
				break;
		}
	}
	
	function generatePage(pData) {
		var categoryLength = pData.length;
		var itemLength = 0;
		var tItems = null;
		var nPage = 0;
		var dataLength = 0;
		var nItemPerPage = 14;
		
		objPages = [];

		for (var categoryIdx = 0; categoryIdx < categoryLength; categoryIdx++) {
			tItems = pData[categoryIdx].items
			itemLength = tItems.length;
			objPages.push({
				type : TYPE_CATEGORY,
				title: pData[categoryIdx].caption,
			});
			for (var itemIdx = 0; itemIdx < itemLength; itemIdx++) {
				if (tItems[itemIdx].data instanceof Array) {
					objPages.push({
						type : TYPE_ITEM,
						title: tItems[itemIdx].caption,
						content: tItems[itemIdx].data[0],
						linefeed : tItems[itemIdx].linefeed ? true : false
					});
					dataLength = tItems[itemIdx].data.length;
					for (var dataIdx = 1; dataIdx < dataLength; dataIdx++) {
						if (tItems[itemIdx].data[dataIdx]) {
							objPages.push({
								type: TYPE_ITEM,
								title: "",
								content: tItems[itemIdx].data[dataIdx],
								linefeed : tItems[itemIdx].linefeed ? true : false
							});
						}
					}
				} else {
					if (tItems[itemIdx].caption && tItems[itemIdx].data) {
						objPages.push({
							type: TYPE_ITEM,
							title: tItems[itemIdx].caption,
							content: tItems[itemIdx].data,
							linefeed : tItems[itemIdx].linefeed ? true : false
						});
					}
				}
			}
		}
	}
	
	function keyHandler(pKeyCode) {
		switch(pKeyCode) {
			case TV.KEY_RIGHT :
			case TV.KEY_PANEL_VOL_DOWN :
				break;
			case TV.KEY_LEFT :
			case TV.KEY_PANEL_VOL_UP :
				iView.blur();
				/* Start Interactive Device */
				if (Instance.Frame.getType() == FacebookFrame.Define.ME) {
					iRemoteFB.onLoadFacebook();
				}
				iRemoteFB.onLoadProfile();
				/*End Interactive Device */
				returnFn();
				break;
			case TV.KEY_UP :
			case TV.KEY_WHEELUP :
			case TV.KEY_PANEL_CH_UP :
				iView.scrollUp();
				break;
			case TV.KEY_DOWN :
			case TV.KEY_WHEELDOWN :
			case TV.KEY_PANEL_CH_DOWN :
				iView.scrollDown();
				break;
			case TV.KEY_FF :
				break;
			case TV.KEY_RW :
				break;				
			case TV.KEY_ENTER :
				iView.focus();
				break;
			case TV.KEY_RETURN : 
				iView.blur();
				/*Start Interactive Device */
				if (Instance.Frame.getType() == FacebookFrame.Define.ME) {
					iRemoteFB.onLoadFacebook();
				}
				iRemoteFB.onLoadProfile();
				/*End Interactive Device */				
				returnFn();
				break;
			case TV.KEY_RED :

			default :
				break;
		}
		return true;
	}
}

Info.Define = {};
Info.Define.NO_SCROLL = 10;
Info.Define.SCROLL = 11;