function InfoData() {
	var userID = "";
    var completeFn = null;
	
	var arrInfo = null;
	
    this.request = function(pUserID, pCompleteFn){
		userID = pUserID;
		Instance.Loading.open();
        /* Start Interactive Device */
        iRemoteFB.showLoading("Loading Data");
        /* End Interactive Device */
        completeFn = pCompleteFn;

		// Object Initialize
		arrInfo = [{
			caption : SID_BASIC_INFORMATION,
			items : [
				{	id : "sex",							caption : SID_SEX,								data : ""	},
				{	id : "birthday",					caption : SID_BIRTHDAY,						data : ""	},
				{	id : "hometown",				caption : SID_HOMETOWN,					data : ""	},
				{	id : "family",						caption : SID_FAMILY_MEMBERS,			data : ""	},
				{	id : "relationship_status",	caption : FBID_RELATIONSHIP_STATUS,	data : ""	},
				{	id : "interested_in",			caption : SID_INTERESTED_IN,				data : ""	},				
				{	id : "looking_for",				caption : SID_LOOKING_FOR,				data : ""	},				
				{	id : "political",					caption : SID_POLITICAL_VIEWS,			data : ""	},				
				{	id : "religious",					caption : FBID_RELIGIOUS_VIEWS,			data : ""	},				
			]
		},{
			caption : SID_PERSONAL_INFORMATION,
			items : [
				{	id : "activities",		caption : FBID_ACTIVITIES_CL,						data : ""	},
				{	id : "interests",		caption : FBID_INTERESTS_CL,						data : ""	},
				{	id : "music",			caption : SID_FAVORITE_MUSIC,				data : ""	},
				{	id : "tv",				caption : SID_FAVORITE_TV_SHOWS,			data : ""	},
				{	id : "movies",		caption : SID_FAVORITE_MOVIES,				data : ""	},
				{	id : "books",			caption : SID_FAVORITE_BOOKS,				data : ""	},
				{	id : "quotes",			caption : SID_FAVORITE_QUOTATIONS,	data : ""	},
				{	id : "about_me",	caption : IDWS_MOIP_ABOUT_ME,						data : ""	}
			]
		},{
			caption : SID_EDUCATION_INFO,
			items : [
				{	id : "college",				caption : SID_COLLEGE_UNIVERSITY,	data : ""	},
				{	id : "highschool",		caption : SID_HIGH_SCHOOL,				data : ""	},
				{	id : "employer",			caption : FBID_EMPLOYER_CL,					data : "",				linefeed : true		},
				{	id : "position",			caption : SID_POSITION_IMPORTANCE,						data : ""	},
				{	id : "time_reriod",		caption : SID_TIME_PERIOD,				data : ""	},
				{	id : "location",			caption : SID_ADDRESS,						data : ""    },
				{	id : "description",		caption : SID_DESCRIPTION,				data : ""	}
			]
		}
	];


        
        Instance.API.users.getInfo(function(pXMLHttpRequest){
            OnLoadData(pXMLHttpRequest);
        }, Instance.API.createAPIParams({
            fields: "uid, about_me, activities, affiliations, birthday, books, current_location, education_history, first_name, hometown_location, hs_info, interests, is_app_user, last_name, locale, meeting_for, meeting_sex, movies, music, name, notes_count, pic, pic_with_logo, pic_big, pic_big_with_logo, pic_small, pic_small_with_logo, pic_square, pic_square_with_logo, political, profile_blurb, profile_update_time, profile_url, quotes, relationship_status, religion, sex, significant_other_id, status, timezone, tv, wall_count, website, work_history, family",
            uids: pUserID,
            format: "JSON"
//            format: "XML"
        }));
        
    }
    function OnLoadData(pXMLHttpRequest){
		
        if (!Instance.Main.checkNetworkError(pXMLHttpRequest)) return;
		
        var objResponse = Util.DecodeJSON(pXMLHttpRequest.responseText);
		objResponse = objResponse[0];
		
		var categoryLength = arrInfo.length;
		var itemLength = 0;
		var tItems = null;
		
		for (var categoryIdx = 0; categoryIdx < categoryLength; categoryIdx++) {
			tItems = arrInfo[categoryIdx].items
			itemLength = tItems.length;
			for (var itemIdx = 0; itemIdx < itemLength; itemIdx++) {
				assignValue(tItems[itemIdx]);
			}
		}
		
		Instance.Loading.close();
        iRemoteFB.hideLoading();
        completeFn(arrInfo);
			
		function assignValue(pItem) {
			switch(pItem.id) {
				case 'sex' : 
					pItem.data = toString(objResponse.sex);
					break;
				case 'birthday' : 
					pItem.data = toString(objResponse.birthday);
					break;
				case 'hometown' : 
					if (typeof(objResponse.hometown_location) == "object") {
						pItem.data = Util.getObjectValues(objResponse.hometown_location);
					}
					break;
				case 'family' :
					pItem.data = [];
					if (objResponse.family instanceof Array) {
						var itemLength = objResponse.family.length;
						for (var itemIdx = 0; itemIdx < itemLength; itemIdx++) {
							pItem.data.push(objResponse.family[itemIdx].relationship + " " + objResponse.family[itemIdx].name);
						}
					}
					break;
				case 'relationship_status' : 
					pItem.data = toString(objResponse.relationship_status);
					break;
				case 'interested_in' : 
					pItem.data = toString(objResponse.meeting_sex);
					break;
				case 'looking_for' : 
					pItem.data = toString(objResponse.meeting_for);
					break;
				case 'political' : 
					pItem.data = toString(objResponse.political);
					break;			
				case 'religious' : 
					pItem.data = toString(objResponse.religion);
					break;
				case 'activities' : 
					pItem.data = toString(objResponse.activities);
					break;
				case 'interests' : 
					pItem.data = toString(objResponse.interests);
					break;
				case 'music' : 
					pItem.data = toString(objResponse.music);
					break;
				case 'tv' : 
					pItem.data = toString(objResponse.tv);
					break;
				case 'movies' : 
					pItem.data = toString(objResponse.movies);
					break;
				case 'books' : 
					pItem.data = toString(objResponse.books);
					break;
				case 'quotes' : 
					pItem.data = toString(objResponse.quotes);
					break;
				case 'about_me' : 
					pItem.data = toString(objResponse.about_me);
					break;
				case 'college' : 
					if (objResponse.education_history instanceof Array) {
						var itemLength = objResponse.education_history.length;
						pItem.data = [];
						for (var itemIdx = 0; itemIdx < itemLength; itemIdx++) {
							pItem.data.push(Util.getObjectValues(objResponse.education_history[itemIdx]));
						}
					}
					break;
				case 'highschool' : 
					if (objResponse.hs_info) {
						pItem.data = toString(objResponse.hs_info.hs1_name);
					}
					break;
				case 'employer' : 
					if (objResponse.work_history instanceof Array && objResponse.work_history.length > 0) {
						pItem.data = toString(objResponse.work_history[0].company_name);
					}
					break;
				case 'position' : 
					if (objResponse.work_history instanceof Array && objResponse.work_history.length > 0) {
						pItem.data = toString(objResponse.work_history[0].position);
					}
					break;
				case 'time_reriod' : 
					if (objResponse.work_history instanceof Array && objResponse.work_history.length > 0) {
						if (objResponse.work_history[0].start_date && objResponse.work_history[0].end_date) {
							pItem.data = toString(objResponse.work_history[0].start_date.replace('-','/')) + " - " + toString(objResponse.work_history[0].end_date.replace('-','/'));
						}
						else 
							if (objResponse.work_history[0].start_date && objResponse.work_history[0].start_date != "0000-00") {
								pItem.data = toString(SID_MIX_TO_PRESENT.Replace(objResponse.work_history[0].start_date.replace('-','/')));
							}
							else 
								if (objResponse.work_history[0].end_date) {
									pItem.data = " - " + toString(objResponse.work_history[0].end_date.replace('-','/'));
								}
					}
					break;
				case 'location' : 
					if (objResponse.work_history instanceof Array && objResponse.work_history.length > 0) {
						pItem.data = Util.getObjectValues(objResponse.work_history[0].location);
					}
					break;
				case 'description' : 
					if (objResponse.work_history instanceof Array && objResponse.work_history.length > 0) {
						pItem.data = toString(objResponse.work_history[0].description);
					}
					break;						
			}
		}
		
		function toString(pArg) {
			if (typeof(pArg) == "string") {
				return pArg;
			} {
				return "";
			}
		}
		
    }
}
