CTools.Define = {
	SOUND_SETTING : 0,
	PICTURE_SETTING : 1,
	SID_ALBUMS_ : 2
}

function CTools (strName) {
	strName = (strName === undefined) ? 'Slideshow' : strName;
	var WIDGET = new Common.API.Widget();
	var TVKEY = new Common.API.TVKeyValue();
	
	var iMenu = new CTools.Menu('iMenu');
	var iView = new CTools.View('iView');
	
	var eAnchor = null;
	var _THIS_ = this;

	var fnOnReturn = null;

	var arrMenuInfo = [];
    var nCurMenu = 0;
	
	this.open = function (fn) {
		alert(strName + ' : open()');
		_THIS_.show();
		iView.highlight(nCurMenu);
		fnOnReturn = fn;
	}
	this.close = function () {
		alert(strName + ' : close()');
		// [DMS00741449]
		// handling video end event.
		arrMenuInfo[nCurMenu].destroy();
		//
		_THIS_.hide();
		if (fnOnReturn) {
			fnOnReturn();
			fnOnReturn = null;
		}
		// initialize
		iView.blur(nCurMenu);
		nCurMenu = 0;
	}
	this.show = function () {
		alert(strName + ' : show()');
		iView.show();
		setTimer(true);
	}
	this.hide = function () {
		alert(strName + ' : hide()');
		iView.hide();
		setTimer(false);
	}
	this.setCallInfo = function (CallInfo) {
		alert(strName + ' : setCallInfo()');
		iMenu.setCallInfo(CallInfo);
	}
	this.focus = function (fn) {
		alert(strName + ' : focus()');
		if (eAnchor == null) {
			// insert anchor
			var divId = "_for_CTools_anchor_";
			var divNode = document.createElement("div");
			divNode.id = divId;
			document.body.appendChild(divNode);
			
			document.getElementById(divId).innerHTML = '<a href="javascript:void(0);" id="_CTools_anchor_"></a>';
			eAnchor = document.getElementById('_CTools_anchor_');
			eAnchor.addEventListener('onkeydown', function(){
				keyHandler();
			});
		}
		eAnchor.focus();
	}
	this.getKeyHandler = function () {
		return function (keyCode) {
			keyHandler(keyCode);
		}
	}
	this.addMenu = function (defMenu)  {
		alert(strName + ' : addMenu('+defMenu+')');
		var valid = false;
		for (var attr in CTools.Define) {
			if (CTools.Define[attr] == defMenu) {
				valid = true;
				break;
			}
		}
		if (!valid) {
			alert(defMenu + ' is not defined.');
			return;
		}
		
		var iMenuInfo = iMenu.getMenuInfo(defMenu);
		arrMenuInfo.push(iMenuInfo);
		iView.addMenu(iMenuInfo);
	}
	function keyHandler (keyCode) {
		keyCode = (keyCode === undefined) ? event.keyCode : keyCode;
		alert(strName + ' : keyHandler('+keyCode+')');
		setTimer(true);
		switch (keyCode) {
			case TVKEY.KEY_LEFT:
			case TVKEY.KEY_PANEL_VOL_DOWN:
				break;
				
			case TVKEY.KEY_RIGHT:
			case TVKEY.KEY_PANEL_VOL_UP:
				break;
				
			case TVKEY.KEY_UP:
			case TVKEY.KEY_WHEELUP:
			case TVKEY.KEY_PANEL_CH_UP:
				if (arrMenuInfo.length == 1) return;
				iView.blur(nCurMenu);
				if (--nCurMenu < 0) {
					nCurMenu = arrMenuInfo.length - 1;
				}
				iView.highlight(nCurMenu);
				break;
				
			case TVKEY.KEY_DOWN:
			case TVKEY.KEY_WHEELDOWN:
			case TVKEY.KEY_PANEL_CH_DOWN:
				if (arrMenuInfo.length == 1) return;
				iView.blur(nCurMenu);
				if (++nCurMenu > arrMenuInfo.length - 1) {
					nCurMenu = 0;
				}
				iView.highlight(nCurMenu);
				break;
				
			case TVKEY.KEY_ENTER:
			case TVKEY.KEY_PANEL_ENTER:
			case TVKEY.KEY_PANEL_SOURCE:
				if (arrMenuInfo[nCurMenu] && arrMenuInfo[nCurMenu].onEnter) {
					arrMenuInfo[nCurMenu].onEnter(_THIS_);
				}
				break;
				
			case TVKEY.KEY_RETURN:
			case TVKEY.KEY_PANEL_MENU:
			case TVKEY.KEY_TOOLS:
				_THIS_.close();
				break;
	
			case TVKEY.KEY_MENU:
				location.reload();
	            break;
		}
	}
	
	// auto hide
	var HIDE_TIME = 60000;
//	var HIDE_TIME = 3000;		// for test
	var timer = null;
	function setTimer (bOn) {
		if (timer != null) {
			clearTimeout (timer);
			timer = null;
		}
		if (bOn) {
			timer = setTimeout(function(){
				timeOver();
			}, HIDE_TIME);
		}
	}
	function timeOver () {
		_THIS_.close();
	}
	
	// for unique div id
	CTools.nInstance++;
}

// Tools popup view
CTools.View = function (strName, strTitle) {
	strName = (strName === undefined) ? 'View' : strName;
	var _THIS_ = this;
	var bFinish = false;		// is all menu added?
	
	var curTop = 0;
	var height = 36;
	
	// element ID
	var strBaseId = '_for_CTools_'+CTools.nInstance+'_';
	var strBgId = strBaseId+'bg_';
	var strTitleId = strBaseId+'title_';
	var strHelpBarId = strBaseId+'helpbar_';
	var strContentsId = strBaseId+'contents_';
	var strNameDivId = strBaseId+'name_';
	var strHighlightDivId = strBaseId+'highlight_';
	
	// BG info
	// [100329] popup size fixed. (3 lines)
	var arrBgInfo = [
		{ left: '246', top: '156', width: '467', height: '227', image: 'Resource/images/keypad_popup1.png'}		// 3 Menu
	];
	
	var contents = '';
	var arrMenuElement = [];
	var nMenuNumber = 0;
	var bFinish = false;
	
	// create base div
	var divNode = document.createElement("div");
	divNode.id = strBaseId;
	document.body.appendChild(divNode);
	
	var eFrame = document.getElementById(strBaseId);
	
	// for dim layer
//	eFrame.style = 'position:absolute;left:0px;top:0px;width:960px;height:540px;background:url(Resource/images/popup_blackbg.png);z-index:10;border:1px solid #ff0000;';
	eFrame.style.position = 'absolute';
	eFrame.style.left = '0px';
	eFrame.style.top = '0px';
	eFrame.style.width = '960px';
	eFrame.style.height = '540px';
	eFrame.style.background = 'url(Resource/images/popup_blackbg.png)';
	eFrame.style.display = 'none';
	eFrame.style.zIndex = 10;
	
	this.highlight = function (nIdx) {
		alert(strName + ' : highlight('+nIdx+')');
		if (arrMenuElement[nIdx]) {
//			arrMenuElement[nIdx].name.style.color = '#6e2eb2';
			arrMenuElement[nIdx].highlight.style.backgroundImage = 'url(Resource/images/tools_highlight.png)';
		}
		else {
			alert(nIdx + 'th menu was not created.');
		}
	}
	this.blur = function (nIdx) {
		alert(strName + ' : blur('+nIdx+')');
		if (arrMenuElement[nIdx]) {
//			arrMenuElement[nIdx].name.style.color = '#434343';
			arrMenuElement[nIdx].highlight.style.backgroundImage = '';
		}
		else {
			alert(nIdx + 'th menu was not created.');
		}
	}
	this.show = function () {
		alert(strName + ' : show()');
		if (!bFinish) {
			finish();
			bFinish = true;
		}
		eFrame.style.display = 'block';
	}
	this.hide = function () {
		alert(strName + ' : hide()');
		eFrame.style.display = 'none';
	}
	this.addMenu = function (iMenuInfo) {
		alert(strName + ' : addMenu()');
		
		contents += '<div id="'+strHighlightDivId+nMenuNumber+'" style="position:absolute;left:0px;top:'+curTop+'px;width:417px;height:33px;"></div>';
		contents += '<div id="'+strNameDivId+nMenuNumber+'" style="position:absolute;left:12px;top:'+(curTop+8)+'px;font-size:16px;color:#434343;">'+iMenuInfo.name+'</div>';
		
		curTop += height;
		nMenuNumber++;
	}
	function finish () {
		// generate bg, title, contents base, help div
		var BgInfo = getBgInfo();
		var strHTML = '';
		strHTML += '<div id="'+strBgId+'" style="position:absolute;left:'+BgInfo.left+'px;top:'+BgInfo.top+'px;width:'+BgInfo.width+'px;height:'+BgInfo.height+'px;background-image:url('+BgInfo.image+');">';
		strHTML += '<div id="'+strTitleId+'" style="position:absolute;left:15px;top:27px;width:437px;text-align:center;font-size:16px;color:#FFFFFF;">'+SID_TOOLS+'</div>';
		strHTML += '<div id="'+strContentsId+'" style="position:absolute;left:26px;top:60px;">'+contents+'</div>';
//		strHTML += '<img src="Resource/images/picasa_popup_bg_line.png" style="position:absolute;left:19px;bottom:45px;"></div>';
		strHTML += '<div id="'+strHelpBarId+'" style="position:absolute;right:30px;bottom:17px;width:326px;height:28px;font-size:16px;font-weight:bolder;color:#434343;text-align:right;">'+getHelpContents()+'</div>';
		strHTML += '</div>';
		eFrame.innerHTML = strHTML;
		
		for (var i=0; i < nMenuNumber; i++) {
			arrMenuElement.push({
				name: document.getElementById(strNameDivId + i),
				highlight: document.getElementById(strHighlightDivId + i)
			});
		}
		
		function getBgInfo () {
			var retValue = null;
			switch (nMenuNumber) {
				case 1:
				case 2:
					retValue = arrBgInfo[0];
					break;
				default:
					retValue = arrBgInfo[0];
					break;
			}
			alert(strName + ' : getBgInfo() returns ' + retValue.image);
			return retValue;
		}
		function getHelpContents () {
			// It need only return
			var strHTML = '';
			strHTML += '<table cellspacing="0px" cellpadding="0px">';
			strHTML += '<tr>';
			strHTML += '<td style="vertical-align:middle;line-height:28px;"><img src="Resource/images/viewmode_backicon.png" style="width:28px;height:28px;"/></td>';
			strHTML += '<td style="">'+SID_RETURN+'</td>';
			strHTML += '</tr>';
			strHTML += '</table>';
			return strHTML;
		}
	}
}

// Menu contents generator
CTools.Menu = function (strName) {
	strName = (strName === undefined) ? 'Menu' : strName;
	
	var _THIS_ = this;
	var PLUGIN = new Common.API.Plugin();
	var arrMenuInfo = [];
	var CallInfo = null;
	
	this.getMenuInfo = function (defMenu) {
		var retValue = arrMenuInfo[defMenu];
		alert(strName + ' : getMenuInfo() returns ' + retValue.name);
		return retValue;
	}
	this.setCallInfo = function (info) {
		alert(strName + ' : setCallInfo()');
		if (!CallInfo) CallInfo = {};
		for (var name in info) {
			CallInfo[name] = info[name];
		}
	}
	
	function MenuInfo (strName) {
		this.name = strName;
		this.bActivate = false;
		this.onEnter = function () {};
		this.isActivate = function () {};
		this.destroy = function () {};
	}
	
	var iMenuInfo = null;
	
	// Picture Setting
	iMenuInfo = new MenuInfo (SID_PICTURE_SETTING);
	iMenuInfo.onEnter = function (iTools) {
		iTools.hide();
		showTools(CTools.Define.PICTURE_SETTING, function(){
			iTools.show();
		});
	}
	iMenuInfo.isActivate = function (iTools) {
		this.bActivate = true;
		return true;	// always activated
	}
	iMenuInfo.destroy = function (iTools) {
		hideTools();
	}
	arrMenuInfo[CTools.Define.PICTURE_SETTING] = iMenuInfo;
	
	// Sound Setting
	iMenuInfo = new MenuInfo (SID_SOUND_SETTING);
	iMenuInfo.onEnter = function (iTools) {
		iTools.hide();
		showTools(CTools.Define.SOUND_SETTING, function(){
			iTools.show();
		});
	}
	iMenuInfo.isActivate = function (iTools) {
		this.bActivate = true;
		return true;	// always activated
	}
	iMenuInfo.destroy = function (iTools) {
		hideTools();
	}
	arrMenuInfo[CTools.Define.SOUND_SETTING] = iMenuInfo;
	
	// Facebook Album
	iMenuInfo = new MenuInfo (SID_ALBUMS_);
	iMenuInfo.onEnter = function (iTools) {
		iTools.close();
		// 현재 화면에서 벗어나서 Album 보여주는 화면으로 고고싱
		CallInfo.caller.close();

		switch(CallInfo.callerFrom) {
			case Facebook.Define.Stream :
				if (Instance.Main.getLoginID() != CallInfo.photoOwner) {
                    Instance.Frame.open(CallInfo.photoOwner, Facebook.Define.Menu.PHOTOS, {
						data : CallInfo.callerPhotoSource
					});
				} else {
					Instance.Frame.go(Facebook.Define.Menu.PHOTOS,{
						data : CallInfo.callerPhotoSource
					});
				}
				break;
			case Facebook.Define.PhotoList :
				CallInfo.fnOnRetun(Facebook.Define.GoAlbum);
				break;
			default : 
				break;
		}
	}
	iMenuInfo.isActivate = function (iTools) {
		this.bActivate = true;
		return true;	// always activated
	}
	arrMenuInfo[CTools.Define.SID_ALBUMS_] = iMenuInfo;
	
	function showTools (defMode, fnOnClose) {
		alert(strName + ' : showTools('+defMode+')');
		PLUGIN.ShowTools(defMode);
		curWidget.onWidgetEvent = fnOnClose;
	}
	function hideTools () {
		alert(strName + ' : hideTools()');
		PLUGIN.HideTools();
		curWidget.onWidgetEvent = function () {};
	}
}

CTools.nInstance = 0;