function PhotoAlbum(pViewInstance, pDataInstance, pReturnFn) {
	var _this_ = this;
	var iView = pViewInstance;	
	var iData = pDataInstance;
	var returnFn = pReturnFn;
	
	var objPages = [];
	
	// [100315] changed design
	var nRow = 2, nCol = 4;
	var iFocus = new FocusMapper("PhotoAlbum",nRow, nCol);
	
	var iPhotoList = new PhotoList(new PhotoListView(_$("facebookPhotoListDiv")),new PhotoListData(),returnAlbumFn);
	
	var bOpened = false;
	var bReady = false;
	
	var shortCutFlag = false;
	var shortCutObject = null;	
    
	this.isOpened = function(){
        return bOpened;
    }
    
	this.isReady = function(){
        return bReady;
    }
	
	// External Interface
	this.open = function(pUserID) {
//		FBTrace("Photo Open Start");
		bOpened = true;

		iView.show();
		iData.request(pUserID, OnLoadData);
//		FBTrace("Photo Open Close");
	}
	
	this.close = function() {
//		FBTrace("Photo Close Start");
		bOpened = false;
		bReady = false;

		iView.clear();
		iView.hide();
//		FBTrace("Photo Close End");
	}
	
	this.enter = function(pEvent, pShortCut) {
		if(pShortCut) {
			shortCutFlag = true;
			shortCutObject = pShortCut;
		}
		if (!bReady) {	 returnToMenuFn(); return; }
		
		Instance.Main.registHelpNavi(generateHelpNavi(),"PhotoAlbum");
		Instance.Main.setKeyHandler(keyHandler,"PhotoAlbum");
		
		switch(pEvent) {
			case Facebook.Define.Return :
				break;
			case Facebook.Define.ShortCut :
				findAlbum(shortCutObject.data.data.aid);
				iView.hide();
				iPhotoList.enter(objPages[iFocus.getFocus().page][iFocus.getFocus().row][iFocus.getFocus().col], shortCutObject.data.data.pid);
				break;
			default : 
				iFocus.resetFocus();
				break;
				
		}
		iView.focus(iFocus.getFocus());
	}

	function findAlbum(pAlbumID) {
		var nRow = 0;
		var nCol = 0;
		var nPages = objPages.length;
		for (var pIdx = 0; pIdx < nPages; pIdx++) {
			nRow = objPages[pIdx].length;
			for (var rIdx = 0; rIdx < nRow; rIdx++) {
				nCol = objPages[pIdx][rIdx].length;
				for (var cIdx = 0; cIdx < nCol; cIdx++) {
					if (objPages[pIdx][rIdx][cIdx].aid == pAlbumID) {
						iFocus.setFocus({ page: pIdx, row: rIdx, col: cIdx });
						requestPage(pIdx);
						return;
					}
				}
			}
		}
	}

	function generateHelpNavi() {
		var arrHelp = [];
		if (iFocus.getTotalPage() > 1) 
			arrHelp[arrHelp.length] = {	image: HelpArea.Image.FFRW, text: SID_PAGE_UP_DOWN };
		arrHelp[arrHelp.length] = {	image : HelpArea.Image.Return,	text : SID_RETURN			};
		return arrHelp;
	}

	function OnLoadData(pData) {
		if (!bOpened) return;
		if (pData) {
			//	In case there are albums
			bReady = true;
			generatePage(pData);
			iFocus.generate(objPages);
			requestPage(iFocus.getFocus().page);
		} else {
			//	In case there is no album
			/*Start Interactive Device */
			iRemoteFB.errormsgPopup(SID_NODATA);
			/*Start Interactive Device */
			bReady = false;
			iView.request(false);
		}
		if (shortCutFlag) {
			shortCutFlag = false;
			shortCutObject.callback();
			_this_.enter(Facebook.Define.ShortCut);
		}
	}
	
	function requestPage(pPage) {
		iFocus.setPage(pPage);		
		iView.request(objPages[iFocus.getFocus().page],iFocus);
        /*Start Interactive Device */
        showDetailsProfilePhoto(objPages, pPage);
        /*End Interactive Device */
	}
    /* Start Interactive Device */
    function   showDetailsProfilePhoto(remotepList, pageNum)
    {
             /*Start Interactive Device */
	    iRemoteFB.GlobalPhotoList = remotepList;
		iRemoteFB.GlobalPageNum = pageNum;
		if(iRemoteFB.menuFlag == 1){			
			iMenu.enter();	
			iRemoteFB.menuFlag = 0;
		}
	    /*End Interactive Device */
    }
	/* End Interactive Device */
	function generatePage(pData) {
		var dataLength = pData.length;
		var itemBuffer = [];
		var lineBuffer = [];
		var nPage = 0;
		objPages[nPage] = [];
		
		for (var dataIdx = 0; dataIdx < dataLength; dataIdx++) {
			if (itemBuffer.length >= nCol) {
				flushItem();
			}
			itemBuffer.push(pData[dataIdx]);
		}
		flushItem();
		flushLine();
		
		function flushItem() {
			if (lineBuffer.length >= nRow) {
				if (!(objPages[nPage] instanceof Array)) objPages[nPage]  = [];
				objPages[nPage++] = Util.copyArray(lineBuffer);
				lineBuffer = [];
			}
			lineBuffer.push(Util.copyArray(itemBuffer));
			itemBuffer = [];
		}
		
		function flushLine() {
			if (lineBuffer.length > 0) {
				if (!(objPages[nPage] instanceof Array)) objPages[nPage]  = [];
				objPages[nPage]= Util.copyArray(lineBuffer);
			}
		}
	}
	
    	IPhotoList = iPhotoList;
    
	function keyHandler(pKeyCode) {
		switch(pKeyCode) {
			case TV.KEY_RIGHT :
			case TV.KEY_PANEL_VOL_DOWN :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.right()) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_LEFT :
			case TV.KEY_PANEL_VOL_UP :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.left()) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				} else {
					iView.blur(iFocus.getFocus());
					 /*Start Interactive Device */
					if (Instance.Frame.getType() == FacebookFrame.Define.ME) {
						iRemoteFB.onLoadFacebook();
						
					}
					iRemoteFB.onLoadProfile();
					 /*End Interactive Device */
					returnToMenuFn();
				}
				break;
			case TV.KEY_UP :
			case TV.KEY_WHEELUP :
			case TV.KEY_PANEL_CH_UP :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.up()) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				} else {
					requestPage(iFocus.getFocus().page);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_DOWN :
			case TV.KEY_WHEELDOWN :
			case TV.KEY_PANEL_CH_DOWN :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.down()) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				} else {
					requestPage(iFocus.getFocus().page);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_FF :
				if (iFocus.nextPage(true)) {
					requestPage(iFocus.getFocus().page);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_RW :
				if (iFocus.prevPage(true)) {
					requestPage(iFocus.getFocus().page);
					iView.focus(iFocus.getFocus());
				}
				break;				
			case TV.KEY_ENTER :
				iView.hide();
				iPhotoList.enter(objPages[iFocus.getFocus().page][iFocus.getFocus().row][iFocus.getFocus().col]);
				break;
			case TV.KEY_RETURN : 
				// Return to main menu	
				iView.blur(iFocus.getFocus());
				 /*Start Interactive Device */
				if (Instance.Frame.getType() == FacebookFrame.Define.ME) {
					iRemoteFB.onLoadFacebook();
					
				}
				iRemoteFB.onLoadProfile();
				 /*End Interactive Device */
				returnToMenuFn();
				break;
			case TV.KEY_RED : 
				if (Instance.Frame.getType() != FacebookFrame.Define.ME) {
					_this_.close();
				}
				break;
			default :
				break;
		}
	}
	
	function returnAlbumFn(pType) {
		if (pType == Facebook.Define.Exit) {
			iView.show();
			iView.blur(iFocus.getFocus());
			returnToMenuFn();
		}
		else {
			iView.show();
			_this_.enter(Facebook.Define.Return);
		}
	}
	
	function returnToMenuFn() {
		if (iFocus.getCurrentPage() > 1) {
			iFocus.setPage(0);
			requestPage(iFocus.getFocus().page);
		}
		returnFn();
	}
}