function PhotoFull(pViewInstance, pDataInstance, pFocusMapper, pReturnFn) {
	var _this_ = this;
	var photoSource = null;
	var originalSource = null;
	
	var iView = pViewInstance;
	var iData = pDataInstance;

	var iStreamShare = new StreamShare(new StreamShareView(_$("facebookStreamShareDiv")),new StreamShareData(),returnListFn);

	var instanceState = Facebook.Define.None;

	var iFocus = pFocusMapper;
	
	// [DMS00740113] Divied for BD 
	// BD has no Picture/Sound Setting menu
	var iTools = new CTools('iTools');
	iTools.addMenu(CTools.Define.SID_ALBUMS_);
	if (Instance.Main.getManagerSetting().product != PL_TV_PRODUCT_TYPE_BD) {
		iTools.addMenu(CTools.Define.PICTURE_SETTING);
	}

	var returnFn = pReturnFn;

	// Caller Infomation
	var nCallFrom = 0;
	var strPhotoOwner = "";
	
	// External Interface
	this.open = function() {
		iView.show();
	}
	
	this.close = function() {
		Instance.Loading.close();
       	iRemoteFB.hideLoading();
		showHelpNavi(false);
		iView.hide();
	}
	
	this.enter = function(pSource) {
		nCallFrom = pSource.type;
		strPhotoOwner = pSource.actor_id;
		
		Instance.Main.registHelpNavi(generateHelpNavi(),"PhotoFull");
		Instance.Main.setKeyHandler(keyHandler,"PhotoFull");
		
		Instance.GMF.addEventListner(photoEventListner);

		photoSource = pSource;
		originalSource = pSource;
		
		switch(nCallFrom) {
			case Facebook.Define.Stream : 
				// pSource is PID
				/* Start Interactive Device */
				iRemoteFB.openRemote();
				/* End Interactive Device */
				iData.request(pSource.pid, OnLoadData);
				break;
			case Facebook.Define.PhotoList :
				/* Start Interactive Device */
				iRemoteFB.openRemote();
				/* End Interactive Device */ 
				iView.show();
				iView.request(photoSource, iFocus);
				showHelpNavi(true);
				break;
			default : 
				break;
		}
		
		iTools.setCallInfo({
			caller : this, 
			callerFrom : pSource.type,
			photoOwner : pSource.actor_id,
			fnOnRetun : returnFn
			, callerPhotoSource : photoSource
		});
	}
	var instanceTimer = null;
	function showHelpNavi(pDisappear) {
		iView.showHelpNavi();
		if (pDisappear) {
			if (instanceTimer) {
				clearTimeout(instanceTimer);
				instanceTimer = null;
			}
            instanceTimer = setTimeout(function(){
				hideHelpNavi();
				instanceTimer = null;
            }, 5000);
		} else {
			if (instanceTimer) {
				clearTimeout(instanceTimer);
				instanceTimer = null;
			}
		}
	}
	
	function hideHelpNavi() {
		iView.hideHelpNavi();
	}
	
	function toggleHelpNavi() {
		if (instanceTimer) {
			hideHelpNavi();
			clearTimeout(instanceTimer);
			instanceTimer = null;
		}
		else {
			showHelpNavi(true);
		}
	}
	
	function generateHelpNavi() {
		var arrHelp = [];
		switch(nCallFrom) {
			case Facebook.Define.PhotoList : 
			arrHelp[arrHelp.length] = {	image : HelpArea.Image.Green,			text : SID_ALBUMS_					};
//			arrHelp[arrHelp.length] = {	image : HelpArea.Image.Yellow,			text : FBID_SHARE					};
			if (iFocus.getItemLength() > 1) 
				arrHelp[arrHelp.length] = {	image : HelpArea.Image.LeftRight,	text : SID_PREVIOUS_NEXT		};
			arrHelp[arrHelp.length] = {	image : HelpArea.Image.Tools,			text : SID_TOOLS					};
			arrHelp[arrHelp.length] = {	image : HelpArea.Image.Return,		text : SID_RETURN					};
				break;
			case Facebook.Define.Stream : 
				arrHelp[arrHelp.length] = {	image : HelpArea.Image.Green,			text : SID_ALBUMS_	};
//				arrHelp[arrHelp.length] = {	image : HelpArea.Image.Yellow,			text : FBID_SHARE	};
				arrHelp[arrHelp.length] = {	image : HelpArea.Image.Tools,			text : SID_TOOLS					}; 
				arrHelp[arrHelp.length] = {	image : HelpArea.Image.Return,		text : SID_RETURN	};
				break;
			default :
				break;
		}

		return arrHelp;
	}
	
	function photoEventListner(pType) {
		switch(pType) {
			case GMFPlayer.Event.EndDrawLoading :
				Instance.Loading.close();
                		iRemoteFB.hideLoading();
				break;
			case GMFPlayer.Event.RenderError :
				Instance.GMF.stop();
				Instance.Loading.close();
                		iRemoteFB.hideLoading();
				break;
			case GMFPlayer.Event.ServerError :		// [DMS00740136]
			case GMFPlayer.Event.NetworkError :
				// Player network error
				Instance.Loading.close();
                		iRemoteFB.hideLoading();
				Instance.GMF.stop();
				iView.showNetworkError();
				break;
		}
	}
	
	function OnLoadData(pData) {
		if (pData) {
			photoSource = pData;
			iView.show();
			iView.request(photoSource);
			showHelpNavi(true);
			iTools.setCallInfo({
				callerPhotoSource : photoSource
			});
		} else {
			returnFn();
		}
	}
	PicStreamShare = iStreamShare ;
       
	function keyHandler(pKeyCode) {
		if (instanceState == Facebook.Define.Processing) {
			FBTrace("Stream : Processing (Block Key Event)");
			return;
		}
		
		if (pKeyCode != TV.KEY_INFO) showHelpNavi(true);
		
		switch(pKeyCode) {
			case TV.KEY_RIGHT :
			case TV.KEY_PANEL_VOL_DOWN :
				if (!GMFPlayer.Instance.isFinish()) break;
				switch(nCallFrom) {
					case Facebook.Define.Stream :
						break;
					case Facebook.Define.PhotoList :
						returnFn(Facebook.Define.Next);
						break;
					default : 
						break;
				}
				break;
			case TV.KEY_LEFT :
			case TV.KEY_PANEL_VOL_UP :
				if (!GMFPlayer.Instance.isFinish()) break;
				switch(nCallFrom) {
					case Facebook.Define.Stream :
						break;
					case Facebook.Define.PhotoList :
						returnFn(Facebook.Define.Prev);
						break;
					default : 
						break;
				}
				break;
			case TV.KEY_UP :
			case TV.KEY_WHEELUP :
			case TV.KEY_PANEL_CH_UP :
				break;
			case TV.KEY_DOWN :
			case TV.KEY_WHEELDOWN :
			case TV.KEY_PANEL_CH_DOWN :
				break;
			case TV.KEY_ENTER :
				break;
			case TV.KEY_RETURN :
				_this_.close();				
                /* Start Interactive Device */
       		 	if (iRemoteFB.photoFlag == 1) {
					iRemoteFB.albumPics(iRemoteFB.GlobalPicsData, iRemoteFB.GlobalPhotoData);
				}
				else{
                    if(Instance.Frame.getType() == FacebookFrame.Define.ME){
						if (checkBrowserVersion()) {
							// iRemoteFB.onLoadFacebook();
						}
					}                       
                    else{
                        var makeMenuData = "";
                        var makeMenuData = new Array();	
                        makeMenuData[0] = {
                            identifier : "menuID34",
                            type : "custom",
                            title : User.name,
                            name : FBID_WALL,
                            icon : "example/a.png",
                            onClick : "action?selectthis=userWall"
                        }
                        makeMenuData[1] = {
                            identifier : "menuID33",
                            type : "custom",
                            title : User.name,
                            name : SID_INFO_CASE,
                            icon : "example/a.png",
                            onClick : "action?selectthis=userInfo"
                        }
                        makeMenuData[2] = {
                            identifier : "menuID32",
                            type : "custom",
                            title : User.name,
                            name : FBID_PHOTOS,
                            icon : "example/a.png",
                            onClick : "action?selectthis=userPhotosProfile"
                        }
                        makeMenuData[3] = {
                            identifier : "menuID31",
                            type : "custom",
                            title : User.name,
                            name : SID_VIDEOS,
                            icon : "example/a.png",
                            onClick : "action?selectthis=userVideosProfile"
                        }
						if (checkBrowserVersion()) {
							
						}                        
                    }
                   
                    if(iRemoteFB.photosHomeFlag == 1){
						if (checkBrowserVersion()) {
							 iRemoteFB.onLoadPhotos(NewsFeedArray);
						}
					}
                       
                    
                    else if((iRemoteFB.statusUpdateFlag+iRemoteFB.photosHomeFlag+iRemoteFB.videosHomeFlag) == 0){
                       if(iRemoteFB.GlobalMode == 12){
				   		if (checkBrowserVersion()) {
							iRemoteFB.showNews(iRemoteFB.GlobalPList,iRemoteFB.GlobalMode);
						}
					   }                           
                       else  if(iRemoteFB.GlobalMode == 13){
				   		if (checkBrowserVersion()) {
							iRemoteFB.showWall(iRemoteFB.GlobalPList,iRemoteFB.GlobalMode);
						}
					   }                           
					}
				}			
				returnFn(false);
				break;
			case TV.KEY_GREEN :
				_this_.close();
				iRemoteFB.albumPics(iRemoteFB.GlobalPicsData, iRemoteFB.GlobalPhotoData);
				switch(nCallFrom) {
					case Facebook.Define.Stream :
						if (Instance.Main.getLoginID() != strPhotoOwner) {
							Instance.Frame.open(strPhotoOwner, Facebook.Define.Menu.PHOTOS, {
								data : photoSource
							});
						} else {
							Instance.Frame.go(Facebook.Define.Menu.PHOTOS, {
								data : photoSource
							});
						}
						break;
					case Facebook.Define.PhotoList :
						returnFn(Facebook.Define.GoAlbum);
						break;
					default : 
						break;
				}
				break;
//			case TV.KEY_YELLOW : 
//				hideHelpNavi();
//				shareContents(photoSource);
//				break;
			case TV.KEY_RED : 
				if (Instance.Frame.getType() != FacebookFrame.Define.ME) {
					_this_.close();
					returnFn(Facebook.Define.Close);
				}
				break;
			case TV.KEY_TOOLS : 
				iTools.open(function(){
					Instance.Main.restoreKeyHandler();
    			});
				Instance.Main.setKeyHandler(iTools.getKeyHandler(), 'iTools');
				break;
			case TV.KEY_INFO : 
				toggleHelpNavi();
				break;
			default :
				break;
		}
	}

	function returnListFn(pReturn) {
		if (pReturn) {
			instanceState == Facebook.Define.None;
			Instance.Main.setKeyHandler(keyHandler,"PhotoFull");
		} else {
			instanceState == Facebook.Define.None;
			Instance.Main.setKeyHandler(keyHandler,"PhotoFull");
		}
	}

	/* 
	 * 		Share Data Spec.
	 * 		{	
	 * 		src : Picture Source,
	 * 		type : Share Object Type,
	 * 		name : Share Name,
	 * 		attachment : Share Contents
	 * 		}
	 */
    function shareContents(pSource){
		instanceState == Facebook.Define.Processing;
		var strPID = pSource.pid.split("_");
        var objShare = {
			src : pSource.src
			, type : "photo"
			, name : pSource.caption
			, pic_square : originalSource.pic_square ? originalSource.pic_square : Instance.Main.getFrameUserInfo().pic_square 
			, attachment : {
				media : [{
					'type': 'image',
					'src': pSource.src_big,
					'href': "http://www.facebook.com/photo.php?pid="+strPID[1]+"%26id="+strPID[0],
					'photo' : {
						"aid" : pSource.aid,
						"pid" : pSource.pid,
						"owner" : pSource.actor_id,
						width : pSource.src_big_width,
						height : pSource.src_big_height
					}
				}]
				, share : "true"
			}
			, writter : Instance.Main.getFrameUserInfo().name
			, pic_square : Instance.Main.getLoginUserInfo().pic_square
        };
		iStreamShare.enter(objShare);
    }
    
    this.shareContents = function(pSource){
    	instanceState == Facebook.Define.Processing;
	var strPID = pSource.pid.split("_");
        var objShare = {
			src : pSource.src
			, type : "photo"
			, name : pSource.caption
			, pic_square : originalSource.pic_square ? originalSource.pic_square : Instance.Main.getFrameUserInfo().pic_square 
			, attachment : {
				media : [{
					'type': 'image',
					'src': pSource.src_big,
					'href': "http://www.facebook.com/photo.php?pid="+strPID[1]+"%26id="+strPID[0],
					'photo' : {
						"aid" : pSource.aid,
						"pid" : pSource.pid,
						"owner" : pSource.actor_id,
						width : pSource.src_big_width,
						height : pSource.src_big_height
					}
				}]
				, share : "true"
			}
			, writter : Instance.Main.getFrameUserInfo().name
			, pic_square : Instance.Main.getLoginUserInfo().pic_square
        };
		iStreamShare.enter(objShare);
    }
}