function PhotoList(pViewInstance, pDataInstance, pReturnFn) {
	var _this_ = this;
	
	var iView = pViewInstance;
	var iData = pDataInstance;
	var returnFn = pReturnFn;
	
	var objPages = [];
	
	var nRow = 3, nCol = 4;
	var iFocus = new FocusMapper("PhotoList",nRow, nCol);
	var iPhotoFull = new PhotoFull(new PhotoFullView(_$("facebookPhotoFullDiv")), null, iFocus, returnListFn);
    /* Start Interactive Device */
	iRemoteFB.picsView = iView ;
    /* End Interactive Device */
	var defaultID = null;
	
	// External Interface
	this.open = function() {
		iView.show();
		iData.request(OnLoadData);
	}
	
	this.close = function() {
		iView.hide();
	}
	
	this.enter = function(pAlbums, pDefaultID) {
		defaultID = pDefaultID ? pDefaultID : null;
		Instance.Main.setKeyHandler(keyHandler,"PhotoList");
		iData.request(pAlbums.aid, OnLoadData);
		iView.setup(pAlbums);
		iView.show();
	}
	
	function generateHelpNavi() {
		var arrHelp = [];
		arrHelp[arrHelp.length] = {	image : HelpArea.Image.Enter,		text : SID_HELP_FULL	};
		if (iFocus.getTotalPage() > 1) 
			arrHelp[arrHelp.length] = {	image: HelpArea.Image.FFRW, text: SID_PAGE_UP_DOWN };
		arrHelp[arrHelp.length] = {	image : HelpArea.Image.Return,	text : SID_RETURN			};
		return arrHelp;
	}

	function OnLoadData(pData) {
		generatePage(pData);
		iFocus.generate(objPages);
		
		
		if  (defaultID) {
			findPicture(defaultID);
		} else {
			requestPage(iFocus.getFocus().page);
		}
		iView.focus(iFocus.getFocus());
		
		// Show help navi after counting pages
		Instance.Main.registHelpNavi(generateHelpNavi(),"PhotoList");
		Instance.Main.applyHelpNavi("PhotoList");
	}
	
	function findPicture(pPictureID) {
		var nRow = 0;
		var nCol = 0;
		var nPages = objPages.length;
		for (var pIdx = 0; pIdx < nPages; pIdx++) {
			nRow = objPages[pIdx].length;
			for (var rIdx = 0; rIdx < nRow; rIdx++) {
				nCol = objPages[pIdx][rIdx].length;
				for (var cIdx = 0; cIdx < nCol; cIdx++) {
					if (objPages[pIdx][rIdx][cIdx].pid == pPictureID) {
						iFocus.setFocus({ page: pIdx, row: rIdx, col: cIdx });
						iView.request(objPages[pIdx],iFocus);
						return;
					}
				}
			}
		}
	}
	
	function requestPage(pPage) {
		iFocus.setPage(pPage);
		iFocus.resetFocus();
		iView.request(objPages[pPage],iFocus);
	}
	
	function generatePage(pData) {
		var dataLength = pData.length;
		var itemBuffer = [];
		var lineBuffer = [];
		var nPage = 0;
		objPages = [];
		objPages[nPage] = [];
		
		for (var dataIdx = 0; dataIdx < dataLength; dataIdx++) {
			if (itemBuffer.length >= nCol) {
				flushItem();
			}
			itemBuffer.push(pData[dataIdx]);
		}
		flushItem();
		flushLine();
		
		function flushItem() {
			if (lineBuffer.length >= nRow) {
				if (!(objPages[nPage] instanceof Array)) objPages[nPage]  = [];
				objPages[nPage++] = Util.copyArray(lineBuffer);
				lineBuffer = [];
			}
			lineBuffer.push(Util.copyArray(itemBuffer));
			itemBuffer = [];
		}
		
		function flushLine() {
			if (lineBuffer.length > 0) {
				if (!(objPages[nPage] instanceof Array)) objPages[nPage]  = [];
				objPages[nPage]= Util.copyArray(lineBuffer);
			}
		}
            /* Start Interactive Device */
        	showDetails(pData, objPages);
            /* End Interactive Device */
	}
	
	    /* Start Interactive Device */
    	function showDetails(picsData, picPages){
       	 iRemoteFB.albumPics(picsData, picPages);
    	}
        /* End Interactive Device */
	
	function returnListFn(pType) {
		switch (pType) {
			case Facebook.Define.Next : 
				if (iFocus.getItemLength() < 2) return;
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.next()) {
					iView.blur(oldFocus);
					if (oldFocus.page != iFocus.getFocus().page) {
						iFocus.setPage(iFocus.getFocus().page);
						iView.request(objPages[iFocus.getFocus().page],iFocus);
					}
					iView.focus(iFocus.getFocus());
					var objPhoto = objPages[iFocus.getFocus().page][iFocus.getFocus().row][iFocus.getFocus().col];
					objPhoto.type = Facebook.Define.PhotoList;
					objPhoto.actor_id = Instance.Main.getLoginID();
					iPhotoFull.enter(objPhoto);
				}
				break;
			case Facebook.Define.Prev :
				if (iFocus.getItemLength() < 2) return;
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.prev()) {
					iView.blur(oldFocus);
					if (oldFocus.page != iFocus.getFocus().page) {
						iFocus.setPage(iFocus.getFocus().page);
						iView.request(objPages[iFocus.getFocus().page],iFocus);
					}
					iView.focus(iFocus.getFocus());
					var objPhoto = objPages[iFocus.getFocus().page][iFocus.getFocus().row][iFocus.getFocus().col];
					objPhoto.type = Facebook.Define.PhotoList;
					objPhoto.actor_id = Instance.Main.getLoginID();
					iPhotoFull.enter(objPhoto);
				}
				break;
			case Facebook.Define.GoAlbum :
				iView.show();
				Instance.Main.setKeyHandler(keyHandler,"PhotoList");
				break;
			case Facebook.Define.Close :
				iView.blur(iFocus.getFocus());
				iView.clear();
				iView.hide();
				returnFn();
				break;
			case false :
				iView.show();
				Instance.Main.setKeyHandler(keyHandler,"PhotoList");
				break;
			default :
				break;
		}
	}
    
   this.returnFn = function(pType) {
		switch (pType) {
			case Facebook.Define.Next : 
				if (iFocus.getItemLength() < 2) return;
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.next()) {
					iView.blur(oldFocus);
					if (oldFocus.page != iFocus.getFocus().page) {
						iFocus.setPage(iFocus.getFocus().page);
						iView.request(objPages[iFocus.getFocus().page],iFocus);
					}
					iView.focus(iFocus.getFocus());
					var objPhoto = objPages[iFocus.getFocus().page][iFocus.getFocus().row][iFocus.getFocus().col];
					objPhoto.type = Facebook.Define.PhotoList;
					objPhoto.actor_id = Instance.Main.getLoginID();
					iPhotoFull.enter(objPhoto);
				}
				break;
			case Facebook.Define.Prev :
				if (iFocus.getItemLength() < 2) return;
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.prev()) {
					iView.blur(oldFocus);
					if (oldFocus.page != iFocus.getFocus().page) {
						iFocus.setPage(iFocus.getFocus().page);
						iView.request(objPages[iFocus.getFocus().page],iFocus);
					}
					iView.focus(iFocus.getFocus());
					var objPhoto = objPages[iFocus.getFocus().page][iFocus.getFocus().row][iFocus.getFocus().col];
					objPhoto.type = Facebook.Define.PhotoList;
					objPhoto.actor_id = Instance.Main.getLoginID();
					iPhotoFull.enter(objPhoto);
				}
				break;
			case Facebook.Define.GoAlbum :
				iView.show();
				Instance.Main.setKeyHandler(keyHandler,"PhotoList");
				break;
			case Facebook.Define.Close :
				iView.blur(iFocus.getFocus());
				iView.clear();
				iView.hide();
				returnFn();
				break;
			case false :
				iView.show();
				Instance.Main.setKeyHandler(keyHandler,"PhotoList");
				break;
			default :
				break;
		}
	}
	
    //IPhotoFull = iPhotoFull;
	IPhotoFullList = iPhotoFull;
    
	function keyHandler(pKeyCode) {
		switch(pKeyCode) {
			case TV.KEY_RIGHT :
			case TV.KEY_PANEL_VOL_DOWN :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.right()) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_LEFT :
			case TV.KEY_PANEL_VOL_UP :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.left()) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				} else {
					iView.blur(iFocus.getFocus());
					iView.clear();
					iView.hide();
					/* Start Interactive Device */                  
	                if (Instance.Frame.getType() == FacebookFrame.Define.ME) {
						iRemoteFB.onLoadFacebook();
						
					}
					iRemoteFB.onLoadProfile();
					
					//INTERACTIVE REMOTE END
					returnFn(Facebook.Define.Exit);
				}
				break;
			case TV.KEY_UP :
			case TV.KEY_WHEELUP :
			case TV.KEY_PANEL_CH_UP :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.up()) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				} else {
//					requestPage(iFocus.getFocus().page);
					iFocus.setPage(iFocus.getFocus().page);
//					iFocus.resetFocus();
					iView.request(objPages[iFocus.getFocus().page],iFocus);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_DOWN :
			case TV.KEY_WHEELDOWN :
			case TV.KEY_PANEL_CH_DOWN :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.down()) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				} else {
//					requestPage(iFocus.getFocus().page);
					iFocus.setPage(iFocus.getFocus().page);
//					iFocus.resetFocus();
					iView.request(objPages[iFocus.getFocus().page],iFocus);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_FF :
				if (iFocus.nextPage(true)) {
					requestPage(iFocus.getFocus().page);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_RW :
				if (iFocus.prevPage(true)) {
					requestPage(iFocus.getFocus().page);
					iView.focus(iFocus.getFocus());
				}
				break;				
			case TV.KEY_ENTER :
				iView.hide();
				var objPhoto = objPages[iFocus.getFocus().page][iFocus.getFocus().row][iFocus.getFocus().col];
				objPhoto.type = Facebook.Define.PhotoList;
				objPhoto.actor_id = Instance.Main.getLoginID();
				iRemoteFB.photoFlag = 1;
				iPhotoFull.enter(objPhoto);
				break;
			case TV.KEY_RETURN : 
				// Return to main menu	
				iView.blur(iFocus.getFocus());
				iView.clear();
				iView.hide();
				returnFn();
                /* Start Interactive Device */                  
                if(Instance.Frame.getType() != FacebookFrame.Define.ME){
                    var makeMenuData = new Array();
                    makeMenuData[0] = {
                        identifier : "menuID34",
                        type : "custom",
                        title : User.name,
                        name : FBID_WALL,
                        icon : "example/a.png",
                        onClick : "action?selectthis=userWall"
                    }
                    makeMenuData[1] = {
                        identifier : "menuID33",
                        type : "custom",
                        title : User.name,
                        name : SID_INFO_CASE,
                        icon : "example/a.png",
                        onClick : "action?selectthis=userInfo"
                    }
                    makeMenuData[2] = {
                        identifier : "menuID32",
                        type : "custom",
                        title : User.name,
                        name : FBID_PHOTOS,
                        icon : "example/a.png",
                        onClick : "action?selectthis=userPhotosProfile"
                    }
                    makeMenuData[3] = {
                        identifier : "menuID31",
                        type : "custom",
                        title : User.name,
                        name : SID_VIDEOS,
                        icon : "example/a.png",
                        onClick : "action?selectthis=userVideosProfile"
                    }
					if (checkBrowserVersion()) {
						//jQuery.sfIRemote('menu', makeMenuData);
					}
                 }					                 
                iRemoteFB.profilePhoto(iRemoteFB.GlobalPhotoList, iRemoteFB.GlobalPageNum);
                /* End Interactive Device */
				break;
			case TV.KEY_RED : 
				if (Instance.Frame.getType() != FacebookFrame.Define.ME) {
					_this_.close();
				}
				break;
			default :
				break;
		}
	}
}