var Player = {
    plugin: null,
    state: -1,
    originalSource: null,
    
    STOPPED: 0,
    PLAYING: 1,
    PAUSED: 2
}

Player.init = function(){
    var success = true;
    
    this.state = this.STOPPED;
    
    this.plugin = document.getElementById("pluginPlayer");
    
    if (!this.plugin) {
        success = false;
    }
    else {
        var mwPlugin = document.getElementById("pluginTVMW");
        
        if (!mwPlugin) {
            success = false;
        }
        else {
            /* Save current TV Source */
            this.originalSource = mwPlugin.GetSource();
            
            /* Set TV source to media player plugin */
            mwPlugin.SetMediaSource();
            
            /* Set up windowed video mode */
            this.setWindow();
        }
    }
    
    return success;
}

Player.destroy = function(){
	if (this.state != this.STOPPEED) {
		this.plugin.stop();
	}
	var mwPlugin = document.getElementById("pluginObjectTVMW");
    mwPlugin.SetSource(this.originalSource);
}

Player.setWindow = function(){
    this.plugin.SetVideoPos(55, 160, 400, 262);
}

Player.setVideoURL = function(url){
    this.url = url;
    alert("URL = " + this.url);
}

Player.playVideo = function(){
    if (this.url == null) {
        alert("No videos to play");
    }
    else {
        this.state = this.PLAYING;
        this.plugin.Play(this.url);
        alert("Playing...");
    }
}

// Global functions called directly by the player 
startDrawLoading = function(){
    alert("startDrawLoading");
}

endDrawLoading = function(){
    alert("endDrawLoading");
}

getBandwidth = function(bandwidth){
    alert("getBandwidth " + bandwidth);
}

onDecoderReady = function(){
    alert("onDecoderReady");
}

onRenderError = function(){
    alert("onRenderError");
}

popupNetworkErr = function(){
    alert("popupNetworkErr");
}

setCurTime = function(time){
    alert("setCurTime " + time);
}

setTottalTime = function(time){
    alert("setTottalTime " + time);
}

stopPlayer = function(){
    alert("stopPlayer");
}

setTottalBuffer = function(buffer){
    alert("setTottalBuffer " + buffer);
}

setCurBuffer = function(buffer){
    alert("setCurBuffer " + buffer);
}

onServerError = function(){
    alert("onServerError");
}
