function VideoDetail(pViewInstance, pFocusMapper, pReturnFn) {
	var _this_ = this;
	
	var iView = pViewInstance;
	/*Start Interactive Device*/
	VideoView = iView ; 
	/*End Interactive Device*/
	var iFocus = pFocusMapper;

	var bLastMuteState = false;

	// [DMS00740113] Divied for BD 
	// BD has no Picture/Sound Setting menu
	if (Instance.Main.getManagerSetting().product != PL_TV_PRODUCT_TYPE_BD) {
		var iTools = new CTools('iTools');
		iTools.addMenu(CTools.Define.SOUND_SETTING);
		iTools.addMenu(CTools.Define.PICTURE_SETTING);		
	}

	var iProgress = null;
	var iComments = new Comments(new CommentsView(_$("facebookCommentsDiv")),innerCommentsListnerFn);
	var iCommentsList = new CommentsList(new CommentsListView(_$("facebookCommentsListDiv")), new CommentsListData(), CommentsListCallback);
	var iStreamVideoFull = new StreamVideoFull(new StreamVideoFullView(_$("facebookStreamVideoFullDiv")),iFocus,returnDetailFn);
	var iCommentsAdd = new StreamAddComment(new StreamAddCommentData(), UpdateCallbackFn);
	var iStreamShare = new StreamShare(new StreamShareView(_$("facebookStreamShareDiv")),new StreamShareData(),returnDetailFn);

	var iVideoInnerLoading = new innerLoading({
		id : "VideoInnerLoading"
		, container : _$("facebookFreeDiv")
		, left : 229
		, top : 252
	});

	var instanceState = Facebook.Define.None;

	var curVideo = null;
	var objInnerComments = { 	nPage : 0, nItem : 0 };
	var objVideoArea = {		left : 57, top : 171, width : 400, height : 262	}
	var returnFn = pReturnFn;

	var lastFocus = null;
	var updateFlag = false;
	var bGlobalLoading = false;
	var bPlayerLoading = false;
	
	// External Interface
	this.open = function() {
		iView.show();
	}
	
	this.close = function() {
		iView.hide();
		
		iComments.close();
		iProgress.close();
		iVideoInnerLoading.close();

		Instance.Main.showFrame();
		Instance.Frame.showMenu();
		Instance.GMF.stop();
		Instance.GMF.close();
		
		bGlobalLoading = false;
		Instance.Loading.close();
		iRemoteFB.hideLoading();
	}
	
	this.enter = function(pVideo, pLastFocus) {
		instanceState = Facebook.Define.Processing;
		
		bGlobalLoading = true;
		Instance.Loading.open();
		iRemoteFB.showLoading("Loading Data");
		curVideo = pVideo;
		thisVideo = curVideo;
		updateFlag = false;
		lastFocus = pLastFocus;
		
		Instance.Main.registHelpNavi(generateHelpNavi(),"VideoDetail");
		Instance.Main.setKeyHandler(keyHandler,"VideoDetail");

		Instance.Main.hideFrame();
		Instance.Frame.hideMenu();
		
		iView.show();
		iView.request(curVideo);
		
		// Display volume OSD, only if  mute is set
		if (Instance.Audio.getMute()) 
			iView.setVolumeOSD();
		
		Instance.GMF.addEventListner(videoEventListner);
		
		iProgress = new Progress(new ProgressVideoView(_$("facebookStreamVideoDetailProgressDiv"),"DETAIL"),new ProgressVideoData());
		iProgress.init({
			rail: {
				left: 50,top: 112,	width: 413,height: 3,
				src: "Resource/images/profile_video_progress_bg.png"
			},
			bar: {
				left: 50,top: 112,	width: 1,height: 3,
				src: "Resource/images/profile_video_progress_bar.png"
			}
		});
		iProgress.open();
		IProgress = iProgress;
		iComments.request(curVideo.post_id, Facebook.Define.IDTYPE_OBJECT);
		
		iView.playHelp.hide();
		
		Instance.GMF.play(curVideo.source_url, objVideoArea.left, objVideoArea.top, objVideoArea.width, objVideoArea.height);
			/*Start Interactive Device*/             
        /*
var makeMenuData = new Array();
        makeMenuData[0] = {
            identifier : "menuID17",
            type : "custom",
            title : curVideo.name,
            name : "Write a Comment",
            icon : "example/a.png",
            onClick : "action?select=videoComment"
        }
        makeMenuData[1] = {
            identifier : "menuID18",
            type : "custom",
            title : FBID_SHARE,
            name : FBID_SHARE,
            icon : "example/a.png",
            onClick : "action?videoShare="
        }
        makeMenuData[2] = {
            identifier : "menuID19",
            type : "custom",
            title : SID_TOOLS,
            name : SID_TOOLS,
            icon : "example/a.png",
            onClick : "action?menu=tools"
        }
		if (checkBrowserVersion()) {
			jQuery.sfIRemote('menu', makeMenuData);
			iRemoteFB.VideoPlay();
		}             
*/
		iRemoteFB.openRemote();
		/*End Interactive Device*/
	}

	function generateHelpNavi() {
		var arrHelp = [];
		arrHelp[arrHelp.length] = {	image : HelpArea.Image.Green,		text : SID_COMMNET_M_ADD_COMMENT			};
//		arrHelp[arrHelp.length] = {	image : HelpArea.Image.Yellow,		text : FBID_SHARE				};
		if (objInnerComments.nItem > 0)
			arrHelp[arrHelp.length] = {	image : HelpArea.Image.Blue,		text : SID_COMMENTS_LIST		};
		// Don't display "Full Mode" when the video is not playing
		if (Instance.GMF.getState() != GMFPlayer.STOPPED)		
			arrHelp[arrHelp.length] = {	image : HelpArea.Image.Enter,		text : SID_HELP_FULL					};
		if (objInnerComments.nPage > 1)
			arrHelp[arrHelp.length] = {	image : HelpArea.Image.FFRW,		text : SID_PAGE_UP_DOWN	};			
		// [DMS00740113] Divied for BD 
		// BD has no Picture/Sound Setting menu
		if (Instance.GMF.getState() != GMFPlayer.STOPPED) {
			if (Instance.Main.getManagerSetting().product != PL_TV_PRODUCT_TYPE_BD) {
				arrHelp[arrHelp.length] = {
					image: HelpArea.Image.Tools,
					text: SID_TOOLS
				}; // Translation Need
			}
		}
		arrHelp[arrHelp.length] = {	image : HelpArea.Image.Return,	text : SID_RETURN				};
		return arrHelp;
	}

	/*Start Interactive Device*/
	this.generateHelpNavi = function() {
		var arrHelp = [];
		arrHelp[arrHelp.length] = {	image : HelpArea.Image.Green,		text : SID_COMMNET_M_ADD_COMMENT			};
		arrHelp[arrHelp.length] = {	image : HelpArea.Image.Yellow,		text : FBID_SHARE				};
		if (objInnerComments.nItem > 0)
			arrHelp[arrHelp.length] = {	image : HelpArea.Image.Blue,		text : SID_COMMENTS_LIST		};
		// Don't display "Full Mode" when the video is not playing
		if (Instance.GMF.getState() != GMFPlayer.STOPPED)		
			arrHelp[arrHelp.length] = {	image : HelpArea.Image.Enter,		text : SID_HELP_FULL					};
		if (objInnerComments.nPage > 1)
			arrHelp[arrHelp.length] = {	image : HelpArea.Image.FFRW,		text : SID_PAGE_UP_DOWN	};			
		// [DMS00740113] Divied for BD 
		// BD has no Picture/Sound Setting menu
		if (Instance.GMF.getState() != GMFPlayer.STOPPED) {
			if (Instance.Main.getManagerSetting().product != PL_TV_PRODUCT_TYPE_BD) {
				arrHelp[arrHelp.length] = {
					image: HelpArea.Image.Tools,
					text: SID_TOOLS
				}; // Translation Need
			}
		}
		arrHelp[arrHelp.length] = {	image : HelpArea.Image.Return,	text : SID_RETURN				};
		return arrHelp;
	}
	/*End Interactive Device*/

	function updateTimeInfoOSD() {
		var nVideoTotalTime = Instance.GMF.getTotalTime();
		var nVideoCurrentTime = Instance.GMF.getCurrentTime();
		
		if (nVideoTotalTime == 0) nVideoCurrentTime = 0;
		else nVideoCurrentTime = nVideoCurrentTime;
		iProgress.update(Math.ceil(100 * nVideoCurrentTime / (nVideoTotalTime - nVideoTotalTime % 1000)));
		iView.setTime(nVideoCurrentTime);
		alert("Video Total Time : "+nVideoTotalTime);
		iView.setTotalTime(nVideoTotalTime);
	}

	function videoEventListner(pType) {
		switch(pType) {
			case GMFPlayer.Event.CurrentTime :
				if (Instance.GMF.getState() == GMFPlayer.STOPPED) return;
				updateTimeInfoOSD();
				break;
			case GMFPlayer.Event.Stop : 
				// [DMS00741449]
				// handling video end event.
				if (iTools) {
					iTools.close();
				}
				//
				iProgress.reset();
				// delay Player operation
				setTimeout(function(){
					Instance.GMF.stop();
				}, 0);
				iView.playHelp.set(Facebook.Define.Stop);
				iView.setTime(0);
				Instance.Main.registHelpNavi(generateHelpNavi(),"VideoDetail");
				if (Instance.Main.getKeyHandler() == "VideoDetail") {
					Instance.Main.applyHelpNavi("VideoDetail");
				}
				break;
			case GMFPlayer.Event.StartDrawLoading :
				bPlayerLoading = true;
				if (!bGlobalLoading)
					iVideoInnerLoading.open();
				break;
			case GMFPlayer.Event.EndDrawLoading :
				bPlayerLoading = false;
				if (bGlobalLoading) {
					Instance.Loading.close();
					/*Start Interactive Device*/
					iRemoteFB.hideLoading();
					/*End Interactive Device*/
					bGlobalLoading = false;
					if (iComments.isLoading()) {
						iComments.openLoading();
					}
				}
				iVideoInnerLoading.close();
				
				instanceState = Facebook.Define.None;
				
				Instance.Main.registHelpNavi(generateHelpNavi(),"VideoDetail");
				Instance.Main.applyHelpNavi("VideoDetail");
				break;
			case GMFPlayer.Event.NetworkError :
				instanceState = Facebook.Define.None;
				iRemoteFB.errormsgPopup(SID_ALERT_NETWORKERROR_MSG);
				Instance.Popup.enter({
	                title: "Facebook",
	                message: SID_ALERT_NETWORKERROR_MSG,
	                buttons: [{ caption: SID_OK, value: true }]
	            }, function(){});
				break;
			default : 	
				break;	
		}
	}
	
	function returnDetailFn(pType) {
		// Display volume OSD
		var bCurMuteState = Instance.Audio.getMute();
		if (bCurMuteState || bCurMuteState != bLastMuteState) {
			iView.setVolumeOSD();
		}
		bLastMuteState = bCurMuteState;
		
		instanceState = Facebook.Define.None;
		
		switch (pType) {
			case Facebook.Define.Next : 
			case Facebook.Define.Prev :
				_this_.close();
				returnFn(pType);					
				break;
			case Facebook.Define.Stop :
				iView.show();
				iProgress.open();
				iComments.open();
				iComments.refresh();
				
				// Detail Screen Mode
				Instance.GMF.clearScreen();
				Instance.GMF.set(objVideoArea.left, objVideoArea.top, objVideoArea.width, objVideoArea.height);
				iProgress.reset();
				Instance.GMF.stop();
				iView.setTime(0);
				Instance.GMF.addEventListner(videoEventListner);
				iView.playHelp.set(Facebook.Define.Stop);
				iView.playHelp.show();
				Instance.Main.registHelpNavi(generateHelpNavi(),"VideoDetail");
				Instance.Main.applyHelpNavi("VideoDetail");
				Instance.Main.setKeyHandler(keyHandler,"VideoDetail");
				break;
			case Facebook.Define.Close :
				_this_.close();
				break;
			case true :
				Instance.Main.setKeyHandler(keyHandler,"VideoDetail");
				return;
				break;
			case false :
				// When screen size is changed, video is resumed automatically
				// So must change internal state
				Instance.GMF.setState(GMFPlayer.PLAYING);

				iView.show();
				iProgress.open();
				updateTimeInfoOSD();
				iComments.open();
				iComments.refresh();
				
				// Detail Screen Mode
				Instance.GMF.clearScreen();
				Instance.GMF.set(objVideoArea.left, objVideoArea.top, objVideoArea.width, objVideoArea.height);
				Instance.GMF.addEventListner(videoEventListner);
				
				if (Instance.GMF.getState() == GMFPlayer.PLAYING) {
					iView.playHelp.set(Facebook.Define.Play);
//					iView.playHelp.show();
				}
				
				Instance.Main.setKeyHandler(keyHandler,"VideoDetail");
				break;
			default :
				break;
		}
		iComments.refresh();
		Instance.Main.setKeyHandler(keyHandler,"VideoDetail");
	}

	this.returnDetailFn = function(pType) {
		// Display volume OSD
		var bCurMuteState = Instance.Audio.getMute();
		if (bCurMuteState || bCurMuteState != bLastMuteState) {
			iView.setVolumeOSD();
		}
		bLastMuteState = bCurMuteState;
		
		instanceState = Facebook.Define.None;
		
		switch (pType) {
			case Facebook.Define.Next : 
			case Facebook.Define.Prev :
				_this_.close();
				returnFn(pType);					
				break;
			case Facebook.Define.Stop :
				iView.show();
				iProgress.open();
				iComments.open();

				iComments.refresh();
				
				// Detail Screen Mode
				Instance.GMF.clearScreen();
				Instance.GMF.set(objVideoArea.left, objVideoArea.top, objVideoArea.width, objVideoArea.height);
				iProgress.reset();
				Instance.GMF.stop();

				iView.setTime(0);
				Instance.GMF.addEventListner(videoEventListner);
				iView.playHelp.set(Facebook.Define.Stop);
				iView.playHelp.show();
				Instance.Main.registHelpNavi(generateHelpNavi(),"VideoDetail");
				Instance.Main.applyHelpNavi("VideoDetail");
				Instance.Main.setKeyHandler(keyHandler,"VideoDetail");
				break;
			case Facebook.Define.Close :
				_this_.close();
				break;
			case true :
				Instance.Main.setKeyHandler(keyHandler,"VideoDetail");
				return;
				break;
			case false :
				// When screen size is changed, video is resumed automatically
				// So must change internal state
				Instance.GMF.setState(GMFPlayer.PLAYING);

				iView.show();
				iProgress.open();
				updateTimeInfoOSD();
				iComments.open();
				iComments.refresh();
				
				// Detail Screen Mode
				Instance.GMF.clearScreen();
				Instance.GMF.set(objVideoArea.left, objVideoArea.top, objVideoArea.width, objVideoArea.height);
				Instance.GMF.addEventListner(videoEventListner);
				
				if (Instance.GMF.getState() == GMFPlayer.PLAYING) {
					iView.playHelp.set(Facebook.Define.Play);
//					iView.playHelp.show();
				}
				
				Instance.Main.setKeyHandler(keyHandler,"VideoDetail");
				break;
			default :
				break;
		}
		iComments.refresh();
		Instance.Main.setKeyHandler(keyHandler,"VideoDetail");
	}
	
	/*Start Interactive Device*/
	IComments = iComments;
    IVideoInnerLoading = iVideoInnerLoading; 
    IStreamVideoFull = iStreamVideoFull;
	/*End Interactive Device*/
	
	function keyHandler(pKeyCode) {
		if (instanceState == Facebook.Define.Processing) {
			FBTrace("Stream : Processing (Block Key Event)");
			return;
		}
		
		// BD Panel key toggle
		if (pKeyCode == TV.KEY_D_FRONT_PLAY) {
			switch(Instance.GMF.getState()) {
				case Facebook.Define.Pause :
					 pKeyCode = TV.KEY_PLAY;
					break;
				case Facebook.Define.Play :
					pKeyCode = TV.KEY_PAUSE;
					break;
				default:
					break;
			}
		}
		
		switch(pKeyCode) {
			case TV.KEY_RIGHT :
			case TV.KEY_PANEL_VOL_DOWN :
				break;
			case TV.KEY_LEFT :
			case TV.KEY_PANEL_VOL_UP :
				break;
			case TV.KEY_UP :
			case TV.KEY_WHEELUP :
			case TV.KEY_PANEL_CH_UP :
				iComments.prev();
				break;
			case TV.KEY_DOWN :
			case TV.KEY_WHEELDOWN :
			case TV.KEY_PANEL_CH_DOWN :
				iComments.next();
				break;
			case TV.KEY_FF :
				iComments.next();
				break;
			case TV.KEY_RW :
				iComments.prev();
				break;			
			case TV.KEY_ENTER :
				if (Instance.GMF.getState() != GMFPlayer.STOPPED) {
					iVideoInnerLoading.close();
					iComments.close();
					iView.hide();
					iProgress.close();
					Instance.GMF.pause();					
					//iRemoteFB.VideoFullScreen(curVideo);
					bLastMuteState = Instance.Audio.getMute();  
					iStreamVideoFull.enter(curVideo);
				}
				break;
			case TV.KEY_STOP :
				iProgress.reset();
				iView.playHelp.set(Facebook.Define.Stop);
				iView.playHelp.show();
				Instance.GMF.stop();
				iView.setTime(0);
				Instance.Main.registHelpNavi(generateHelpNavi(),"VideoDetail");
				Instance.Main.applyHelpNavi("VideoDetail");
				break;
			case TV.KEY_PAUSE :
				switch (Instance.GMF.getState()) {
					case GMFPlayer.PLAYING: 
						Instance.GMF.pause();
						iView.playHelp.set(Facebook.Define.Pause);
						iView.playHelp.show();
						break;
					default :
						break;
				}
				break;
			case TV.KEY_PLAY :
				iView.playHelp.set(Facebook.Define.Play);
				iView.playHelp.hide();
				switch (Instance.GMF.getState()) {
					case GMFPlayer.STOPPED : 
						Instance.GMF.play(curVideo.source_url, objVideoArea.left, objVideoArea.top, objVideoArea.width, objVideoArea.height);
						Instance.GMF.BDFrontPanelDisplay(FRONT_DISPLAY_PLAY);
						break;
					case GMFPlayer.PAUSED : 
						Instance.GMF.resume();
						break;
					default :
						break;
				}
				Instance.Main.registHelpNavi(generateHelpNavi(),"VideoDetail");
				Instance.Main.applyHelpNavi("VideoDetail");
				break;			
			case TV.KEY_BLUE :
				if (bGlobalLoading) return;
				if (objInnerComments.nItem > 0) {
					instanceState = Facebook.Define.Processing;
					iCommentsList.open(curVideo.post_id,false,Facebook.Define.IDTYPE_OBJECT);
				}
				break;
			case TV.KEY_RETURN :
				/*Start Interactive Device*/				
				if(iRemoteFB.videoAddCommentFlag == 1){
                	if (checkBrowserVersion()) {					
                    	/*
var makeMenuData = new Array();
                   		if(iRemoteFB.videoFlag == 1){
                        	makeMenuData[0] = {
                                identifier : "menuID17",
                                type : "custom",
                                title :  iRemoteFB.GlobalVideoArray.name,
                                name : "Write a Comment",
                                icon : "example/a.png",
                                onClick : "action?select=videoComment"
                        	}
                    	}
                    	else if (iRemoteFB.ProfilevideoFlag ==1){
                            makeMenuData[0] = {
                                identifier : "menuID17",
                                type : "custom",
                                title : iRemoteFB.ProfileVideoList[iRemoteFB.profilevideoArray[0]][ iRemoteFB.profilevideoArray[1]][iRemoteFB.profilevideoArray[2]].name,
                                name : "Write a Comment",
                                icon : "example/a.png",
                                onClick : "action?select=videoComment"
                            }
                        }
                        makeMenuData[1] = {
                                identifier : "menuID18",
                                type : "custom",
                                title : FBID_SHARE,
                                name : FBID_SHARE,
                                icon : "example/a.png",
                                onClick : "action?videoShare="+ iRemoteFB.GlobalId
                        }
                        makeMenuData[2] = {
                                identifier : "menuID19",
                                type : "custom",
                                title : SID_TOOLS,
                                name : SID_TOOLS,
                                icon : "example/a.png",
                                onClick : "action?menu=tools"
                        }
                        jQuery.sfIRemote('menu', makeMenuData);  
                        iRemoteFB.VideoPlay();
*/	
						iRemoteFB.openRemote();
                        iRemoteFB.videoAddCommentFlag = 0; 
                    }
				}                   
                else{					
					if(iRemoteFB.toolsFlag == 1){
						if (checkBrowserVersion()) {
	                        /*
var makeMenuData = new Array();
	                        if (iRemoteFB.ProfilevideoFlag ==1){
	                            makeMenuData[0] = {
	                            identifier : "menuID17",
	                            type : "custom",
	                            title : iRemoteFB.ProfileVideoList[iRemoteFB.profilevideoArray[0]][ iRemoteFB.profilevideoArray[1]][iRemoteFB.profilevideoArray[2]].name,
	                            name : "Write a Comment",
	                            icon : "example/a.png",
	                            onClick : "action?select=videoComment"
	                         }
	                        }
	                        else if (iRemoteFB.videoFlag == 1){
	                            makeMenuData[0] = {
	                            identifier : "menuID17",
	                            type : "custom",
	                            title :  iRemoteFB.GlobalVideoArray.name,
	                            name : "Write a Comment",
	                            icon : "example/a.png",
	                            onClick : "action?select=videoComment"
	                         }
	                        }
	                        makeMenuData[1] = {
	                            identifier : "menuID18",
	                            type : "custom",
	                            title : FBID_SHARE,
	                            name : FBID_SHARE,
	                            icon : "example/a.png",
	                            onClick : "action?videoShare="+ iRemoteFB.GlobalId
	                         }
	                         makeMenuData[2] = {
	                            identifier : "menuID19",
	                            type : "custom",
	                            title : SID_TOOLS,
	                            name : SID_TOOLS,
	                            icon : "example/a.png",
	                            onClick : "action?menu=tools"
	                         }
	                         jQuery.sfIRemote('menu', makeMenuData);  	
	                         iRemoteFB.VideoPlay();
*/
							 iRemoteFB.openRemote(); 
	                         iRemoteFB.toolsFlag = 0;
	                    }
					}                    
                    else{						
						if (Instance.Frame.getType() == FacebookFrame.Define.ME) {
							if (checkBrowserVersion()) {
								
								
							}
						}
						else {
							var makeMenuData = "";
							var makeMenuData = new Array();
							
							makeMenuData[0] = {
								identifier: "menuID34",
								type: "custom",
								title: User.name,
								name: FBID_WALL,
								icon: "example/a.png",
								onClick: "action?select=userWall"
							}
							makeMenuData[1] = {
								identifier: "menuID33",
								type: "custom",
								title: User.name,
								name: SID_INFO_CASE,
								icon: "example/a.png",
								onClick: "action?select=userInfo"
							}
							makeMenuData[2] = {
								identifier: "menuID32",
								type: "custom",
								title: User.name,
								name: FBID_PHOTOS,
								icon: "example/a.png",
								onClick: "action?select=userPhotosProfile"
							}
							makeMenuData[3] = {
								identifier: "menuID31",
								type: "custom",
								title: User.name,
								name: SID_VIDEOS,
								icon: "example/a.png",
								onClick: "action?select=userVideosProfile"
							}
							if (checkBrowserVersion()) {
								//jQuery.sfIRemote('menu', makeMenuData);
							}
						}						
                        if(toolspop == 1){
                            iRemoteFB.toolsFlag =1;
                            var makeMenuData ="";
                            var makeMenuData ="";
                            makeMenuData = {
                                identifier : "menuID19",
                                type : "mediacontrol",
                                title : SID_TOOLS,
                                name : SID_TOOLS,
                                icon : "example/a.png"
                             }
							 if (checkBrowserVersion()) {
							 	jQuery.sfIRemote('menu', makeMenuData);
							 }
                             toolspop =0;
                        }                       
                        else{							
                            if(prevMode == 13){
                            	iRemoteFB.onLoadStatusUpdate(NewsFeedArray);	
                            }else if(prevMode == 14){
                                iRemoteFB.onLoadVidoes(NewsFeedArray);
                            }
                            else if(prevMode == 11){
                                iRemoteFB.showNews(NewsFeedArray, 12);
                            }else if(prevMode == 10){
                                iRemoteFB.showWall(NewsFeedArray, 13);
                            }else if(prevMode == 102){
                                iRemoteFB.showProfileDetailsVideos(iRemoteFB.ProfileVideoList);	
                            }
							_this_.close();
                            returnFn(updateFlag ? Facebook.Define.Update : false, lastFocus);
                        }
                    }
                }
                 
				/*End Interactive Device*/
				break;
			case TV.KEY_GREEN :
				if (bGlobalLoading) return;
				instanceState = Facebook.Define.Processing;
				iCommentsAdd.enterVID(curVideo.post_id);
				break;
//			case TV.KEY_YELLOW : 
//				if (bGlobalLoading) return;
//				shareContents(curVideo);
//				break;
			case TV.KEY_RED :
				if (bGlobalLoading) return;
				if (Instance.Frame.getType() != FacebookFrame.Define.ME) {
					_this_.close();
				}
				break;
			case TV.KEY_VOL_UP: 
				if (Instance.Audio.volumeUp())
					iView.setVolumeOSD();
				break;
			case TV.KEY_VOL_DOWN: 
				if (Instance.Audio.volumeDown())
					iView.setVolumeOSD();
				break;
			case TV.KEY_MUTE:
				if(Instance.Audio.mute())
					iView.setVolumeOSD();
				break;
			case TV.KEY_TOOLS : 
				toolspop = 1;
				if (bGlobalLoading) return;
				// [DMS00740113] Divied for BD 
				// BD has no Picture/Sound Setting menu
				if (Instance.GMF.getState() != GMFPlayer.STOPPED) {
					if (Instance.Main.getManagerSetting().product != PL_TV_PRODUCT_TYPE_BD) {
						iTools.open(function(){
							Instance.Main.restoreKeyHandler();
						});
						Instance.Main.setKeyHandler(iTools.getKeyHandler(), 'iTools');
					}
				}
				break;
			default :
				break;
		}
	}

	function CommentsListCallback(pReturn) {
		instanceState = Facebook.Define.None;
		if (pReturn == Facebook.Define.Close) {
			_this_.close();
			return;
		}
		iView.show();
		iProgress.open();
		iComments.open();
		iComments.refresh();
		if (pReturn) {
			updateFlag = true;
			iComments.request(curVideo.post_id, Facebook.Define.IDTYPE_OBJECT);
		}
		Instance.Main.setKeyHandler(keyHandler,"VideoDetail");
	}

	function UpdateCallbackFn(pResult) {
		if (pResult) {
			updateFlag = true;
			iComments.request(curVideo.post_id, Facebook.Define.IDTYPE_OBJECT);
		} else {
			instanceState = Facebook.Define.None;
		}
		iComments.refresh();
		Instance.Main.setKeyHandler(keyHandler,"VideoDetail");
	}
	/*Start Interactive Device*/
	ICommentsAdd = iCommentsAdd;
	/*End Interactive Device*/
		/* 
	 * 		Share Data Spec.
	 * 		{	
	 * 		src : Picture Source,
	 * 		type : Share Object Type,
	 * 		name : Share Name,
	 * 		attachment : Share Contents
	 * 		}
	 */
	/*Start Interactive Device*/
	VideoStreamShare = iStreamShare;
	/*End Interactive Device*/

    function shareContents(pStream){
        var curStream = pStream.body;

        var objShare = {
			src : curStream.attachment.media[0].src
			, type : curStream.attachment.fb_object_type
			, name : curStream.attachment.name
        };
		
		if (pStream.singleMode) {
			objShare.pic_square = curStream.pic_square;
			objShare.writter = curStream.name;
		} else {
			objShare.writter = pStream.writter;
			objShare.pic_square = pStream.pic_square;
		}
        
		objShare.attachment = Util.copyObject(curStream.attachment);
		objShare.attachment.media[0].src = curStream.attachment.media[0].src;
		objShare.attachment.media[0].video_src = curStream.attachment.media[0].video.source_url;
		objShare.attachment.media[0].preview_img = curStream.attachment.media[0].src;
		objShare.attachment.media[0].video_title = curStream.attachment.name;
		objShare.attachment.properties = {};
		objShare.attachment.properties[curStream.attachment.properties[0].name] = curStream.attachment.properties[0].text;
		delete objShare.attachment.fb_object_id;
		delete objShare.attachment.description;
		objShare.attachment.share = "true";
		instanceState = Facebook.Define.Processing;
		iStreamShare.enter(objShare);
    }
	
	function innerCommentsListnerFn(pEvent, pArgs) {
		switch(pEvent) {
			case Facebook.Define.Update : 
				// In this case, pArgs is quantity of pages
				objInnerComments.nPage = pArgs.nPage;
				objInnerComments.nItem = pArgs.nItem;
				Instance.Main.registHelpNavi(generateHelpNavi(),"VideoDetail");
				if (Instance.Main.getKeyHandler() == "VideoDetail") {
					Instance.Main.applyHelpNavi("VideoDetail");
				}
				instanceState = Facebook.Define.None;
				break;
			case VideoDetail.Define.ON_GLOBAL_LOADING :
				return bGlobalLoading;
				break;
			case VideoDetail.Define.OFF_GLOBAL_LOADING :
				var retValue =  bGlobalLoading;
				if (bGlobalLoading) {
					Instance.Loading.close();
					iRemoteFB.hideLoading();
					bGlobalLoading = false;
					if (bPlayerLoading) {
						iVideoInnerLoading.open();
					}
				}
				return retValue;
				break;
			default :
				break;
		}
	}
}

VideoDetail.Define = {};
VideoDetail.Define.ON_GLOBAL_LOADING = 11;
VideoDetail.Define.OFF_GLOBAL_LOADING = 12;