var PreviewFacebook = {
	widgetID : "",
	widgetPath : "",
	languageCode : 0,
	callback : null
}

PreviewFacebook.Caption = {};
PreviewFacebook.Caption['fi'] = "Sosiaalinen apuohjelma, jonka avulla ihmiset voivat pitää yhteyttä ystäviin ja muihin.";
PreviewFacebook.Caption['et'] = "Suhtlusprogramm, mis ühendab inimesi sõprade ja teiste inimestega.";
PreviewFacebook.Caption['lt'] = "Socialinių paslaugų priemonė, leidžianti susisiekti žmonėms su draugais ir kitais žmonėmis.";
PreviewFacebook.Caption['it'] = "Social utility per entrare in contatto con amici e altre persone.";
PreviewFacebook.Caption['hu'] = "Barátokat, ismerősöket összekapcsoló közösségi hálózat.";
PreviewFacebook.Caption['hr'] = "Društvena alatka koja povezuje osobe s prijateljima i drugima.";
PreviewFacebook.Caption['fr'] = "Utilitaire social permettant d'être en contact avec ses amis et les autres utilisateurs.";
PreviewFacebook.Caption['es'] = "Utilidad social que conecta a la gente entre sí.";
PreviewFacebook.Caption['en'] = "Social utility connecting people<br>with friends and others.";
PreviewFacebook.Caption['en-GB'] = "Social utility connecting people with friends and others.";
PreviewFacebook.Caption['el'] = "Κοινωνικό βοηθητικό πρόγραμμα που συνδέει τους χρήστες με τους φίλους τους και άλλα άτομα.";
PreviewFacebook.Caption['de'] = "Soziales Dienstprogramm, das Menschen mit Freunden und anderen Personen verbindet.";
PreviewFacebook.Caption['da'] = "Socialt redskab, der holder kontakt til bl.a. venner.";
PreviewFacebook.Caption['cs'] = "Společenský nástroj spojující uživatele s přáteli a dalšími uživateli.";
PreviewFacebook.Caption['bg'] = "Социална помощна програма за връзка с приятели и др.";
PreviewFacebook.Caption['zh-TW'] = "將人們與朋友及他人聯繫在一起的社交公用程式。";
PreviewFacebook.Caption['zh-HK'] = "將人們與好友及他人聯繫在一起的社交公用程式。";
PreviewFacebook.Caption['zh-CN'] = "帮助人们与好友或其他人进行联络的社交小工具。";
PreviewFacebook.Caption['tr'] = "İnsanların arkadaşları ve başkalarıyla iletişim kurmasını sağlayan sosyal program.";
PreviewFacebook.Caption['th'] = "ยูทิลิตี้ทางสังคมเพื่อการติดต่อกับเพื่อนๆ และบุคคลอื่นๆ";
PreviewFacebook.Caption['sv'] = "Socialt verktyg som förenar människor med vänner och andra personer.";
PreviewFacebook.Caption['sr'] = "Društvena mreža koja povezuje korisnike sa prijateljima i drugim korisnicima.";
PreviewFacebook.Caption['sk'] = "Spoločenský nástroj spájajúci používateľov s priateľmi a ďalšími používateľmi.";
PreviewFacebook.Caption['ru'] = "Социальная сеть, которая помогает общаться с друзьями и другими людьми.";
PreviewFacebook.Caption['ro'] = "Utilitar social care ajută utilizatorii să păstreze legătura cu prietenii şi cu alte persoane.";
PreviewFacebook.Caption['pt'] = "Utilitário social que liga as pessoas aos amigos e a outras pessoas.";
PreviewFacebook.Caption['pt-US'] = "Serviço de utilidade pública que conecta as pessoas com amigos e conhecidos.";
PreviewFacebook.Caption['pl'] = "Usługa społecznościowa, dzięki której można się łączyć z przyjaciółmi i innymi osobami.";
PreviewFacebook.Caption['no'] = "Sosialt verktøy som knytter mennesker sammen med venner og andre.";
PreviewFacebook.Caption['nl'] = "Sociaal programma om met vrienden en andere mensen in aanraking te komen.";
PreviewFacebook.Caption['lv'] = "Sabiedriska utilīta cilvēku savienošanai ar draugiem un citiem cilvēkiem.";
PreviewFacebook.Caption['ko'] = "인맥기반 친목 도모 서비스입니다.";

PreviewFacebook.init = function (pWidgetPath, pWidgetID, pSendPreviewFunc, pLoadingFunc, pArg) {
	TRACE ("PreviewFacebook.init("+pWidgetID+")",TRACE_LEVEL.INFO);

	this.widgetID = pWidgetID;
	this.widgetPath = pWidgetPath;
	this.callback = pSendPreviewFunc;
	this.languageCode = pArg.lang;
	
	TRACE ("PreviewFacebook.init() End",TRACE_LEVEL.INFO);
}

PreviewFacebook.requestPreview = function() {
	TRACE ("PreviewFacebook.requestPreview()",TRACE_LEVEL.INFO);
	this.callback(this.generatePreviewHTML());
}

PreviewFacebook.generatePreviewHTML = function () {
	TRACE ("PreviewFacebook.generatePreviewHTML()",TRACE_LEVEL.INFO);
	
    var tmpHtml = "<div style = 'position:absolute;top:0px;left:0px;'>";
	tmpHtml += "<img style = 'position:absolute;top:0px;left:0px;' src = '"+this.widgetPath + this.widgetID + "/Resource/icon/nnavi_icon_facebook 1.png'>";
    tmpHtml += "</div>";
	var languageKeyword = new Common.Util.Language().convertCodeToKeyword(parseInt(this.languageCode,10));
	var strCaption = PreviewFacebook.Caption[languageKeyword] ? PreviewFacebook.Caption[languageKeyword] : PreviewFacebook.Caption['en'];
	tmpHtml += "<div style = 'position:absolute;top:47px;width:130px;left:20px;line-height:18pt;font-size:12pt;color:#FFFFFF;text-align:left;'>" + strCaption + "</div>";

	TRACE ("PreviewFacebook.generatePreviewHTML() End",TRACE_LEVEL.INFO);
    return tmpHtml;
}

PreviewFacebook.onHidePreview = function() {

}