function RequestList(pViewInstance, pDataInstance, pReturnFn) {
	var iView = pViewInstance;
	var iData = pDataInstance;
	var returnFn = pReturnFn;
	
	var nRow = 6;
	var nCol = 2;
	
	var iFocus = new FocusMapper("RequestList",nRow,nCol);
	
	var objPages = [];
	objPages[0] = [];
	
	var nCurPage = 0;

	var bOpened = false;
	var bReady = false;
    
	this.isOpened = function(){
        return bOpened;
    }
    
	this.isReady = function(){
        return bReady;
    }
	
	// External Interface
	this.open = function() {
		bOpened = true;
		
		iView.show();
		iData.request(OnLoadData);
	}
	
	this.close = function() {
		bOpened = false;
		bReady = false;
		
		iView.clear();
		iView.hide();
	}
	
	this.enter = function() {
		if (!bReady) {	 returnFn(); return; }
		
		Instance.Main.registHelpNavi(generateHelpNavi(),"RequestList");
		Instance.Main.setKeyHandler(keyHandler,"RequestList");
		iView.focus(iFocus.getFocus());
	}

	function generateHelpNavi() {
		var arrHelp = [];
		if (iFocus.getTotalPage() > 1) 
			arrHelp[arrHelp.length] = {	image : HelpArea.Image.FFRW,		text : SID_PAGE_UP_DOWN	};
		arrHelp[arrHelp.length] = {	image : HelpArea.Image.Return,	text : SID_RETURN			};
		return arrHelp;
	}

	function OnLoadData(pRequests) {
		if (!bOpened) return;
		if (pRequests) {
			bReady = true;
            
			objPages = generatePage(pRequests);			
            /* Start Interactive Device */
			iRemoteFB.requestObj = pRequests;
            iRemoteFB.ShareObjPages = objPages;
            /* End Interactive Device */
			iFocus.generate(objPages);
			requestPage(iFocus.getFocus().page);
		} else {
        /* Start Interactive Device */			
            iRemoteFB.noContentPopup(SID_NO_FRIEND_REQUESTS, SID_NO_PENDING_FRIEND_REQUESTS);
			/* End Interactive Device */
			bReady = false;
			iView.request(false);
		}
	}
	
	function requestPage(pPage) {
		iFocus.setPage(pPage);
		iView.request(objPages[pPage], iFocus);
		 /*Start Interactive Device */	
		if(iRemoteFB.menuFlag == 1){
			iMenu.enter();
			iRemoteFB.menuFlag = 0;
		}
   	        /*End Interactive Device */	
	}
	
	function generatePage(pRequests) {
		var requestLength = pRequests.length;
		var objPages = [];
		var nCurPage = 0;
		objPages[nCurPage] = [];
		
		var arrRow = null;
		var columnItem = null;
		
		for (var reqIdx = 0; reqIdx < requestLength; reqIdx++) {
			if (objPages[nCurPage].length >= nRow) {		// change to next page
				nCurPage++;
				objPages[nCurPage] = [];
			}
			
			arrRow = [];
			
			// Add name button info
			columnItem = {};
			columnItem.data = pRequests[reqIdx];
			columnItem.data.total = requestLength;
			columnItem.actor = function () {
				Instance.Frame.open(objPages[iFocus.getFocus().page][iFocus.getFocus().row][0].data.uid);
			}
			arrRow.push(columnItem);
			
			// Add empty cell
			columnItem = {};
			columnItem.disable = true;
			arrRow.push(columnItem);
			
			objPages[nCurPage].push(arrRow);
			
			arrRow = [];
			
			// Add Confirm button info
			columnItem = {};
			columnItem.actor = function (reqIdx) {
				return function () {
                    /* Start Interactive Device */
					iRemoteFB.confirmcancelrequestpopup(SID_ARE_YOU_SURE_TO_CONFIRM_THE_FRIEND_REQUEST,reqIdx, pRequests[reqIdx].uid,1);
                    /* End Interactive Device */
					Instance.Popup.enter({
		                title: '',
		                message: SID_ARE_YOU_SURE_TO_CONFIRM_THE_FRIEND_REQUEST,
		                buttons: [{ caption: SID_OK, value: pRequests[reqIdx].uid },{ caption: SID_CANCEL, value: false}],
						focus: 1		// focus button location
		            }, function(pReturn) {
						if (pReturn) {
							// [100412/DMS00733314] wating XHR result
							Instance.Main.setKeyHandler(sKeyHandler,"RequestList");
							//
							iView.clear();
                            /* Start Interactive Device */
                            iRemoteFB.hidePopup(); 
                            /* End Interactive Device */
							iData.confirm(pReturn, confirmCallback);
						} else {
							iView.show();
                            /* Start Interactive Device */
                             iRemoteFB.hidePopup(); 
                             /* End Interactive Device */
							iView.focus(iFocus.getFocus());
						}
					});
				}
			}(reqIdx);

			arrRow.push(columnItem);
			
			// Add Ignore button info
			columnItem = {};
			columnItem.actor = function (reqIdx) {
				return function () {
                   /* Start Interactive Device */
                    iRemoteFB.confirmcancelrequestpopup(SID_ARE_YOU_SURE_TO_IGNORE_THE_FRIEND_REQUEST, reqIdx, pRequests[reqIdx].uid,0);
                    /* End Interactive Device */
					Instance.Popup.enter({
		                title: '',
		                message: SID_ARE_YOU_SURE_TO_IGNORE_THE_FRIEND_REQUEST,
		                buttons: [{ caption: SID_OK, value: pRequests[reqIdx].uid },{ caption: SID_CANCEL, value: false}],
						focus: 1		// focus button location
		            }, function(pReturn) {
						if (pReturn) {
							// [100412/DMS00733314] wating XHR result
							Instance.Main.setKeyHandler(sKeyHandler,"RequestList");
							//
							iView.clear();
                            /* Start Interactive Device */
                            iRemoteFB.hidePopup(); 
                            /* End Interactive Device */
							iData.ignore(pReturn, confirmCallback);
						} else {
							iView.show();
                            /* Start Interactive Device */
                          	iRemoteFB.hidePopup(); 
                            /* End Interactive Device */
							iView.focus(iFocus.getFocus());
						}
					});
				}
			}(reqIdx);
			
			arrRow.push(columnItem);
			
			objPages[nCurPage].push(arrRow);
		}
		
		return objPages;
	}
    /* Start Interactive Device */
    this.getiData = function(){
    return iData;
    }
    this.confirmCallbackforiPhone = function(pResult) {
		// pResult is true or false
		// how to work on 'false'?
        
		iView.show();
		iData.request(function(pRequests) {
			if (!bOpened) return;
			
			// [100412/DMS00733314] wating XHR result
			if (Instance.Main.getKeyHandler() == 'RequestList') {
				Instance.Main.restoreKeyHandler();
			}
			
			if (pRequests) {
				bReady = true;
                /* Start Interactive Device */
               iRemoteFB.friendRequest(pRequests);
               /* End Interactive Device */
				objPages = generatePage(pRequests);
				iFocus.generate(objPages);	
				requestPage(iFocus.getFocus().page);
				if (Instance.Main.getKeyHandler() == 'RequestList') {
					iView.focus(iFocus.getFocus());
				}
			} else {
				bReady = false;
                /* Start Interactive Device */
               
				iRemoteFB.noContentPopup(SID_NO_FRIEND_REQUESTS, SID_NO_PENDING_FRIEND_REQUESTS);
                /* End Interactive Device */     
				iView.request(false);
				// [DMS00741621] return to main menu
				returnFn();
			}
		});
	}
    /* End Interactive Device */
	function confirmCallback (pResult) {
		// pResult is true or false
		// how to work on 'false'?
		iView.show();
		iData.request(function(pRequests) {
			if (!bOpened) return;
			
			// [100412/DMS00733314] wating XHR result
			if (Instance.Main.getKeyHandler() == 'RequestList') {
				Instance.Main.restoreKeyHandler();
			}
			
			if (pRequests) {
				bReady = true;
                /* Start Interactive Device */
               	iRemoteFB.friendRequest(pRequests);
                /* End Interactive Device */
				objPages = generatePage(pRequests);
				iFocus.generate(objPages);
	
				requestPage(iFocus.getFocus().page);
				
				// [100412/DMS00733314] wating XHR result
				if (Instance.Main.getKeyHandler() == 'RequestList') {
					iView.focus(iFocus.getFocus());
				}
			} else {
				bReady = false;
				iView.request(false);
                /* Start Interactive Device */              
				iRemoteFB.noContentPopup(SID_NO_FRIEND_REQUESTS, SID_NO_PENDING_FRIEND_REQUESTS);
                /* End Interactive Device */
				// [DMS00741621] return to main menu
				returnFn();
			}
		});
	}
	
	function keyHandler(pKeyCode) {
		switch(pKeyCode) {
			case TV.KEY_RIGHT :
			case TV.KEY_PANEL_VOL_DOWN :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.right()) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_LEFT :
			case TV.KEY_PANEL_VOL_UP :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.left()) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				} else {
					iView.blur(iFocus.getFocus());
					/*Start Interactive Device */	
					iRemoteFB.onLoadFacebook();
					iRemoteFB.onLoadHome();
					/*End Interactive Device */	
					returnFn();
				}
				break;
			case TV.KEY_UP :
			case TV.KEY_WHEELUP :
			case TV.KEY_PANEL_CH_UP :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.up()) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				} else {
					requestPage(iFocus.getFocus().page);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_DOWN :
			case TV.KEY_WHEELDOWN :
			case TV.KEY_PANEL_CH_DOWN :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.down()) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				} else {
					requestPage(iFocus.getFocus().page);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_FF :
				if (iFocus.nextPage(true)) {
					requestPage(iFocus.getFocus().page);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_RW :
				if (iFocus.prevPage(true)) {
					requestPage(iFocus.getFocus().page);
					iView.focus(iFocus.getFocus());
				}
				break;				
			case TV.KEY_ENTER :
//				iView.clear();
				objPages[iFocus.getFocus().page][iFocus.getFocus().row][iFocus.getFocus().col].actor();
//				Instance.Frame.open(objPages[iFocus.getFocus().page][iFocus.getFocus().row][0].uid);
				break;
			case TV.KEY_RETURN : 
				// Return to main menu	
				iView.blur(iFocus.getFocus());
				/*Start Interactive Device */	
				iRemoteFB.onLoadFacebook();
				iRemoteFB.onLoadHome();
				 /*End Interactive Device */	
				returnFn();
				break;
			default :
				break;
		}
	}
	
	// key handler for wating XHR result.
	function sKeyHandler(pKeyCode) {
		switch(pKeyCode) {
			case TV.KEY_RETURN : 
				// Return to main menu
				returnFn();
				break;
			default :
				break;
		}
	}
}


var testData = [{
        "name": "Dae-Ki Cho",
        "uid": 1162489694,
        "pic_square": "http:\/\/profile.ak.fbcdn.net\/v225\/1562\/20\/q1162489694_5215.jpg"
    }, {
        "name": "Hyun Park",
        "uid": 1693247418,
        "pic_square": "http:\/\/profile.ak.fbcdn.net\/v229\/329\/111\/q1693247418_7432.jpg"
    },{
        "name": "한가인",
        "uid": 1162489694,
        "pic_square": "http:\/\/profile.ak.fbcdn.net\/v225\/1562\/20\/q1162489694_5215.jpg"
    }, {
        "name": "한채영",
        "uid": 1693247418,
        "pic_square": "http:\/\/profile.ak.fbcdn.net\/v229\/329\/111\/q1693247418_7432.jpg"
    },{
        "name": "태연",
        "uid": 1162489694,
        "pic_square": "http:\/\/profile.ak.fbcdn.net\/v225\/1562\/20\/q1162489694_5215.jpg"
    }, {
        "name": "김태희",
        "uid": 1693247418,
        "pic_square": "http:\/\/profile.ak.fbcdn.net\/v229\/329\/111\/q1693247418_7432.jpg"
    }]