function StreamFilter(pViewInstance, pReturnFn) {
	var _this_ = this;
	
	var iView = pViewInstance;
	var returnFn = pReturnFn;
	
	var objPages = [];
	
	var nRow = 1, nCol = 4;
	var iFocus = new FocusMapper("StreamFilter",nRow, nCol);
	
	// External Interface
	this.open = function() {
		iView.show();
	}
	
	this.close = function() {
		iView.hide();
	}
	
	this.enter = function(pFilter) {
		Instance.Main.registHelpNavi(generateHelpNavi(),"StreamFilter");
		Instance.Main.setKeyHandler(keyHandler,"StreamFilter");
		
		generatePage();
		iFocus.generate(objPages);
		iFocus.setPage(0);

		iView.show();
		iView.request(objPages[0],iFocus);
		var tColumn = 0;
		switch(pFilter) {
			case Stream.Define.All 		: tColumn = 0;	break;
			case Stream.Define.Text 	: tColumn = 1; 	break;
			case Stream.Define.Photo 	: tColumn = 2; 	break;
			case Stream.Define.Video 	: tColumn = 3;	break;
		}
        iFocus.setFocus({
            col: tColumn
        });
		iView.focus(iFocus.getFocus());
	}
	
	function generateHelpNavi() {
		var arrHelp = null;
		arrHelp = [
			{	image : HelpArea.Image.Return,	text : SID_RETURN			}
		];
		return arrHelp;
	}
	
	function generatePage(pData) {
		objPages[0] = [[SID_ALL,FBID_STATUS_UPDATE_CL,FBID_PHOTOS,SID_VIDEOS]];
	}
	
	function keyHandler(pKeyCode) {
		switch(pKeyCode) {
			case TV.KEY_RIGHT :
			case TV.KEY_PANEL_VOL_DOWN :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.right(true)) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_LEFT :
			case TV.KEY_PANEL_VOL_UP :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.left(true)) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_UP :
			case TV.KEY_WHEELUP :
			case TV.KEY_PANEL_CH_UP :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.up()) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_DOWN :
			case TV.KEY_WHEELDOWN :
			case TV.KEY_PANEL_CH_DOWN :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.down()) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_FF :
				if (iFocus.nextPage(true)) {
					requestPage(iFocus.getFocus().page);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_RW :
				if (iFocus.prevPage(true)) {
					requestPage(iFocus.getFocus().page);
					iView.focus(iFocus.getFocus());
				}
				break;				
			case TV.KEY_ENTER :
				iView.hide();
				var returnType = 0;
				switch(iFocus.getFocus().col) {
					case 0 :
						returnType = Stream.Define.All;
						break;
					case 1 :
						returnType = Stream.Define.Text;
						break;						
					case 2 :
						returnType = Stream.Define.Photo;
						break;						
					case 3 :
						returnType = Stream.Define.Video;
						break;						
				}
				returnFn(returnType);
				break;
			case TV.KEY_RETURN : 
				// Return to main menu	
				iView.blur(iFocus.getFocus());
				iView.hide();
				returnFn(false);
				break;
			default :
				break;
		}
	}
}