function StreamNewsData() {
    var userID = "";
    var completeFn = null;
    
	this.getID = function() {
		return userID;
	}
	
    this.request = function(pUserID, pCompleteFn){
		userID = pUserID;
		
		Instance.Loading.open();
        /* Start Interactive Device */
        iRemoteFB.showLoading("Loading Data");
        /* End Interactive Device */
        completeFn = pCompleteFn;
        
        var strMultiQuery = '{\"streams\": \"SELECT post_id, actor_id, source_id, target_id, message, comments, created_time, attachment, app_data, updated_time, type FROM stream WHERE source_id in (SELECT target_id FROM connection WHERE source_id=\''+userID+'\')" ,\"profile\" : \"SELECT uid, name, pic_square FROM user WHERE uid IN (SELECT source_id FROM #streams)\"}';
		
        Instance.API.fql.multiquery(function(pXMLHttpRequest){
            OnLoadData(pXMLHttpRequest);
        }, Instance.API.createAPIParams({
            queries: strMultiQuery,
            format: "JSON"
        }));
        
    }
    
    function OnLoadData(pXMLHttpRequest){
		
        if (!Instance.Main.checkNetworkError(pXMLHttpRequest)) return;
        var objResponse = Util.DecodeJSON(pXMLHttpRequest.responseText);
		if (objResponse.error_code) {
			// If returned XHR is error, show error message and exit widget
//			Instance.Loading.close();
//			Instance.Popup.enter({
//				idleSec : 10, 
//                title: objResponse.error_code,
//                message: objResponse.error_msg,
//                buttons: [{ caption: SID_OK, value: true}]
//            }, function(){
//				WIDGET.sendReturnEvent();
//			});
			Instance.Loading.close();
              /* Start Interactive Device */
            iRemoteFB.hideLoading();            
			iRemoteFB.errormsgPopup(SID_ALERT_NETWORKERROR_MSG);
              /* End Interactive Device */
			Instance.Popup.enter({
                title: FACEBOOK_NAME,
                message: SID_ALERT_NETWORKERROR_MSG,
                buttons: [{ caption: SID_OK, value: true}]
            }, function(){});
			return;
		}
		
        var objStream = null;
		var objProfile = null;
		
		if (objResponse[0].name == "streams") {
			objStream = objResponse[0].fql_result_set;
		}

		if (objResponse[1].name == "profile")	{
			objProfile = objResponse[1].fql_result_set;
		}
		var refProfile = {};
		var objProfileLength = objProfile.length;
		for (var profileIdx = 0; profileIdx < objProfileLength; profileIdx++) {
            refProfile[objProfile[profileIdx].uid] = {
                name: objProfile[profileIdx].name,
                pic_square: objProfile[profileIdx].pic_square
            };
		}

		var objStreamLength = objStream.length;
		var tempStream = [];
		var tID = "";
		for (var streamIdx = 0; streamIdx < objStreamLength; streamIdx++) {
			tID = objStream[streamIdx].actor_id;
			if (refProfile[tID]) {
				objStream[streamIdx].pic_square = refProfile[tID].pic_square ? refProfile[tID].pic_square : "http://static.ak.fbcdn.net/pics/q_silhouette.gif";
				objStream[streamIdx].name = refProfile[tID].name;
				tempStream.push(objStream[streamIdx]);
			}
			else {
				objStream[streamIdx].pic_square = "http://static.ak.fbcdn.net/pics/q_silhouette.gif";
				objStream[streamIdx].name = "Unknown";
			}
		}
		
		Instance.Loading.close();
           /* Start Interactive Device */
        iRemoteFB.hideLoading();
           /* End Interactive Device */
        completeFn({
			mode : Facebook.Define.NEWSFEED,
			result : tempStream
		});
    }
	
	this.del = function(pCommentID, pCompleteFn){
		Instance.Loading.open();
           /* Start Interactive Device */
        iRemoteFB.showLoading("Loading Data");
           /*End Interactive Device */
        completeFn = pCompleteFn;
        
        Instance.API.stream.removeComment(function(pXMLHttpRequest){
            DeleteOnComplete(pXMLHttpRequest);
        }, Instance.API.createAPIParams({
            comment_id: pCommentID,
            format: "JSON"
        }));
        
    }
    
    function DeleteOnComplete(pXMLHttpRequest){
		
        if (!Instance.Main.checkNetworkError(pXMLHttpRequest)) return;
		
        FBTrace(pXMLHttpRequest.responseText);
        var objResponse = Util.DecodeJSON(pXMLHttpRequest.responseText);
		
		Instance.Loading.close();	
           /* Start Interactive Device */
        iRemoteFB.hideLoading();
           /* End Interactive Device */
        completeFn();
    }
	
	var fnCheckCallback = null;
	this.checkUpdate = function(pPostID, pCheckCallback) {
		Instance.Loading.open();
        fnCheckCallback = pCheckCallback;
        var strMultiQuery = '{\"streams\": \"SELECT post_id, actor_id, source_id, target_id, message, comments, created_time, attachment, app_data, updated_time, type FROM stream WHERE post_id =\''+pPostID+'\'" ,\"profile\" : \"SELECT uid, name, pic_square FROM user WHERE uid IN (SELECT source_id FROM #streams)\"}';
        Instance.API.fql.multiquery(function(pXMLHttpRequest){
            OnLoadCheck(pXMLHttpRequest);
        }, Instance.API.createAPIParams({
            queries: strMultiQuery,
            format: "JSON"
        }));
		function OnLoadCheck(pXMLHttpRequest) {
	        if (!Instance.Main.checkNetworkError(pXMLHttpRequest)) return;
	        var objResponse = Util.DecodeJSON(pXMLHttpRequest.responseText);
			if (objResponse.error_code) {
				// If returned XHR is error, show error message and exit widget
				Instance.Loading.close();
				Instance.Popup.enter({
	                title: FACEBOOK_NAME,
	                message: SID_ALERT_NETWORKERROR_MSG,
	                buttons: [{ caption: SID_OK, value: true}]
	            }, function(){});
				return;
			}
			Instance.Loading.close();
			var oResult = objResponse["fql_result_set"];
			if (oResult && oResult instanceof Array && oResult[0].post_id) {
				if (fnCheckCallback && fnCheckCallback instanceof Function)
					fnCheckCallback(true);
			} else {
				alert("[Facebook(OnLoadCheck)] There is no post which you check.");
				fnCheckCallback(false);
			}
		}
	}
}
