function StreamShareAddFriends(pViewInstance, pDataInstance, pReturnFn) {
	var _this_ = this;
	
	var iView = pViewInstance;
	var iData = pDataInstance;
	var returnFn = pReturnFn;
	var returnList = [];
	
	var objPages = [];
	
	var nRow = 6, nCol = 1;
	var iFocus = new FocusMapper("StreamShareAddFriends",nRow, nCol);
	
	// External Interface
	this.open = function() {
		iView.show();
		iView.focus(iFocus.getFocus());
		Instance.Main.setKeyHandler(keyHandler,"StreamShareAddFriends");
	}
	
	this.close = function() {
		iView.hide();
	}
	
	this.enter = function() {
		Instance.Main.setKeyHandler(keyHandler,"StreamShareAddFriends");
		iData.request(OnLoadData);
	}
	
	function OnLoadData(pData) {
		generatePage(pData);
		iFocus.generate(objPages);
		requestPage(iFocus.getFocus().page);
		iView.show();
	}
	
	function requestPage(pPage) {
		iFocus.setPage(pPage);
		iView.request(objPages[pPage],iFocus);
		iView.focus(iFocus.getFocus());
	}
	
	function generatePage(pData) {
		var dataLength = pData.length;
		var itemBuffer = [];
		var lineBuffer = [];
		var nPage = 0;
		objPages[nPage] = [];
		
		for (var dataIdx = 0; dataIdx < dataLength; dataIdx++) {
			if (itemBuffer.length >= nCol) {
				flushItem();
			}
			pData[dataIdx].checked = false;
			pData[dataIdx].actor = function(dataIdx) {
				return function() {
					pData[dataIdx].checked = pData[dataIdx].checked ? false : true;
					iFocus.refresh(objPages);
					iView.request(objPages[iFocus.getFocus().page],iFocus);
					iView.focus(iFocus.getFocus());
				}
			}(dataIdx);
			itemBuffer.push(pData[dataIdx]);
		}
		flushItem();
		flushLine();
		
		nTotalPages = objPages.length;
		
		function flushItem() {
			if (lineBuffer.length >= nRow) {
				if (!(objPages[nPage] instanceof Array)) objPages[nPage]  = [];
				objPages[nPage++] = Util.copyArray(lineBuffer);
				lineBuffer = [];
			}
			lineBuffer.push(Util.copyArray(itemBuffer));
			itemBuffer = [];
		}
		
		function flushLine() {
			if (lineBuffer.length > 0) {
				if (!(objPages[nPage] instanceof Array)) objPages[nPage]  = [];
				objPages[nPage]= Util.copyArray(lineBuffer);
			}
		}
	}
	
	function returnListFn() {
		iView.show();
		Instance.Main.setKeyHandler(keyHandler,"");
	}
	
	function keyHandler(pKeyCode) {
		switch(pKeyCode) {
			case TV.KEY_RIGHT :
			case TV.KEY_PANEL_VOL_DOWN :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.right()) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_LEFT :
			case TV.KEY_PANEL_VOL_UP :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.left()) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				} else {
					iView.blur(iFocus.getFocus());
					returnFn();
				}
				break;
			case TV.KEY_UP :
			case TV.KEY_WHEELUP :
			case TV.KEY_PANEL_CH_UP :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.up()) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_DOWN :
			case TV.KEY_WHEELDOWN :
			case TV.KEY_PANEL_CH_DOWN :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.down()) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_FF :
				if (iFocus.nextPage(true)) {
					requestPage(iFocus.getFocus().page);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_RW :
				if (iFocus.prevPage(true)) {
					requestPage(iFocus.getFocus().page);
					iView.focus(iFocus.getFocus());
				}
				break;				
			case TV.KEY_ENTER :
				objPages[iFocus.getFocus().page][iFocus.getFocus().row][iFocus.getFocus().col].actor();
				break;
			case TV.KEY_RETURN : 
				// Return to main menu	
				iView.hide();
				iView.blur(iFocus.getFocus());
				returnFn(generateReturnData());
				break;
			default :
				break;
		}
	}
	
	function generateReturnData() {
		pageLength = objPages.length;
		returnList = [];
		for (var pageIdx = 0; pageIdx < pageLength; pageIdx++) {
			// Initialize mapper
			var row = objPages[pageIdx];
			var rowLength = row.length;
			var itemLength = 0;
			for (var rowIdx = 0; rowIdx < rowLength; rowIdx++) {
				if (row[rowIdx] instanceof Array) {
					itemLength = row[rowIdx].length;
					for (var itemIdx = 0; itemIdx < itemLength; itemIdx++) {
						if (objPages[pageIdx][rowIdx][0].checked)
                        returnList.push({
                            uid: objPages[pageIdx][rowIdx][0].uid,
							name : objPages[pageIdx][rowIdx][0].name
                        });
					}
				}
			}
		}
		return returnList;
	}
}