function StreamVideoFull(pViewInstance, pFocusMapper, pReturnFn) {
	var _this_ = this;
	
	var iView = pViewInstance;
	FullView = iView ;
	var iFocus = pFocusMapper;
	var iProgress = null;
	
	// [DMS00740113] Divied for BD 
	// BD has no Picture/Sound Setting menu
	if (Instance.Main.getManagerSetting().product != PL_TV_PRODUCT_TYPE_BD) {
		var iTools = new CTools('iTools');
		iTools.addMenu(CTools.Define.SOUND_SETTING);
		iTools.addMenu(CTools.Define.PICTURE_SETTING);
	}
	
	var objPages = null;
	
	var returnFn = pReturnFn;

	var curVideo = null;
	
	// External Interface
	this.open = function() {
		iView.show();
	}
	
	this.close = function(pType) {
		showHelpNavi(false);
		iView.hide();
        	FullView.hide();
		iProgress.close();
        	FullProgress.close();
       		if (pType) {
			iView.setStatus(GMFPlayer.STOPPED);
           		 FullView.setStatus(GMFPlayer.STOPPED);
			Instance.GMF.stop();
		}
              /* Start Interactive Device */
        	if(iRemoteFB.VideoFullFlag == 0){
        		returnFn(pType);
		}
        	else if (iRemoteFB.VideoFullFlag == 1){
       		 	if(iRemoteFB.ProfilevideoFlag == 1)
        			ProfileVideoDetail.returnDetailFn(pType);
        	 	else
        			IStreamVideoDetail.returnDetailFn(pType);
       			 iRemoteFB.VideoFullFlag = 0;
		 }
           /*End Interactive Device */
	}
	
	this.enter = function(pVideo) {
		curVideo = pVideo;
		Instance.Main.registHelpNavi(generateHelpNavi(),"StreamVideoFull");
		Instance.Main.setKeyHandler(keyHandler,"StreamVideoFull");

		// When screen size is changed, video is resumed automatically
		// So must change internal state
		Instance.GMF.setState(GMFPlayer.PLAYING);

		iView.show();
      		FullView.show();
		iView.request(pVideo);
        	FullView.request(pVideo);
        
		iProgress = new Progress(new ProgressVideoView(_$("facebookStreamVideoFullProgressDiv"),"FULL"),new ProgressVideoData());
		iProgress.init({
			rail: {
				left: 240,top: 20,	width: 331,height: 3,
				src: "Resource/images/profile_video_progress_bg.png"
			},
			bar: {
				left: 240,top: 20,	width: 1,height: 3,
				src: "Resource/images/profile_video_progress_bar.png"
			}
		});
        	FullProgress = iProgress ;
		iProgress.open();
		updateTimeInfoOSD();
		
		showHelpNavi(true);

		if (Instance.Audio.getMute()) iView.setVolumeOSD();
		
		// Full Screen Mode
		Instance.GMF.clearScreen();
		Instance.GMF.set(0,0,960,540); // In this stage, paused is released.
		Instance.GMF.addEventListner(videoEventListner);
	}

	var instanceTimer = null;
	function showHelpNavi(pDisappear) {
		iProgress.show();
		iView.showHelpNavi();
        	FullView.showHelpNavi();
		if (pDisappear) {
			if (instanceTimer) {
				clearTimeout(instanceTimer);
				instanceTimer = null;
			}
            instanceTimer = setTimeout(function(){
				hideHelpNavi();
				instanceTimer = null;
            }, 5000);
		} else {
			if (instanceTimer) {
				clearTimeout(instanceTimer);
				instanceTimer = null;
			}
		}
	}
	
	this.showHelpNavi= function(pDisappear) {
		iProgress.show();
       	iView.showHelpNavi();
        	FullView.showHelpNavi();
		if (pDisappear) {
			if (instanceTimer) {
				clearTimeout(instanceTimer);
				instanceTimer = null;
			}
            instanceTimer = setTimeout(function(){
				hideHelpNavi();
				instanceTimer = null;
            }, 5000);
		} else {
			if (instanceTimer) {
				clearTimeout(instanceTimer);
				instanceTimer = null;
			}
		}
	}
	function hideHelpNavi() {
		iProgress.hide();
		iView.hideHelpNavi();
        	FullView.hideHelpNavi();
	}
	
	function toggleHelpNavi() {
		if (instanceTimer) {
			hideHelpNavi();
			clearTimeout(instanceTimer);
			instanceTimer = null;
		}
		else {
			showHelpNavi(true);
		}
	}

	function generateHelpNavi() {
		var arrHelp = [];
		if (iFocus && iFocus.getItemLength() > 1)
			arrHelp[arrHelp.length] = {	image : HelpArea.Image.FFRW,		text : SID_PREVIOUS_NEXT	};
		arrHelp[arrHelp.length] = {	image : HelpArea.Image.Enter,		text : SID_ACTUAL	};
		// [DMS00740113] Divied for BD 
		// BD has no Picture/Sound Setting menu
		if (Instance.Main.getManagerSetting().product != PL_TV_PRODUCT_TYPE_BD) {
			arrHelp[arrHelp.length] = {	image : HelpArea.Image.Tools,			text : SID_TOOLS					};
		}
		arrHelp[arrHelp.length] = {	image : HelpArea.Image.Return,	text : SID_RETURN				};
		return arrHelp;
	}

	function videoEventListner(pType, pValue) {
		switch(pType) {
			case GMFPlayer.Event.CurrentTime :
				if (Instance.GMF.getState() == GMFPlayer.STOPPED) return;
				updateTimeInfoOSD();
				break;
			case GMFPlayer.Event.Stop :
				// [DMS00741449]
				// handling video end event.
				if (iTools) {
					iTools.close();
				}
				// delay Player operation.
				setTimeout(function(){
					_this_.close(Facebook.Define.Stop);
				}, 0);
              /* Start Interactive Device */
                 var makeMenuData = new Array();
                 makeMenuData[0] = {
                    identifier : "menuID17",
                    type : "custom",
                    title : curVideo.name,
                    name : "Write a Comment",
                    icon : "example/a.png",
                    onClick : "action?selectthis=videoComment"
                 }
                 makeMenuData[1] = {
                    identifier : "menuID18",
                    type : "custom",
                    title : FBID_SHARE,
                    name : FBID_SHARE,
                    icon : "example/a.png",
                    onClick : "action?videoShare="+ iRemoteFB.GlobalId
                 }
                 makeMenuData[2] = {
                    identifier : "menuID19",
                    type : "custom",
                    title : SID_TOOLS,
                    name : SID_TOOLS,
                    icon : "example/a.png",
                    onClick : "action?menu=tools"
                 }
				 if (checkBrowserVersion()) {
					iRemoteFB.openRemote();
				 }     
              /*End Interactive Device */
				break;
		}
	}
	
	function updateTimeInfoOSD() {
		var nVideoTotalTime = Instance.GMF.getTotalTime();
		var nVideoCurrentTime = Instance.GMF.getCurrentTime();
		
		if (nVideoTotalTime == 0) nVideoCurrentTime = 0;
		else nVideoCurrentTime = nVideoCurrentTime;
		iProgress.update(Math.ceil(100 * nVideoCurrentTime / (nVideoTotalTime - nVideoTotalTime % 1000)));
		iView.setTime(nVideoCurrentTime);
        	FullView.setTime(nVideoCurrentTime);
		iView.setTotalTime(nVideoTotalTime);
        	FullView.setTotalTime(nVideoTotalTime);
	}
	
	FullFocus = iFocus;
	function keyHandler(pKeyCode) {
		
		if (pKeyCode != TV.KEY_INFO) showHelpNavi(true);

		// BD Panel key toggle
		if (pKeyCode == TV.KEY_D_FRONT_PLAY) {
			switch(Instance.GMF.getState()) {
				case Facebook.Define.Pause :
					 pKeyCode = TV.KEY_PLAY;
					break;
				case Facebook.Define.Play :
					pKeyCode = TV.KEY_PAUSE;
					break;
				default:
					break;
			}
		}

		switch(pKeyCode) {
			case TV.KEY_RIGHT :
			case TV.KEY_PANEL_VOL_DOWN :
				break;
			case TV.KEY_LEFT :
			case TV.KEY_PANEL_VOL_UP :
				break;
			case TV.KEY_UP :
			case TV.KEY_WHEELUP :
			case TV.KEY_PANEL_CH_UP :
				break;
			case TV.KEY_DOWN :
			case TV.KEY_WHEELDOWN :
			case TV.KEY_PANEL_CH_DOWN :
				break;
			case TV.KEY_FF :
			case TV.KEY_RW :
				if(!iFocus || (iFocus && iFocus.getItemLength() == 1)) return;
				Instance.GMF.stop();
				showHelpNavi(false);
				iProgress.reset();
				iView.setStatus(GMFPlayer.STOPPED);
                		FullView.setStatus(GMFPlayer.STOPPED);

				iView.setTime(0);
                		FullView.setTime(0);
				iView.hide();
                		FullView.hide();
				iProgress.close();
				if (pKeyCode == Facebook.Define.Next) {
					returnFn(Facebook.Define.Next);
				} else {
					returnFn(Facebook.Define.Prev);
				}
				break;
			case TV.KEY_PLAY : 
				var playState = Instance.GMF.getState();
				iView.setStatus(GMFPlayer.PLAYING);
                		FullView.setStatus(GMFPlayer.PLAYING);
				switch (playState) {
					case GMFPlayer.STOPPED : 
						Instance.GMF.play(curVideo.source_url, 0,0,960,540);
						break;
					case GMFPlayer.PAUSED : 
						Instance.GMF.resume();
						break;
					default :
						break;
				}
				break;
			case TV.KEY_STOP :
				iProgress.reset();
				iView.setStatus(GMFPlayer.STOPPED);
                		FullView.setStatus(GMFPlayer.STOPPED);
				Instance.GMF.stop();
				iView.setTime(0);
		        FullView.setTime(0);
                /*Start Interactive Device */                   
                var makeMenuData = new Array();
                 makeMenuData[0] = {
                    identifier : "menuID17",
                    type : "custom",
                    title : curVideo.name,
                    name : "Write a Comment",
                    icon : "example/a.png",
                    onClick : "action?selectthis=videoComment"
                 }
                 makeMenuData[1] = {
                    identifier : "menuID18",
                    type : "custom",
                    title : FBID_SHARE,
                    name : FBID_SHARE,
                    icon : "example/a.png",
                    onClick : "action?videoShare="
                 }
                 makeMenuData[2] = {
                    identifier : "menuID19",
                    type : "custom",
                    title : SID_TOOLS,
                    name : SID_TOOLS,
                    icon : "example/a.png",
                    onClick : "action?menu=tools"
                 }
				 if (checkBrowserVersion()) {
					iRemoteFB.openRemote();
				 }
               /*End Interactive Device */
				_this_.close(Facebook.Define.Stop);
				break;
			case TV.KEY_PAUSE :
				var playState = Instance.GMF.getState();
				switch (playState) {
					case GMFPlayer.PLAYING : 
						iView.setStatus(GMFPlayer.PAUSED);
                        			FullView.setStatus(GMFPlayer.PAUSED);
						Instance.GMF.pause();
						break;
					default :
						break;
				}
				break;	
			case TV.KEY_ENTER :
			case TV.KEY_RETURN :
                  /* Start Interactive Device */                   
                    var makeMenuData = new Array();
                     makeMenuData[0] = {
                        identifier : "menuID17",
                        type : "custom",
                        title : curVideo.name,
                        name : "Write a Comment",
                        icon : "example/a.png",
                        onClick : "action?selectthis=videoComment"
                     }
                     makeMenuData[1] = {
                        identifier : "menuID18",
                        type : "custom",
                        title : FBID_SHARE,
                        name : FBID_SHARE,
                        icon : "example/a.png",
                        onClick : "action?videoShare="
                     }
                     makeMenuData[2] = {
                        identifier : "menuID19",
                        type : "custom",
                        title : SID_TOOLS,
                        name : SID_TOOLS,
                        icon : "example/a.png",
                        onClick : "action?menu=tools"
                     }
					 if (checkBrowserVersion()) {
						iRemoteFB.openRemote();
					 }
                  /*End Interactive Device */
				var playState = Instance.GMF.getState();
				switch (playState) {
					case GMFPlayer.PLAYING : 
						Instance.GMF.pause();
					case GMFPlayer.PAUSED : 
						_this_.close(false);
						break;
					case GMFPlayer.STOPPED :
						_this_.close(Facebook.Define.Stop);
						break;
					default :
						break;
				}
				break;
			case TV.KEY_RED :
				if (Instance.Frame.getType() != FacebookFrame.Define.ME) {
					_this_.close(Facebook.Define.Close);
				}
				break;
			case TV.KEY_VOL_UP: 
				if (Instance.Audio.volumeUp())
					iView.setVolumeOSD();
                    			FullView.setVolumeOSD();
				break;
			case TV.KEY_VOL_DOWN: 
				if (Instance.Audio.volumeDown())
					iView.setVolumeOSD();
                    			FullView.setVolumeOSD();
				break;
			case TV.KEY_MUTE:
				if(Instance.Audio.mute())
					iView.setVolumeOSD();
                    			FullView.setVolumeOSD();
				break;
			case TV.KEY_TOOLS : 
				// [DMS00740113] Divied for BD 
				// BD has no Picture/Sound Setting menu
				if (Instance.Main.getManagerSetting().product != PL_TV_PRODUCT_TYPE_BD) {
					iTools.open(function(){
						Instance.Main.restoreKeyHandler();
	    			});
					Instance.Main.setKeyHandler(iTools.getKeyHandler(), 'iTools');					
				}
				break;
			case TV.KEY_INFO : 
				toggleHelpNavi();
				break;
			default :
				break;
		}
	}
}