function StreamVideoList(pViewInstance, pDataInstance, pReturnFn) {
	var _this_ = this;
	
	var iView = pViewInstance;
      /* Start Interactive Device */
	iRemoteFB.ProfileVideoView  = iView ;
      /* End Interactive Device */
	var iData = pDataInstance;
	var returnFn = pReturnFn;
	
	var objPages = [];
	var dataLength = 0;
	var refIndex = [];
	
	var nRow = 2, nCol = 4;
	var iFocus = new FocusMapper("StreamVideoList",nRow, nCol);
	var iStreamVideoDetail = new StreamVideoDetail(new StreamVideoDetailView(_$("facebookStreamVideoDetailDiv")), iFocus, returnListFn);

	var bOpened = false;
	var bReady = false;

	var shortCutFlag = false;
	var shortCutObject = null;	

	this.isOpened = function(){
        return bOpened;
    }
    
	this.isReady = function(){
        return bReady;
    }
	
	// External Interface
	this.open = function(pUserID) {
//		FBTrace("StreamVideoList Open Start");
		bOpened = true;
		
		iView.show();
		iData.request(pUserID, OnLoadData);
//		FBTrace("StreamVideoList Open End");
	}
	
	this.close = function() {
//		FBTrace("StreamVideoList Close Start");
		bOpened = false;
		bReady = false;
		
		iView.clear();
		iView.hide();
//		FBTrace("StreamVideoList Close End");
	}
	
	// 
	this.enter = function(pEvent, pShortCut) {
		// Added for SNS Portal : Shortcut to the content
		if(pShortCut) {
			shortCutFlag = true;
			shortCutObject = pShortCut;
		}
		if (!bReady) {	 returnFn(); return; }
		
		Instance.Main.registHelpNavi(generateHelpNavi(),"StreamVideoList");
		Instance.Main.setKeyHandler(keyHandler,"StreamVideoList");
		
		switch(pEvent) {
			case Facebook.Define.Return :
				break;
			case Facebook.Define.ShortCut :
				iView.hide();
				
				Util.traverse(shortCutObject);
				
				iStreamVideoDetail.enter(generateDetailData(shortCutObject.data.postid));
				break;
			default : 
				iFocus.resetFocus();
				break;
				
		}
		iView.focus(iFocus.getFocus());
	}

	function generateHelpNavi() {
		var arrHelp = [];
		if (iFocus.getTotalPage() > 1) 
			arrHelp[arrHelp.length] = {	image: HelpArea.Image.FFRW, text: SID_PAGE_UP_DOWN };
		arrHelp[arrHelp.length] = {	image : HelpArea.Image.Return,	text : SID_RETURN			};
		return arrHelp;
	}

	function OnLoadData(pData) {
		if (!bOpened) return;
		if (pData) {
			bReady = true;
			generatePage(pData);
			iFocus.generate(objPages);
			requestPage(iFocus.getFocus().page);
		} else {
			bReady = false;
			iView.request(false);
		
              /* Start Interactive Device */
				iRemoteFB.noContentPopup("", SID_NO_POSTS_TO_DISPLAY);
             /* End Interactive Device */
		}
		if (shortCutFlag) {
			shortCutFlag = false;
			shortCutObject.callback();
			_this_.enter(Facebook.Define.ShortCut);
		}
	}
	
	function requestPage(pPage) {
		iFocus.setPage(pPage);
		iView.request(objPages[pPage],iFocus);
        	showProfileDetailsVideos(objPages);
              /* Start Interactive Device */
        	iRemoteFB.ProfileVideoList = objPages;
			if(iRemoteFB.menuFlag == 1){
				iMenu.enter();
				iRemoteFB.menuFlag = 0;
			}				
              /* End Interactive Device */
	}
	
	function generatePage(pData) {
		refIndex = [];

		var dataLength = pData.length;
		var itemBuffer = [];
		var lineBuffer = [];
		var nPage = 0;
		objPages[nPage] = [];
		
		for (var dataIdx = 0; dataIdx < dataLength; dataIdx++) {
			if (itemBuffer.length >= nCol) {
				flushItem();
			}
			refIndex.push(pData[dataIdx].post_id);
			itemBuffer.push(pData[dataIdx]);
		}
		flushItem();
		flushLine();
		
		nTotalPages = objPages.length;
		
		function flushItem() {
			if (lineBuffer.length >= nRow) {
				if (!(objPages[nPage] instanceof Array)) objPages[nPage]  = [];
				objPages[nPage++] = Util.copyArray(lineBuffer);
				lineBuffer = [];
			}
			lineBuffer.push(Util.copyArray(itemBuffer));
			itemBuffer = [];
		}
		
		function flushLine() {
			if (lineBuffer.length > 0) {
				if (!(objPages[nPage] instanceof Array)) objPages[nPage]  = [];
				objPages[nPage]= Util.copyArray(lineBuffer);
			}
		}
	}
	
	function returnListFn(pType) {
		FBTrace("StreamVideoList -> returnListFn");
		switch(pType) {
			case Facebook.Define.Next : 
			case Facebook.Define.Prev :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (pType == Facebook.Define.Next ? iFocus.next() : iFocus.prev()) {
					iView.blur(oldFocus);
					if (oldFocus.page != iFocus.getFocus().page) {
						iFocus.setPage(iFocus.getFocus().page);
						iView.request(objPages[iFocus.getFocus().page],iFocus);
					}
					iView.focus(iFocus.getFocus());
					iView.hide();
					iStreamVideoDetail.enter(generateDetailData());
					return true;
				}
				break;
			default:
				break;
		}
		iView.show();
		Instance.Main.setKeyHandler(keyHandler,"StreamVideoList");
	}
	
	ProfileVideoDetail = iStreamVideoDetail;
	function keyHandler(pKeyCode) {
		switch(pKeyCode) {
			case TV.KEY_RIGHT :
			case TV.KEY_PANEL_VOL_DOWN :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.right()) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_LEFT :
			case TV.KEY_PANEL_VOL_UP :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.left()) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				} else {
					iView.blur(iFocus.getFocus());
					 /* Start Interactive Device */
					if (Instance.Frame.getType() == FacebookFrame.Define.ME) {
						iRemoteFB.onLoadFacebook();
						
					}
					iRemoteFB.onLoadProfile();
					 /* End Interactive Device */
					returnFn();
				}
				break;
			case TV.KEY_UP :
			case TV.KEY_WHEELUP :
			case TV.KEY_PANEL_CH_UP :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.up()) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				} else {
					requestPage(iFocus.getFocus().page);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_DOWN :
			case TV.KEY_WHEELDOWN :
			case TV.KEY_PANEL_CH_DOWN :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.down()) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				} else {
					requestPage(iFocus.getFocus().page);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_FF :
				if (iFocus.nextPage(true)) {
					requestPage(iFocus.getFocus().page);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_RW :
				if (iFocus.prevPage(true)) {
					requestPage(iFocus.getFocus().page);
					iView.focus(iFocus.getFocus());
				}
				break;				
			case TV.KEY_ENTER :
				iView.hide();
				iStreamVideoDetail.enter(generateDetailData());
				break;
			case TV.KEY_RETURN : 
				// Return to main menu	
				iView.blur(iFocus.getFocus());
				 /* Start Interactive Device */
				if (Instance.Frame.getType() == FacebookFrame.Define.ME) {
					iRemoteFB.onLoadFacebook();
					
				}
				iRemoteFB.onLoadProfile();
				 /* End Interactive Device */
				returnFn();
				break;
			default :
				break;
		}
	}
	
	function generateDetailData(pPostID) {
		var objRef = pPostID ? findItem(pPostID) : iFocus.getFocus();
		var objVideo = objPages[objRef.page][objRef.row][objRef.col];
		objVideo.total_idx = refIndex.length;
		objVideo.current_idx = findIndex(objVideo.post_id);
		objVideo.singleMode = false;
		objVideo.pic_square = Instance.Main.getLoginUserInfo().pic_square;
		objVideo.writter = Instance.Main.getFrameUserInfo().name;
		return objVideo;
	}
	this.generateDetailData= function(pPostID) {
		alert("###@@@ " + pPostID);
		var objRef = pPostID ? findItem(pPostID) : iFocus.getFocus();
		var objVideo = objPages[objRef.page][objRef.row][objRef.col];
		objVideo.total_idx = refIndex.length;
		objVideo.current_idx = findIndex(objVideo.post_id);
		objVideo.singleMode = false;		
		objVideo.pic_square = Instance.Main.getLoginUserInfo().pic_square;
		objVideo.writter = Instance.Main.getFrameUserInfo().name;
		return objVideo;
	}

    function findItem(pPostID){
        var nPage = objPages.length;
        for (var pIdx = 0; pIdx < nPage; pIdx++) {
            var nRow = objPages[pIdx].length;
            for (var rIdx = 0; rIdx < nRow; rIdx++) {
                var nCol = objPages[pIdx][rIdx].length;
                for (var cIdx = 0; cIdx < nCol; cIdx++) {
                    if (pPostID == objPages[pIdx][rIdx][cIdx].post_id) {
                    	return { page : pIdx, row : rIdx, col : cIdx };
                    }
                }
            }
        }
        return { page: 0, row: 0, col: 0 };
    }
	
	function findIndex(pPostID) {
		var refIndexLength = refIndex.length;
		for (var refIdx = 0; refIdx < refIndexLength; refIdx++) {
			if (pPostID == refIndex[refIdx]) {
				return refIdx;
			}
		}
	}
}