function StreamVideoListData() {
	var userID = "";
    var completeFn = null;

    this.request = function(pUserID, pCompleteFn){
		userID = pUserID;
		Instance.Loading.open();
          /* Start Interactive Device */
        iRemoteFB.showLoading("Loading Data");
          /*End Interactive Device */
        completeFn = pCompleteFn;
        
        Instance.API.fql.query(function(pXMLHttpRequest){
            OnLoadData(pXMLHttpRequest);
        }, Instance.API.createAPIParams({
			query : "SELECT post_id, created_time, attachment FROM stream WHERE type=128 AND created_time > 0 AND source_id="+pUserID + " LIMIT 1000",
			format : "JSON"
		}));
        
    }
    function OnLoadData(pXMLHttpRequest){

        if (!Instance.Main.checkNetworkError(pXMLHttpRequest)) return;

		FBTrace(pXMLHttpRequest.responseText);
        var objResponse = Util.DecodeJSON(pXMLHttpRequest.responseText);

		var objResponseLength = objResponse.length;
		var objMedia = null;
		var objMediaLength = 0;
		var arrResult = [];
		
		for (var objectIdx = 0; objectIdx < objResponseLength; objectIdx++) {
			if (objResponse[objectIdx].attachment && objResponse[objectIdx].attachment.media) {
				objMedia = objResponse[objectIdx].attachment.media;
				objMediaLength = objMedia.length;
				for (var mediaIdx = 0; mediaIdx < objMediaLength; mediaIdx++) {
					if (objMedia[mediaIdx].type == "video") {
						// Video Data
						arrResult.push({
							post_id : objResponse[objectIdx].post_id,
							name : objResponse[objectIdx].attachment.name,
							length : objResponse[objectIdx].attachment.properties[mediaIdx] ? objResponse[objectIdx].attachment.properties[mediaIdx].text : "00:00",
							thumbnail : objMedia[mediaIdx].src,
							source_url :  objMedia[mediaIdx].video.source_url,
							created_time : objResponse[objectIdx].created_time,
							body : objResponse[objectIdx]
						});
					}
				}
			}
		}
		Instance.Loading.close();
          /* Start Interactive Device */
		iRemoteFB.hideLoading();
          /*End Interactive Device */
		if (arrResult.length > 0) {
			// In case there are results
			completeFn(arrResult);
		} else {
			// In case there is no result
			completeFn(false);
		}
    }
}