/*
 Title: SNSList.js
 		Facebook Mini widget
 */
alert('SceneSNSList(Facebook).js loaded');

/*
 Class: SceneSNSList
 		Control Facebook Mini widget
 */
function SceneSNSList() {
	var $this = this;
	
	this.arrFeedList = [];
	
	var prevQueryURL = "";
	var nextQueryURL = "";
	
	this.DEF = {};
	this.DEF.INIT = 10;
	this.DEF.NEW = 11;
	this.DEF.MORE = 12;
	this.DEF.USER_REFRESH = 13;
	this.DEF.AUTO_REFRESH =14;

	this.isFocused = false;
	this.isLogin = false;
	
	var autoRefreshInstance = null;
	var autoRefreshTime = 5*60*1000;
	
	var instanceMPopup = null;
	var updateFlag = false;
	var updateIdx = 0;

	var sYourVideoID = "11111000000";

	// Event Listener
	this.eventListener = function(pEvent) {
		switch (pEvent) {
			default:
				break;
		}
	}
	
	// Request from "NIDHISH AGRAWAL"
	//Interactive Remote Start
	/**
         *@brief SmartPhone action
	 *@remarks function for viewing comment list function from Smart device
	 *@param void
	 *@return void
	 */
	this.viewCommentsList = function() {
		viewCommentsList();
	}
	/**
         *@brief SmartPhone action
	 *@remarks function for viewing liking function from Smart device
	 *@param void
	 *@return void
	 */
	this.setLike = function() {
		setLike();
	}
	/**
         *@brief SmartPhone action
	 *@remarks function for viewing unliking function from Smart device
	 *@param void
	 *@return void
	 */
	this.setUnlike = function(){
		setUnlike();
	}
	/**
         *@brief SmartPhone action
	 *@remarks function for starting the Facebook widget from smart device
	 *@param void
	 *@return void
	 */
	this.getRunWidgetParam = function(pFeed) {
		return getRunWidgetParam(pFeed);
	}
	/**
         *@brief SmartPhone action
	 *@remarks function for getting current index from smart device
	 *@param void
	 *@return void
	 */
	this.gettingOldIndex=function()
	{
	 return this.mFacebookList.getCurrentIndex();
	}
	/**
         *@brief SmartPhone action
	 *@remarks function for updating refresh flag from smart device
	 *@param void
	 *@return void
	 */
	this.updateRefreshFlag=function()
	{
		this.mFacebookList.setUpdateRefreshFlag();
	}
	/**
         *@brief SmartPhone action
	 *@remarks function for opening ime for  Facebook widget from smart device
	 *@param void
	 *@return void
	 */
	this.openFirstIME=function()
	{
	IMEOpen({title:"What's on your mind ?",caller :{id:"SNSList",scope :FACEBOOK_ID},nMaxLength:250});
	}
        //Interactive Remote End
    /*
     	Function: update
     			Update Feed with given input text

     	Parameters:
     			 pText - Text which user input
     */
	this.update = function(pText) {
		alert("MFacebook Update " + pText);
		// If input is consisted with blank, ignore it
		if (!pText || !pText.match(/[^\s]/)) {
			$.sfScene.focus({ id : "SNSList", scope : FACEBOOK_ID });
			return;
		}
		$this.innerLoading.open();
        this.FacebookAPI.updateFeed(function(pResult, pSuccess){
			$this.innerLoading.close();
			if (pSuccess) {
				$.sfScene.focus({ id : "SNSList", scope : FACEBOOK_ID });
				$this.refresh($this.DEF.NEW);
			} else {
				Misc.networkErrPopup(function(pEvent){
					$.sfScene.focus({ id : "SNSList", scope : FACEBOOK_ID });
					if (pEvent == EVENT_SOCIAL_KEY) $this.returnToCategory();
				});
			}
		}, {
            'message': pText
        });
	}

    /*
     	Function: enter
     			Open IME Popup or submenu depends on current focus		
     */
	this.enter = function() {
		if ($this.mFacebookList.getCurRealIdx() == -1) {
             //Interactive Remote Start
			$this.mFacebookList.openWhatsIme();
    		//Interactive Remote End
			IMEOpen({ title : SID_WHATS_ON_YOUR_MIND, caller : { id : "SNSList", scope : FACEBOOK_ID }, nMaxLength : 200, returnFn: function(pEvent){
				$.sfScene.focus({ id : "SNSList", scope : FACEBOOK_ID });
				if (pEvent == EVENT_SOCIAL_KEY) {
					$this.returnToCategory();
				}
			},
			focusCtrl : true, callback : function(pInputTxt) {
				$this.update(pInputTxt);
			}
			});
		} else {
			$this.innerLoading.open();
			//Interactive Remote Start
			$this.mFacebookList.showLoading();
			//Interactive Remote End
			// Check whether user likes this stream already
			$this.FacebookAPI.isLike(function(pXMLHttpRequest, pSuccess){
				//Interactive Remote Start
				$this.innerLoading.close();
				//Interactive Remote Start
				$this.mFacebookList.hideLoading();
				if (pSuccess) {
					var likesFlag = false;
					var result = JSON.parse(pXMLHttpRequest.responseText);
					for (var idx = 0; idx < result.data.length; idx++) {
						if (result.data[idx].id == strSessionID) {
							likesFlag = true;
							break;
						}
					}
					$this.mFacebookList.select();
					instanceMPopup = $.sfScene.get("MPopup");
					instanceMPopup.set(getPopupSetting({
						likes: likesFlag
					}));
					$.sfScene.show("MPopup");
					$.sfScene.focus("MPopup");
				} else {
					Misc.networkErrPopup(function(pEvent){
						$.sfScene.focus({ id : "SNSList", scope : FACEBOOK_ID });
						if (pEvent == EVENT_SOCIAL_KEY) $this.returnToCategory();
					});
				}
			}, $this.arrFeedList[$this.mFacebookList.getCurRealIdx()].id);
		}
	}

	this.isReady = function() {
		return $this.mFacebookList.getListLength() > -1 ? true : false; 
	}
	//Interactive Remote Start
	/**
         *@brief SmartPhone action
	 *@remarks function for moving item index from smart device
	 *@param void
	 *@return void
	 */
	this.moveToItemIndex=function(prevIndex,newIndex)
	{
		this.mFacebookList.moveToItemIndex(prevIndex,newIndex);
		this.adaptNavi();
	}
	//Interactive Remote End
    /*
     	Function: focusReset
     			Display first page and focus to first item
     */
	this.focusFirstItem = function() {
		$this.mFacebookList.focusFirstItem();
	}

    /*
     	Function: blurFocus
     			Blur current focused item
     */
	this.blurFocus = function() {
		$this.mFacebookList.blur($this.mFacebookList.getCurRealIdx()+1);
	}

    /*
     	Function: tools
     			Open Service Setting Menu when tools key is pressed
     */
    this.tools = function() {
		var instanceServiceSetting = $.sfScene.get("ServiceSetting");
		instanceServiceSetting.reset();
		instanceServiceSetting.set(function(pEvent){
			if (pEvent == EVENT_SOCIAL_KEY) {
				$this.returnToCategory();
			} else {
				$.sfScene.get("Home").focusCurService();
			}
		});
		$.sfScene.show("ServiceSetting");
        $.sfScene.focus("ServiceSetting");
	}

    /*
     	Function: refresh
     			Refresh current feed list

     	Parameters:
     			pType - Refresh type
     */
    this.refresh = function(pType) {
		alert("[SNSList(Facebook)] Refresh");
		if (pType == $this.DEF.MORE && !nextQueryURL) return;
		if (pType !=  $this.DEF.AUTO_REFRESH) {
			$this.innerLoading.open();
			//Interactive Remote Start
			$this.mFacebookList.showLoading();
			//Interactive Remote End
		}
		switch(pType) {
			case $this.DEF.INIT :
			case  $this.DEF.USER_REFRESH :
				prevQueryURL = null;
				nextQueryURL = null;				
				$this.FacebookAPI.request("/me/home", $this.FacebookAPI.createAPIParams({}), getCallbackFn(pType));
				break;
			case $this.DEF.NEW :
			case  $this.DEF.AUTO_REFRESH :
				if (prevQueryURL) {
					$this.mFacebookList.autoRefresh();
					$this.FacebookAPI.requestByURL(prevQueryURL, getCallbackFn(pType));	
				}
				else {
					// In this case, user already done "Init" or "User refresh". 
					// But got nothing from Facebook server, so request new posts 
					$this.FacebookAPI.request("/me/home", $this.FacebookAPI.createAPIParams({}), getCallbackFn(pType));
				}
				break;
			case $this.DEF.MORE :
			    $this.mFacebookList.setMoreFlag(FACEBOOK_ID);
				$this.FacebookAPI.requestByURL(nextQueryURL, getCallbackFn(pType));
				break;
			default:
				alert("[Error] MFacebook.refresh >> Refresh type must be defined.");
				break;
		}
		
		if (autoRefreshInstance) {
			clearTimeout(autoRefreshInstance);
		}
        autoRefreshInstance = setTimeout(function(){
            $this.refresh($this.DEF.AUTO_REFRESH);
        }, autoRefreshTime);
		
		function getCallbackFn(pType) {
			return function(pXMLHttpRequest, pSuccess){
				$this.innerLoading.close();
				//Interactive Remote Start
				$this.mFacebookList.hideLoading();
				//Interactive Remote End
//				alert(pXMLHttpRequest.responseText);
				if (pSuccess) {
					$this.ListParsor(JSON.parse(pXMLHttpRequest.responseText), pType);
				} else {
					// Control request is failed
					switch(pType) {
						case $this.DEF.USER_REFRESH :
						case $this.DEF.NEW :
						case $this.DEF.MORE :
	                        Misc.networkErrPopup(function(pEvent){
	                            ctrlFocus();
								if (pEvent == EVENT_SOCIAL_KEY) $this.returnToCategory();
	                        });
							break;
						case $this.DEF.INIT :
							Misc.networkErrPopup(function(){ widgetAPI.sendExitEvent(); });
							break;
						default:
							break;
					}
				}
				$this.adaptNavi();
			}
		}
    }

    /*
     	Function: writeComment
     			Write comment of given feed ID

     	Parameters:
     			 pPostID	-	Feed post ID
     */
	this.writeComment = function(pPostID) {
		var nFeedIdx = $this.mFacebookList.getCurRealIdx();
		//Interactive Remote Start
		$this.mFacebookList.writeInteractiveComments();	
		//Interactive Remote End
		IMEOpen({ title : SID_COMMNET_M_ADD_COMMENT, callerID : "MPopup", contents : "", callback : function(pText) {
			// If input is consisted with blank, ignore it
			if (!pText || !pText.match(/[^\s]/)) {
				$.sfScene.hide("MPopup");
				$.sfScene.show({ id : "SNSList", scope : FACEBOOK_ID });
				$.sfScene.focus({ id : "SNSList", scope : FACEBOOK_ID });
				return;
			}
			alert("MFacebook Update " + pText);
			$this.innerLoading.open();
			//Interactive Remote Start
			$this.mFacebookList.showLoading();
			//Interactive Remote End
	        $this.FacebookAPI.writeComment(function(pResult, pSuccess){
				$this.innerLoading.close();
				$this.mFacebookList.hideLoading();
				if (pSuccess) {
					//$this.updateRefreshFlag();
					$.sfScene.focus({ id : "SNSList", scope : FACEBOOK_ID });
					$this.FacebookAPI.getFeed(function(pResult, pSuccess){
						updateFeed(nFeedIdx, JSON.parse(pResult.responseText));
		            }, pPostID);
				} else {
                    Misc.networkErrPopup(function(pEvent){
						$.sfScene.focus({ id : "SNSList", scope : FACEBOOK_ID });	
						if (pEvent == EVENT_SOCIAL_KEY) $this.returnToCategory();		
                    });
				}
			}, pPostID, {
	            'message': pText
	        });
		}, returnFn : function(pEvent){
			if (pEvent == EVENT_SOCIAL_KEY) {
				$this.returnToCategory();
				return;
			}
			$.sfScene.focus({ id : "SNSList", scope : FACEBOOK_ID });
		} });
	}

    /*
     	Function: viewCommentsList
				View comments list of current focus
     */
	function viewCommentsList() {
		$.sfScene.get("CommentsList").open(adapterForMini($this.arrFeedList[$this.mFacebookList.getCurRealIdx()]),function(pUpdate, pEvent){
			if (pUpdate) {
				updateFlag = true;
				updateIdx = $this.mFacebookList.getCurRealIdx();
			}
			$.sfScene.hide("MPopup");
			$.sfScene.show({ id : "SNSList", scope : FACEBOOK_ID });
			$.sfScene.focus({ id : "SNSList", scope : FACEBOOK_ID });			
			if (pEvent == EVENT_SOCIAL_KEY) {
				$this.returnToCategory();
			}
		});
	}
	
	
	/**
     *@brief SmartPhone action
	 *@remarks function for writing comment on  Facebook widget from smart device
	 *@param void
	 *@return void
	 */
this.writefromIRemote=function(pText,pPostID){
	var nFeedIdx = $this.mFacebookList.getCurRealIdx();
		if (!pText) {
				$.sfScene.hide("MPopup");
				$.sfScene.show({ id : "SNSList", scope : FACEBOOK_ID });
				$.sfScene.focus({ id : "SNSList", scope : FACEBOOK_ID });
				return;
			}
			$this.innerLoading.open();
			//Interactive Remote Start
			$this.mFacebookList.showLoading();
			//Interactive Remote End
	        $this.FacebookAPI.writeComment(function(pResult,pSuccess){
				$this.innerLoading.close();
				//Interactive Remote Start
				$this.mFacebookList.hideLoading();
				//Interactive Remote End
				if (pSuccess) {
					$.sfScene.focus({ id : "SNSList", scope : FACEBOOK_ID });
					$this.FacebookAPI.getFeed(function(pResult, pSuccess){
						updateFeed(nFeedIdx, JSON.parse(pResult.responseText));
		            }, pPostID);
				//setTimeout(100,function(){});
				} else {
                    Misc.networkErrPopup(function(pEvent){
						$.sfScene.focus({ id : "SNSList", scope : FACEBOOK_ID });	
						if (pEvent == EVENT_SOCIAL_KEY) $this.returnToCategory();		
                    });
				}
			}, pPostID, {
	            'message': pText
	        });
	
}
    /*
     	Function: setLike
     			Set "like" to feed of current focus 
     */
	function setLike() {
		$this.innerLoading.open();
		//Interactive Remote Start
		$this.mFacebookList.showLoading();
		//Interactive Remote End
		if (instanceMPopup && instanceMPopup.lock) instanceMPopup.lock();
        $this.FacebookAPI.setLike(function(pResult, pSuccess){
			$this.innerLoading.close();
			//Interactive Remote Start
			$this.mFacebookList.hideLoading();
			//Interactive Remote End
			if (instanceMPopup && instanceMPopup.unlock) instanceMPopup.unlock();
			if (pSuccess) {
				// Change menu title "Like" -> "Unlike"
				instanceMPopup.changeItem("Like",{	"title": FBID_UNLIKE, "action": function(){ setUnlike();	}});

				updateFlag = true;
				updateIdx = $this.mFacebookList.getCurRealIdx();
				//Interactive Remote Start
				$this.mFacebookList.setFacebookPopupoff();
				//Interactive Remote End
				// Close MPopup
				$.sfScene.hide("MPopup");
				$.sfScene.focus({ id : "SNSList", scope : FACEBOOK_ID });
			} else {
				Misc.networkErrPopup(function(pEvent){
					if (pEvent == EVENT_SOCIAL_KEY) {
						$.sfScene.hide("MPopup");
						$.sfScene.focus({ id : "SNSList", scope : FACEBOOK_ID });
						$this.returnToCategory();
						return;
					}
					$.sfScene.focus("MPopup");
				});
			}
		}, $this.arrFeedList[$this.mFacebookList.getCurRealIdx()].id);
	}

    /*
     	Function: setUnlike
     			Unset "like" to feed of current focus 
     */
	function setUnlike() {
		$this.innerLoading.open();
		//Interactive Remote Start
		$this.mFacebookList.showLoading();
		//Interactive Remote End
		if (instanceMPopup && instanceMPopup.lock) instanceMPopup.lock();
        $this.FacebookAPI.setUnlike(function(pResult, pSuccess){
			$this.innerLoading.close();
			$this.mFacebookList.hideLoading();
			if (instanceMPopup && instanceMPopup.unlock) instanceMPopup.unlock();
				if (pSuccess) {
				// Change menu title "Unlike" -> "Like"
				instanceMPopup.changeItem("Unlike", {	"title": FBID_LIKE, "action": function(){ setLike();	}});
				
				updateFlag = true;
				updateIdx = $this.mFacebookList.getCurRealIdx();
				//Interactive Remote Start
				$this.mFacebookList.setFacebookPopupoff();
				//Interactive Remote End
				// Close MPopup
				$.sfScene.hide("MPopup");
				$.sfScene.focus({ id : "SNSList", scope : FACEBOOK_ID });
			} else {
				Misc.networkErrPopup(function(pEvent){
					if (pEvent == EVENT_SOCIAL_KEY) {
						$.sfScene.hide("MPopup");
						$.sfScene.focus({ id : "SNSList", scope : FACEBOOK_ID });
						$this.returnToCategory();
						return;
					}
					$.sfScene.focus("MPopup");
				});
			}
        }, $this.arrFeedList[$this.mFacebookList.getCurRealIdx()].id);			
	}

    /*
     	Function: updateFeed
     			Request new status of feed and update

     	Parameters:
     			pIdx - Current index
     			pFeed - New status
     */
	function updateFeed(pIdx, pFeed) {
		$this.arrFeedList[pIdx] = pFeed;
		$this.mFacebookList.update(pIdx, adapterForMini(pFeed));
		$this.drawAdditionalInfo(adapterForMini(pFeed));
		
		// If focus is placed at last item in page, adjust scroll position
		if ($this.mFacebookList.adjustScroll) $this.mFacebookList.adjustScroll();
	}

    /*
     	Function: getPopupSetting
     			Get popup setting

     	Parameters:
     			 pOption - Popup option
     */
	function getPopupSetting(pOption) {
		var curFeed = $this.arrFeedList[$this.mFacebookList.getCurRealIdx()];
		var nTop = 0;
		var items = getSubMenu(pOption);
		$this.mFacebookList.adjustSubmenuPos(items.length);
		return {
			"id" : FACEBOOK_ID,
			"caller" : { id : "SNSList", scope : FACEBOOK_ID },
			"items" :items,
			"returnFn" : function(pEvent){
				returnFn(pEvent);
			}
		}

    /*
     	Function: returnFn
     			Control return from submenu

     	Parameters:
     			 pEvent - Event enum
     	Returns:
     			 N/A
     */
	function returnFn(pEvent) {
		switch(pEvent) {
			case EVENT_SOCIAL_KEY :
				$this.returnToCategory();
				break;
			default :
				break;
		}
	}
	
    /*
     	Function: getSubMenu
     			Get submenu

     	Parameters:
     			 pOption - Option
     	Returns:
     			 Submenu items
     */
		function getSubMenu(pOption) {
			var items = [];
			// Add Comment Menu
			if (curFeed.comments)
				items[items.length] = {	"title": SID_COMMENTS, "action": function(){ viewCommentsList(); }	};
			// Add Like Menu
			if (pOption.likes) {
				items[items.length] = {	"title": FBID_UNLIKE, "action": function(){ setUnlike();	}};
			} else {
				items[items.length] = {	"title": FBID_LIKE, "action": function(){ setLike();	}};
			}
			switch(getFeedType(curFeed)) {
				case "photo" :
				case "album" :
					items[items.length] = {"title": TV_SID_VIEW_ALBUM,"action": function() {
						//Interactive Remote Start
						$this.mFacebookList.openAlbumFacebookPopup();
						//Interactive Remote End
						$("#HomePopup").sfPopup({
					        text: TV_SID_MIX_DO_YOU_WANT_TO_MOVE_TO_APPLICATION.Replace(Util.getWidgetName(FACEBOOK_ID)), 
					        num : 2,
							focus : "left",
					        callback : function(pRtn) {
								$("#Default_DIM").hide();
								if ( pRtn == true ) {
										$this.mFacebookList.closeOKFacebookPop();
									runWidget(FACEBOOK_ID, getRunWidgetParam(curFeed));
								}
								else {
									$this.mFacebookList.closeFacebookPop();
									$("#HomePopup").sfPopup("hide");
								}
							}
						});
						$("#Default_DIM").show();
						$("#HomePopup").sfPopup("show");
					}} 
					break;
				case "movie" :
				case "video" :
					items[items.length] = {"title": TV_SID_PLAY_VIDEO ,"action": function() {
						//Interactive Remote Start
						$this.mFacebookList.openVideoFacebookPop();
						//Interactive Remote End
						$("#HomePopup").sfPopup({
					        text: TV_SID_MIX_DO_YOU_WANT_TO_MOVE_TO_APPLICATION.Replace(Util.getWidgetName(FACEBOOK_ID)), 
					        num : 2,
							focus : "left",
					        callback : function(pRtn) {
								$("#Default_DIM").hide();
								if ( pRtn == true ) {
									$this.mFacebookList.closeOKFacebookPop();
									runWidget(FACEBOOK_ID, getRunWidgetParam(curFeed));
								}
								else {
									$this.mFacebookList.closeFacebookPop();
									$("#HomePopup").sfPopup("hide");
								}
							}
						});
						$("#Default_DIM").show();
						$("#HomePopup").sfPopup("show");
					}} 
					break;
			}
			
			// Add Go Your Video Menu
			if (curFeed.message && typeof curFeed.message == "string") {
				var aYourVideo = curFeed.message.match(/#YourVideo\s[(\s|\w|\W)]*\(([\d]+)_(\w\w)\)/);
				if (aYourVideo && aYourVideo.length == 3) {
					var nGlobalSetting = isYourVideoGlobal();
					if (nGlobalSetting == isYourVideoGlobal.TRUE || nGlobalSetting == isYourVideoGlobal.FALSE) {
						var sBaseCountry = (nGlobalSetting == isYourVideoGlobal.TRUE) ? "US" :  InitParam.country;
						if (aYourVideo[2]== sBaseCountry) {
								items[items.length] = {	"title": TV_SID_MIX_MOVE_TO.Replace("Your Video"),"action": function() {
								$("#HomePopup").sfPopup({
							        text: TV_SID_MIX_DO_YOU_WANT_TO_MOVE_TO_APPLICATION.Replace("Your Video"), 
							        num : 2,
									focus : "right",
							        callback : function(pRtn) {
										$("#Default_DIM").hide();
										if ( pRtn == true ) {
											runWidget(sYourVideoID, {data :JSON.stringify({ TTID: aYourVideo[1] }) });
										}
										else {
											$("#HomePopup").sfPopup("hide");
										}
									}
								});
								$("#Default_DIM").show();
								$("#HomePopup").sfPopup("show");
								}	
							}	
							}
					}
				}
			}
			
			// Add Go Facebook Menu
			items[items.length] = {	"title": TV_SID_MIX_MOVE_TO.Replace("Facebook"),"action": function() {
							//Interactive Remote Start
							$this.mFacebookList.openFacebookPopup();
							//Interactive Remote End
						$("#HomePopup").sfPopup({
					        text: TV_SID_MIX_DO_YOU_WANT_TO_MOVE_TO_APPLICATION.Replace(Util.getWidgetName(FACEBOOK_ID)), 
					        num : 2,
							focus : "left",
					        callback : function(pRtn) {
								$("#Default_DIM").hide();
								if ( pRtn == true ) {
									//Interactive Remote Start
									$this.mFacebookList.closeOKFacebookPop();
									//Interactive Remote End
									runWidget(FACEBOOK_ID, getRunWidgetParam());
								}
								else {
									//Interactive Remote Start
									$this.mFacebookList.closeFacebookPop();
									//Interactive Remote End
									$("#HomePopup").sfPopup("hide");
								}
							}
						});
						$("#Default_DIM").show();
						$("#HomePopup").sfPopup("show");
					}	}
			return items;
		}
	}
    
    /*
     Function: ctrlFocus
     	Focus the scene which is correct up to situation
     
     Parameters:
     	N/A
     Returns:
     	N/A
     */
	function ctrlFocus() {
		if ($this.mFacebookList.getState() == CVLList.FOCUS) {
			$.sfScene.focus({ id : "SNSList", scope : FACEBOOK_ID });
		} else {
			$.sfScene.focus("Home");
		}
	}

    /*
     	Function: getRunWidgetParam
     			Get run widget parameter

     	Parameters:
     			 pFeed - Feed object
     	Returns:
     			 Parameters to run widget
     */


	function getRunWidgetParam(pFeed) {
		var feedid = "";
		var objAccount = TVComm.getAccount(FACEBOOK_ID);
		switch(getFeedType(pFeed)) {
			case "album" :
				 feedid = Util.getValueFromURI("id") + "_" + Util.getValueFromURI("aid"); 
				break;
			case "photo" :
				feedid = Util.getValueFromURI("id") + "_" + Util.getValueFromURI("pid");
				break;
			case "movie" :
			case "video" :
				feedid = pFeed.id;
				break;
		}
		
		return {
			type : getFeedType(pFeed)
			, userid : $this.arrFeedList[$this.mFacebookList.getCurRealIdx()].from.id
			, feedid : feedid
			, id : objAccount.id
			, pw : objAccount.pw
		};
	}

    /*
     	Function: getFeedType
     			Get feed type

     	Parameters:
     			 pFeed - Feed object
     	Returns:
     			 Type of feed
     */
	function getFeedType(pFeed) {
		if (pFeed) {
			if (pFeed.type == "link") {
				if (pFeed.link.match(/album.php/)) {
					return "album";
				} else if (pFeed.link.match(/video.php/)) {
					return "movie";
				} else {
					return false;
				}
			} else {
				return pFeed.type;
			}	
		} else {
			return false;
		}
	}

    /*
     	Function: ListParsor
     			Parse data, notify events and draw list 

     	Parameters:
     			 pJSON - Feed list
     			 pEvent - Request type
     */
	this.ListParsor = function(pJSON, pEvent) {
		$this.innerLoading.close();
		//Interactive Remote Start
		$this.mFacebookList.hideLoading();
		//Interactive Remote End
		var arrCurFeedList = null;

		switch(pEvent) {
			case $this.DEF.AUTO_REFRESH :
				if (pJSON.paging) {
					prevQueryURL = pJSON.paging.previous;
				}
				if (pJSON.data.length > 0) {
					TVComm.eventListener(FACEBOOK_ID, TVCHAT_EVENT_NEW, pJSON.data.length);
				} 
				return;
				break;
			case $this.DEF.MORE :
				if (pJSON.paging) {
					nextQueryURL = pJSON.paging.next;
				}
				Util.insertArray($this.arrFeedList, pJSON.data, $this.arrFeedList.length);
				arrCurFeedList = pJSON.data;
				break;
			case $this.DEF.NEW :
				if (pJSON.paging) {
					prevQueryURL = pJSON.paging.previous;
				}
				$this.mFacebookList.reset();
				Util.insertArray($this.arrFeedList, pJSON.data, 0);
				arrCurFeedList = $this.arrFeedList;
				break;
			default:
				if (pEvent == $this.DEF.USER_REFRESH) {
					TVComm.eventListener(FACEBOOK_ID, TVCHAT_EVENT_NEW, -1);
				}
				if (pJSON.paging) {
					prevQueryURL = pJSON.paging.previous;
					nextQueryURL = pJSON.paging.next;
				}
				$this.mFacebookList.reset();
				$this.arrFeedList = pJSON.data;
				arrCurFeedList = $this.arrFeedList;
				break;
		}
		var nLength = arrCurFeedList.length;
		var  arrMiniFeed = [];
		for (var idx = 0; idx < nLength; idx++) {
			arrMiniFeed.push(adapterForMini(arrCurFeedList[idx]));
		}
		$this.mFacebookList.addItems(arrMiniFeed);
		$this.mFacebookList.addRemoteServiceItem(arrMiniFeed,FACEBOOK_ID);
		$this.mFacebookList.displayPage(pEvent == $this.DEF.MORE ? false : 0);
		if (pEvent != $this.DEF.MORE) {
			if ($this.isFocused) {
				if (arrMiniFeed.length > 0) {
					$this.mFacebookList.focus(1);
				} else {
					$this.mFacebookList.focus(0);
				}
			}
		} else {
			if ($this.isFocused) 
				$this.mFacebookList.focus($this.mFacebookList.getCurRealIdx() + 1);
		}
		return pJSON.data.length > 0 ? true : false;
	}

    /*
     	Function: adapterForMini
     			Convert raw data to customized format

     	Parameters:
     			 pJSON - Raw feed object
     	Returns:
     			 Cutomized data
     */
	function adapterForMini(pJSON) {
		var jsonItem = {};
		jsonItem.id = pJSON.id;
		
		// Request from NIDHISH AGRAWAL
		jsonItem.type = pJSON.type;
		
		jsonItem.profile_pic = "https://graph.facebook.com/"+pJSON.from.id+"/picture";
		jsonItem.name = pJSON.from.name;
		switch(pJSON.type) {
			case "link" :
				jsonItem.text = pJSON.name || pJSON.message || "";
				break; 
			default :
				jsonItem.text = pJSON.message || pJSON.caption || pJSON.name || "";
			 	break;
		}
		jsonItem.photo = pJSON.picture
		jsonItem.comments = pJSON.comments ? pJSON.comments.count : null; 
		jsonItem.likes = pJSON.likes ? pJSON.likes.count : null; 
		jsonItem.updated_time = pJSON.created_time;
		
		return jsonItem;
	}

    /*
     	Function: adaptNavi
     			Change help navigation with given situation
     */
    this.adaptNavi = function(){
		if ($.sfScene.get("Home").getCurServiceID() != FACEBOOK_ID) return;
		
        if (TVComm.getAccount(FACEBOOK_ID).id) {
			if ($this.mFacebookList.getCurRealIdx() == -1) {
				$("#HomeHelp").sfKeyHelp({
					'user': TVComm.getAccount(FACEBOOK_ID).id,
					'red' : TVComm.getSSOID() ? SID_LOGOUT : SID_LOGIN,
					'green': SID_REFRESH  ,
					'blue': TV_SID_CHANGE_VIEW,
					'tools': SID_SETTINGS,
					'return': SID_EXIT
				});
			}
			else {
				$("#HomeHelp").sfKeyHelp({
					'user': TVComm.getAccount(FACEBOOK_ID).id,
					'red' : TVComm.getSSOID() ? SID_LOGOUT : SID_LOGIN,
					'green': SID_REFRESH ,
					'yellow': SID_COMMNET_M_ADD_COMMENT,
					'blue': TV_SID_CHANGE_VIEW,
					'tools': SID_SETTINGS,
					'return': SID_EXIT
				});
			}
		} else {
            $("#HomeHelp").sfKeyHelp({
				'red' : TVComm.getSSOID() ? SID_LOGOUT : SID_LOGIN,
                'blue': TV_SID_CHANGE_VIEW,
                'tools': SID_SETTINGS,
                'return': SID_EXIT
            });
		}
    }
	/**
     *@brief SmartPhone action
	 *@remarks function for viewing liking function from Smart device
	 *@param void
	 *@return void
	 */
	this.showServiceInfo=function()
	{
		$this.mFacebookList.sendServiceInfo();
	}
    /*
     	Function: onFocus
     			Update current focused feed
     */
	this.onFocus = function() {
		if (updateFlag) {
			$this.FacebookAPI.getFeed(function(pResult){
				updateFeed(updateIdx, JSON.parse(pResult.responseText));
				//Interactive Remote Start
				var faceIndexData=JSON.parse(pResult.responseText);
				$this.mFacebookList.setLikeUpdate(updateIdx,faceIndexData);
				//Interactive Remote End
				updateFlag = false;
				updateIdx = 0;
            }, $this.arrFeedList[updateIdx].id);
		}
	}

    /*
     	Function: drawAdditionalInfo
     			Draw additional infomation to feed list

     	Parameters:
     			 pContents - Feed object 
     */
	this.drawAdditionalInfo = function(pContents) {
		var strHTML = "";
		if (pContents.likes || pContents.comments) {
			$("." + pContents.id + "_Additional").show();
			if (pContents.likes) {
				strHTML += "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<img src = 'images/tvchat_list_icon05.png'>";
				strHTML += "&nbsp;<span class = 'MFacebookWShadow' id = '"+pContents.id+"_nLikes' style = 'color:#002b43;'>" + (pContents.likes ? pContents.likes : "") + "</span>";
			}
			if (pContents.comments) {
				strHTML += "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<img src = 'images/tvchat_list_icon04.png'>";
				strHTML += "&nbsp;<span class = 'MFacebookWShadow' id = '"+pContents.id+"_nComments' style = 'color:#002b43;'>" + (pContents.comments ? pContents.comments : "") + "</span>";
			}
		} else {
			$("." + pContents.id + "_Additional").hide();
		}
		$("." + pContents.id + "_Additional").html(strHTML);
	}

    /*
     	Function: login
     			Login to start service
     */
	this.login = function() {
		var objAccount = TVComm.getAccount(FACEBOOK_ID);
		if (objAccount.id && objAccount.pw) {
			$this.isLogin = true;
			
			// Focus to category for login
			$.sfScene.get("Home").focusToCategory();
			
			this.FacebookAPI.auth.login(function(pXMLHttpRequest){
		        loginCallback(pXMLHttpRequest);
		    },  $this.FacebookAPI.createAPIParams({
				email : objAccount.id,
				password : objAccount.pw,
				format : "JSON"
			}));	
		} else {
			// Facebook account is not registered yet
			this.innerLoading.close();
		}
		
		/*
			Function: loginCallback
					Login callback
		
			Parameters:
					 pXMLHttpRequest - Response of login request
		*/
		function loginCallback(pXMLHttpRequest) {
			var objResponse = JSON.parse(pXMLHttpRequest.responseText);
			accessToken = objResponse["access_token"];
			if (objResponse["session_key"] && objResponse["uid"] && objResponse["secret"]) {
				$this.FacebookAPI.setSessionValue(objResponse["session_key"],objResponse["secret"],objResponse["uid"],objResponse["access_token"]);
				alert(objResponse["session_key"]+" : "+objResponse["secret"]+" : "+objResponse["uid"]+" : "+objResponse["access_token"]);
				strSessionID = objResponse["uid"];
			}
			$this.refresh($this.DEF.INIT);
		}		
	}
	
	/*
     	Function: logout
     			Logout to end service
     */
	$this.logout = function() {
		$this.isLogin = false;
		$this.mFacebookList.clear();
		if ($this.isFocused) {
			$.sfScene.focus("Home");
		}
	}

	/*
     	Function: returnToCategory
     			Focus to category
     */
	this.returnToCategory = function() {
		$.sfKey.block();
		// Focus to category for service change
		$.sfScene.focus("Home");
		$this.blurFocus();
		$this.focusFirstItem();
		$this.blurFocus();
		$this.isFocused = false;
		$this.adaptNavi();		
	}

	/*
     	Function: isYourVideoGlobal
     			Check global option is true in your video
     			
     	Returns:
     			true | false
     */
	function isYourVideoGlobal() {
		var yourVideoData = readCommonFile(sYourVideoID, '_sfdata.json');
		if (yourVideoData) {	// YourVideo ?일???음.
			try {	// file??깨졌??경우??처리
				yourVideoData = (yourVideoData == '') ? null : $.parseJSON(yourVideoData);
			} catch(e)  {
				return isYourVideoGlobal.ERROR;
				alert ;
			}
			useGlobal = yourVideoData['setting_useGlobal'];
			alert("[Facebook SNSList.js] isYourVideoGlobal returns " + useGlobal, 0);
			if (useGlobal) {
				return isYourVideoGlobal.TRUE;
			} else {
				return isYourVideoGlobal.FALSE;
			}
		}
		return isYourVideoGlobal.NONE;
	}
	
	isYourVideoGlobal.TRUE = 100;
	isYourVideoGlobal.FALSE = 101;
	isYourVideoGlobal.NONE = 998;
	isYourVideoGlobal.ERROR = 999;

	/*
     	Function: readCommonFile
     			Utility to read common file.
     			This module will be replaced with Util.readCommonFile().

     	Parameters:
     			 String -	 Filepath
     			 String - Filename
     	Returns:
     			String - File contents
     */
	function readCommonFile(dir, file) {
	    alert('[SocialTV] readCommonFile(' + dir + ',' + file + ')');
	    var FS = new FileSystem();
	    if (FS.isValidCommonPath(dir) != 1) {
	        alert('[SocialTV] directory is not found : ' + dir);
	        return null;
	    }
	    var FP = FS.openCommonFile(dir + '/' + file, 'r');
	    if (!FP) {
	        alert('[SocialTV] file is not found : ' + file);
	        return null;
	    }
	    var result = FP.readAll();
	    alert('[SocialTV] loaded data : ' + result);
	    FS.closeFile(FP);
	    return result;
	}
}

/*
	Function: initialize
			Setup facebook mini widget and login
*/
SceneSNSList.prototype.initialize = function () {
	alert("MFacebook.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here 
	// scene HTML and CSS will be loaded before this function is called
	var $this = this;
	
//	this.mFacebookList = new VariableLengthList(document.getElementById("MFacebook"));
	this.mFacebookList = new CVLList({
		id : FACEBOOK_ID
		, div : document.getElementById("MFacebook")
		, headerFocus : true
		, width : 285, height : 429
	});
	
	this.mFacebookList.setRenderer(function(pContents){
		var strHTML = "";
		strHTML += "<table>";
		strHTML += "<tr><td = 'width:15px;'></td><td style = 'width:56px;vertical-align:top;'>";
		strHTML += "<div style ='width:56px;height:56px;background-image:url(images/tvchat_photo_bg.png);'>";
		strHTML += "<img src = '" + pContents.profile_pic + "' style = 'position:relative;width:48px;height:48px;left:3px;top:3px'>";
		strHTML += "</div>";
		strHTML += "</td><td style = 'width:200px;vertical-align:top;'>";
		strHTML += "<div class = 'MFacebookWShadow'  style = 'color:#004f8c;'>"+pContents.name+"</div>";
		strHTML += "<div>" +Util.seperateString(pContents.text) + "</div></td></tr></table>";
		if (pContents.photo) {
			strHTML += "<div style = 'position:relative;width:270px;height:72px;text-align:center;'>";
			strHTML += "<table><tr><td style = 'width:83px;height:71px;background-image:url(images/tvchat_facebook_photo_frame.png)'>";
			strHTML += "<img src = '" + pContents.photo + "' style = 'padding:2px;width:78px;height:66px'>";
			if (pContents.type == "video")
				strHTML += "<img src ='images/tvchat_video_play.png' style='position:absolute;left:120px;top:25px;'>";
			strHTML += "</td></tr></table>";
			strHTML += "</div>";
		}
		
		strHTML += "<div class = 'MFacebookWShadow'  style = 'padding-right:11px;text-align:right;color:#002b43;'>"+Util.getFacebookTime(pContents.updated_time)+"</div>";
		strHTML += "<div class = '"+pContents.id+"_Additional' style = 'position:relative;height:22px;width:270px;text-align:right;display:"+(pContents.comments || pContents.likes ? "block" : "none")+"'>";
		if (pContents.likes) {
			strHTML += "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<img src = 'images/tvchat_list_icon05.png'>";
			strHTML += "&nbsp;<span class = 'MFacebookWShadow'   id = '"+pContents.id+"_nLikes' style = 'color:#002b43;'>" + (pContents.likes ? pContents.likes : "") + "</span>";
		}
		if (pContents.comments) {
			strHTML += "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<img src = 'images/tvchat_list_icon04.png'>";
			strHTML += "&nbsp;<span class = 'MFacebookWShadow'   id = '"+pContents.id+"_nComments' style = 'color:#002b43;'>" + (pContents.comments ? pContents.comments : "") + "</span>";
		}
		strHTML += "</div>";
		return strHTML;
	});
	this.mFacebookList.setHeaderRenderer(function(pContents){
		var strHTML = "";
		strHTML += "<table>";
		strHTML += "<tr><td style = 'font-size:15px;width:279px;height:24px;text-align:center;vertical-align:middle;'>";
		strHTML += SID_WHATS_ON_YOUR_MIND;
		strHTML += "</td></tr></table>";
		return strHTML;
	});
	
	// Service Login
	this.FacebookAPI = new FacebookAPI("7fb38f1cda70ca6b11a821e160d0853d","36768bbfd5243d527debf134f6f11630");
	 
	this.innerLoading = new innerLoading({
            id: "MFacebookLoading",
            container: document.getElementById("MFacebookLoading")
			, left : 770
			, top : 230
        });
	this.innerLoading.open();
	
	$this.login();
	
}

SceneSNSList.prototype.handleShow = function () {
	alert("MFacebook.handleShow()");
	// this function will be called when the scene manager show this scene
	this.adaptNavi();
	this.mFacebookList.onShow();
}

SceneSNSList.prototype.handleHide = function () {
	alert("MFacebook.handleHide()");
	// this function will be called when the scene manager hide this scene
	
	this.mFacebookList.blur(this.mFacebookList.getCurRealIdx()+1);
}

SceneSNSList.prototype.handleFocus = function () {
	alert("MFacebook.handleFocus()");
	// this function will be called when the scene manager focus this scene
	
	this.isFocused = true;
	
	// If service is not available, focus to top category	
	if (!TVComm.getAccount(FACEBOOK_ID).id) {
		this.mFacebookList.blur(this.mFacebookList.getCurRealIdx()+1);
		$.sfScene.focus("Home");
		return;
	}
	
	this.onFocus();
	
	this.mFacebookList.focus(this.mFacebookList.getCurRealIdx()+1);
	
	// When return from submenu, restore help navi setting
	this.adaptNavi();
}

SceneSNSList.prototype.handleBlur = function () {
	alert("MFacebook.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
}

/*
 Function: handleKeyDown
 		Key handler
 		
 Parameters:
 		keyCode - Key code
 */
SceneSNSList.prototype.handleKeyDown = function (keyCode) {
	alert("MFacebook.handleKeyDown(" + keyCode + ")");
	var $this = this;
	if (keyCode != $.sfKey.EXIT  && this.innerLoading.isLoading()) return;
	// TODO : write an key event handler when this scene get focued
	if (!Util.commonKeyHandler(keyCode)) return;
	switch (keyCode) {
		case $.sfKey.LEFT:
			$.sfScene.get("Home").prevService();
			break;
		case $.sfKey.RIGHT:
			$.sfScene.get("Home").nextService();
			break;
		case $.sfKey.UP:
			if (this.mFacebookList.getCurRealIdx() > -1) {
				this.mFacebookList.prevItem();
				this.adaptNavi();
			} else {
				// Focus to category for service change
				$.sfScene.focus("Home");
				this.mFacebookList.blur(this.mFacebookList.getCurRealIdx()+1);
				this.isFocused = false;
				//Interactive Remote Start
				this.showServiceInfo();
				//Interactive Remote End
			}
			break;
		case $.sfKey.DOWN:
			if (this.mFacebookList.getCurRealIdx() < (this.mFacebookList.getListLength() - 1)) {
				this.mFacebookList.nextItem();
				this.adaptNavi();
			} else {
				this.refresh(this.DEF.MORE);
			}
			break;
		case $.sfKey.FF:
			this.mFacebookList.nextPage();
			break;
		case $.sfKey.RW:
			this.mFacebookList.prevPage();
			break;
		case $.sfKey.ENTER:
			if (CommonPlugin.isViewerKey($.sfKey.ENTER)) return;
			if ($this.innerLoading.isLoading()) return;
			this.enter();
			break;
		case $.sfKey.RED:
			TVComm.openSSO();
			break;			
		case $.sfKey.GREEN:
			if ($this.isLogin){ 
			this.updateRefreshFlag();
			this.refresh(this.DEF.USER_REFRESH);
			}break;
		case $.sfKey.BLUE:
			TVComm.changeMode();
			break;
		case $.sfKey.YELLOW:
			this.writeComment(this.arrFeedList[this.mFacebookList.getCurRealIdx()].id);
			break;
        case $.sfKey.TOOLS:
			$.sfKey.block();
            this.tools();
			break;
		case $.sfKey.RETURN:
		case SOCIAL_TV_KEY:
			this.returnToCategory();
			//Interactive Remote Start
			this.showServiceInfo();
			//Interactive Remote End
			break;
		case $.sfKey.EXIT:
			$.sfKey.block();
			TVComm.returnEvent();
			break;
	}
}