function CPSearch() {
	var $this = this;
	this.ver = 0.102;
	
	this.cpName = 'Facebook';
	this.libs = [];
	this.icon = 'Resource/images/facebook.png';

	var REQ_STATUS = {
		SUCCESS : 1,
		XHR_ERROR : 10,
		NO_DATA : 11
	}

	var curKeyword = "";
	var resultList = [];
	var XMLHttpRequest = null;
	var reqValidity = false;
	
	/*
     Function: request
     		Interface
     
     Parameters:
     		pkeyword - Key word
     		pStart - Start Index (0-based)
     		pLength - Request data length 
     		pCallback - Callback Function 
     */
	this.request = function (pkeyword, pStart, pLength, pCallback) {
		alert("[Facebook Search] request - " + pkeyword + ", " + pStart + ", " + pLength);
		reqValidity = true;
		if (curKeyword != encodeURIComponent(pkeyword) || pStart == 0) {
			resultList = []; 
			curKeyword = encodeURIComponent(pkeyword);
		}
		if (pStart + pLength < resultList.length - 1) {
			pCallback(makeResult(REQ_STATUS.SUCCESS, pStart, pLength));
			return ;
		}
		XMLHttpRequest = createXHRObject();
		XMLHttpRequest.onreadystatechange = function(){
			if (!reqValidity) return;
			if (XMLHttpRequest.readyState == 4) {
				alert("[Facebook Search]  XMLHttpRequest - " + XMLHttpRequest.responseText);
				var reqStatus = generateList(XMLHttpRequest, pStart, pLength);
				if (reqStatus == REQ_STATUS.SUCCESS) {
					pCallback(makeResult(reqStatus, pStart, pLength));
				} else {
					pCallback(makeResult(reqStatus));
				}
			}
		};
		XMLHttpRequest.open("GET", getQueryURL(pStart, pLength));
		XMLHttpRequest.setRequestHeader("Content-type", "application/x-www-form-urlencoded;charset=utf-8");
		XMLHttpRequest.send();
	}

	this.cancel = function(){
		alert("Facebook cpsearch.js -> Request's canceled");
		reqValidity = false;
		if (XMLHttpRequest && XMLHttpRequest instanceof Function)
			XMLHttpRequest.abort();
	}
	
	function getQueryURL(pStart, pLength) {
		var strURL = "";
		if (resultList.length == 0) {
			strURL = "https://graph.facebook.com/search?q="+curKeyword+"&type=page&fields=id,name,category,likes&limit="+pLength;
		} else {
			strURL = "https://graph.facebook.com/search?q="+curKeyword+"&type=page&fields=id,name,category,likes&offset="+pStart+"&limit="+pLength;
		}
		alert("[Facebook Search] getQueryURL - " + strURL);
		return strURL;
	}
	
	function makeResult(pStatus, pStart, pLength) {
		var objResult = {};
		objResult.cpName = $this.cpName;
		if (pStatus == REQ_STATUS.SUCCESS) {
			objResult.data = resultList.slice(pStart, pStart + pLength);
		} else {
			// Search Failed
			objResult.error = pStatus;
		}
		return objResult;
	}
	
	/*
     Function: generateList
     Parameters:
     Returns:
     */
	function generateList(pXHR, pStart, pLength) {
		if (pXHR.status == 200) {
			var resultJSON = $.parseJSON(pXHR.responseText);
			if (resultJSON.data && resultJSON.data.length > 0) {
				var nLength = resultJSON.data.length;
				alert("[Facebook Search] generateList - " + nLength);
				var tempResult;
				if (nLength > 0) {
					for (var idx = 0; idx < nLength; idx++) {
						tempResult = resultJSON.data[idx];
						var nLikes = parseInt(tempResult.likes);
						// Convert Time String
						resultList[pStart + idx] = {
							field1: {		value: tempResult.name + "(" + 	tempResult.category + ")"},
							field2: { 	value: (nLikes > 0 ? makePuncDigit(nLikes) : 0) + " people like this."}, // JavaScript Time Object
							runInfo: {
								id : tempResult.id,
								name : tempResult.name,
								// FacebookFrame.Define.FAN_PAGE
								type : 3 
								}
						};
					}
				}
			}
			else {
				return REQ_STATUS.NO_DATA;
			}
		} else {
			// XHR status is not 200
			return REQ_STATUS.XHR_ERROR;
		}
		return REQ_STATUS.SUCCESS;
	}
	
    /*
     Function: createXHRObject
     		Create XMLHttpRequest Object
     
     Returns:
     		XMLHttpRequest Object
     */
	function createXHRObject(){
		return new window.XMLHttpRequest;
	}
	
	/*
     Function: createXHRObject
     		Create XMLHttpRequest Object
     
     Returns:
     		XMLHttpRequest Object
     */
    function makePuncDigit(pNum){
        var strNum = "", num = pNum, remainder = 0;
        for (var idx = 0; num > 0; idx++) {
            remainder = num % 10;
            num = Math.floor(num / 10);
            strNum = remainder + strNum + "";
            if (idx % 3 == 2 && num > 0) {
                strNum = "," + strNum;
            }
        }
		return strNum;
    }
}
